                            Release Notes for
			P4, the P4 Command Line Interface,
			P4D, the P4 Server,
			P4P, the P4 Proxy and
			P4Broker, the P4 Broker.

                            Version 2026.1

Introduction

	This document lists all user-visible changes to:
		* P4 Server (P4D)
		* P4 CLI (P4)
		* P4 Proxy (P4P)
		* P4 Broker (P4Broker)
	in the 2026.1 release. Release notes for other Perforce products are 
	at https://www.perforce.com/support/release-notes which includes a link
	to the developer notes for the P4 API for C/C++ at 
	https://www.perforce.com/perforce/doc.current/user/p4devnotes.txt

	Perforce numbers releases YYYY.R/CCCCC, e.g. 2002.1/30547.
	YYYY is the year; R is the release of that year; CCCCC is the
	bugfix change level.  Each bugfix in these release notes is
	marked by its change number.  Any build includes (1) all bugfixes
	of all previous releases and (2) all bugfixes of the current
	release up to the bugfix change level.

	Both 'p4' and 'p4d' will report their version information by
	passing the '-V' flag.  Additionally, 'p4' can report the server's
	information with the 'p4 info' command.  Version information
	includes a release version and a build change number.  The build
	change number can be compared with change numbers and patch
	information mentioned in the matching version release notes
	file to determine if a particular build of a version includes
	the change mentioned.

Supported Platforms for p4d, p4, p4p and p4broker

	Linux kernel 2.6+ (glibc 2.17+) for Intel(x86_64)
	Linux kernel 2.6+ (glibc 2.17+) for ARM(aarch64)
	Windows 11 for Intel(x64)
	Windows 2016 for Intel(x64)
	Windows 2019 for Intel(x64)
	Windows 2022 for Intel(x64)
	Windows 2025 for Intel(x64)
	Apple OS X 10.15+ for Intel(x86_64)
	MacOS 12+ for Apple silicon (arm64)

--------------------------------------------------------------------------

Important Product Rebrand Notice

        Helix Core is now P4
        Perforce has a new look and logo that reflects our place in DevOps
        workflows. As part of these changes, Helix Core is now P4. Name updates
        and new icons to align with the P4 branding will be rolled out soon.
        To learn more, see:
          https://www.perforce.com/blog/vcs/introducing-the-p4-platform

--------------------------------------------------------------------------

Important Platform End-of-Life Notice

	This notice identifies the platforms that will be placed in
	End-of-Life (EOL) status in May 2026. This applies to p4, p4d,
	p4p, and p4broker components of the server release.
	
	The following 64-bit platforms are now in the Discontinued phase:

	Windows 10 for Intel(x64)
	Apple OS X 10.12 for Intel(x86_64)

	OBSOLESCENT Phase:
	Starting with this release, these platforms will no longer be
	supported.  Customers will receive full support and patches
	for the deprecated platforms during this phase for older
	releases. The platforms will remain in this phase until
	November 2026 after which they will transition into the
	discontinued phase.

	DISCONTINUED (EOL) Phase:
	Patches will no longer be issued for these platforms. We will
	no longer provide technical support to customers with servers
	on these platforms

--------------------------------------------------------------------------

Important Changes to P4 Licenses

	P4 licenses have been modified to include an 'ExtraCapabilities' field.
	This field encapsulates details about the license for this server as
	well as additional applications that extend this P4 Server.
	Please note, a comprehensive list of possible values is not provided as
	the list will evolve over time and, as with other fields in the license,
	any modifications to the 'ExtraCapabilities' field will invalidate the
	license.

	This new license format requires an updated version of the P4 Server
	to be able to read and apply this new license. License files that use
	this new field require an updated version of the P4 Server and include
	the following comment specifying the exact versions
	required:

	    # This license works with 2019.2 patch 14, 2020.1 patch 8, 2020.2
	    patch 6, 2021.1 patch 1, 2021.2 or later servers.

--------------------------------------------------------------------------

Important limitation for Windows servers prior to 2021.2

	Support for P4 Extensions was disabled for Windows servers
	prior to 2021.2 due to unrelated performance concerns on that platform
	requiring a conflicting toolchain change.  Extensions remained fully
	supported on Linux and Mac.

	This limitation has been resolved in 2021.2 and extensions are now
	fully supported on all supported platforms.

--------------------------------------------------------------------------

Important security note

	This release links OpenSSL version 3.5.5

--------------------------------------------------------------------------

Important export note

	This product is subject to U.S. export control laws and regulations
	including, but not limited to, the U.S. Export Administration
	Regulations, the International Traffic in Arms Regulation requirements,
	and all applicable end-use, end-user and destination restrictions.
	Licensee shall not permit, directly or indirectly, use of any Perforce
	technology in or by any U.S. embargoed country or otherwise in
	violation of any U.S. export control laws and regulations.

--------------------------------------------------------------------------

Upgrading the Server

	** IMPORTANT UPGRADE NOTES **

	  CHANGES TO DISTRIBUTED UPGRADE RECOMMENDATIONS

	  For 2019.1 or later of the P4 Server (P4D), significant
	  schema upgrades performed by 'p4d -xu' will only be performed on
	  servers where those upgrades are needed. This means that metadata
	  changes made by upgrades must be replicated and so must be journaled.
	  To help prevent mistakes, upgrades will not run if journaling is
	  disabled.  If offline databases are in use, upgrades should not be
	  performed on them, as the upgrade performed on the live database will
	  be journaled and applied during normal journal replay.

	  When upgrading from 2019.1 or later of the P4 Server
	  (P4D), replicas may be upgraded safely prior to the server they are
	  replicating from. This upgrade pattern, referred to as "outside-in",
	  allows a multi-server environment be upgraded server-by-server
	  starting with the outermost replica, without requiring the entire
	  set of servers to be taken offline at once.

	  When upgrading from a version prior to 2019.1 to 2019.1 or later, we
	  strongly recommend that all servers are upgraded in a single upgrade
	  session.

	  More information can be found in the P4 Server Administration
	  Documentation at 
	    https://www.perforce.com/manuals/p4sag/Content/P4SAG/chapter.upgrade.html

	  -------------------------------------------------------------------

	  CHANGES TO UNLICENSED SERVER

	  For v16.1 onwards of the P4 Server (P4D) the number
	  of free users allowed with an unlicensed server has changed to 5,
	  the number of clients remains at 20. Previous versions of the
	  server will continue to support the 20/20 usage allowance.

	  -------------------------------------------------------------------

	  BEFORE UPGRADING

	  To upgrade your P4 Server (P4D), your license file must be 
	  current. Expired licenses do not work with upgraded servers.

	  In addition to your usual checkpointing scheme, always checkpoint
	  your server immediately before undertaking an upgrade.

	  For any P4 Git Connector (formerly Helix4Git) instances that are
	  currently polling repos we recommend upgrading your P4 Git Connector
	  instance before upgrading your P4 Server. Otherwise, any repo
	  polling would cease.

	  Read-only archive directories can interfere with the upgrade process.
	  This may be the case for archive paths migrated from a different
	  version control system, such as CVS, or in cases where 3rd party
	  imported content has been made read only by a system admin.
	  Make sure all such archive paths are writeable before attempting
	  the upgrade.

	  DOWNGRADING A 2026.1 SERVER IS NOT POSSIBLE

	  UPGRADING PROCEDURE IS DIFFERENT DEPENDING ON WHAT YOUR CURRENT
	  PERFORCE VERSION IS:

	           UPDATE DATABASE SCHEMA vs UPDATE DATABASE FORMAT

	  -------------------------------------------------------------------
	  ** UPDATE DATABASE SCHEMA

	  If your current server version is 2013.3 or above, then this upgrade
	  is a UPDATE DATABASE SCHEMA upgrade:

	  Unix Platforms

	    1. Issue the 'p4d -r <server-root> -J <journal-file> -xu'
	       command. This command performs the significant schema
	       upgrades, then exits.

	    2. Restart your server with your site's usual parameters.

	  Windows Platforms

	    1. Issue the 'p4d -r <server-root> -J <journal-file> -xu'
	       command from a command prompt window. This command
	       performs the significant schema upgrades, then exits.

	    2. Restart your P4 Server (P4D) service.


	  Note: Personal DVCS servers will automatically perform any database
	        schema upgrades. Although the upgrade steps described above
	        are unnecessary for these servers, they are safe to run.

	  -------------------------------------------------------------------
	  ** UPDATE DATABASE FORMAT

	  If your current server version is 2013.2 or earlier,
	  then this upgrade is an UPDATE DATABASE FORMAT upgrade:

	  Due to the btree format introduced in 2013.3 this is not an
	  UPDATE DATABASE SCHEMA upgrade. A checkpoint using your old server
	  and then a restore using the 2026.1 server is required before the
	  internal upgrades 'p4d -xu' (if required) can be performed.

	  Note:  If you have made use of the (undocumented) '+T' modifier
	  (storing file content in the tiny.db database) this data is not
	  checkpointed (and therefore not restored). See 'p4 help undoc'
	  for backup/restore procedures for this table.

	  Once the database has been restored with the 2026.1 version,
	  update your database schema:

	  Unix Platforms

	    1. Issue the 'p4d -r <server-root> -J <journal-file> -xu'
	       command. This command performs the schema upgrades, then exits.

	    2. Restart your server with your site's usual parameters.

	  Windows Platforms

	    1. Issue the 'p4d -r <server-root> -J <journal-file> -xu'
	       command from a command prompt window. This command
	       performs the schema upgrades, then exits.

	    2. Restart your P4 Server (P4D) service.


--------------------------------------------------------------------------

Interoperating With Previous Releases

	1. Unless stated otherwise, you can intermix any release of
	   P4 CLI (P4) with any release of the P4 Server (P4D), but any
	   functionality new to this release requires you to upgrade
	   P4 CLI and/or P4 Server. See marks in the notes below.

	   * -- requires new p4 client program
	        including all client applications and derived APIs

	   ** -- requires new p4d server program

	   *** -- requires new p4p proxy program

	   **** -- requires new p4broker broker program

	   Any replica servers must be at least the same release level as the
	   master server and any functionality that requires an upgrade for the
	   master requires an upgrade for the replica. A replica can be running
	   a later release than the master if the master is running at least
	   2019.1. However in this case some new functionality might not be
	   available on the upgraded replica until the master has been upgraded.

	2. Beginning with 99.2, remote depots will interoperate
	   between UNIX and NT.  Beginning with 98.2, remote depots
	   will interoperate across (98.2 and higher) releases.
	   In 98.1 and before, remote depots will only operate with
	   another server of the same release.

	3. As of 2005.1, remote depot support for 98.2 and 99.1 servers
	   has been dropped.  Attempts by 98.2 and 99.1 servers to contact
	   2005.1 servers still works, but the depots will appear devoid
	   of files.

--------------------------------------------------------------------------

Technology Preview features:

	Features offered in Technology Preview are experimental and not
	guaranteed to always work as expected. If you have feedback and
	functionality suggestions, email techpreview@perforce.com.

	The following features are in Technology Preview:

	    P4 Web Server (introduced 2025.2).

	    P4 REST API (introduced 2025.2).

	    P4 Extensions for clients (introduced 2019.1).

	The following features have been promoted from Technology Preview:

	    'p4 diagnostics' command (introduced 2024.2).

--------------------------------------------------------------------------

Important note:

	Please refer to:
	http://www.perforce.com/perforce/r26.1/user/relnotes.txt
	to get up to date GA and post-GA information about this release.

--------------------------------------------------------------------------

Major new functionality in 2026.1 (2026.1/2951233) (2026/05/19)

	#2931239 (Jobs #132785, #125021) **
	    Branch-on-submit feature for sparse streams.

	    Prior to this change, sparse streams used a branch-on-edit
	    methodology to branch files into a sparse stream upon the first
	    edit of a non-resident parent file. The file would be populated
	    directly into the sparse stream, then sync'd and opened in the
	    client workspace.

	    This methodology had a serious defect in that edits of non-resident
	    parent files made a sparse stream less sparse. Once a file was
	    opened and branched, a reversion would not remove the branch in
	    the sparse stream. Since some workflows involve checking out of all
	    files in a stream and then reverting unchanged files, the
	    branch-on-edit methodology was less than ideal.

	    The branch-on-submit feature changes the branching methodology
	    for sparse streams. With this method, an edit of a non-resident
	    parent file branches the file to the sparse stream workspace and
	    reopens the file for add. If the file is submitted, the file is
	    branched into the sparse stream; if the file is reverted, then the
	    sparse stream is not affected, and the sparse stream does not
	    become less sparse.

	    Similarly, with the deletion of a non-resident file, the file is
	    deleted from the workspace and opened for delete. With a moved
	    file, the move-from file is deleted and the move-to file is added.
	    Reverting deleted or moved files will restore the files to their
	    original state.

	    The dm.stream.sparse.branchmax configurable now only applies to
	    'p4 submit' and 'p4 populate'.

	    There is no way to change the branching methodology from
	    branch-on-submit back to branch-on-edit.

Behavior Changes 2026.1 (2026.1/2951233) (2026/05/19)

	#2872424, #2932243 (Jobs #130093, #107092, #130281, #130282, #130283,
	#131203, #132706, #132711) **
	    Secure by default

	    P4 2026.1 introduces a number of security hardening
	    changes that take effect automatically on install/upgrade.
	    The following configurables have new default values:

	        Configurable                Previous default  New default
	        --------------------------- ----------------  -----------
	        security                    0                 4
	        server.rolechecks           0                 1
	        dm.info.hide                0                 1
	        dm.user.hideinvalid         0                 1
	        dm.user.noautocreate        0                 2
	        dm.user.resetpassword       0                 1
	        dm.user.setinitialpasswd    1                 0
	        run.users.authorize         0                 1
	        dm.user.autoprotections     (new)             1
	        rmt.enforce.serviceusertype (new)             1

	    After 'p4d -xu' is run, the security level will be raised to 4 if it
	    was previously set below that value. All other configurables will
	    remain at the value they were previously set to; the change in
	    defaults will apply if they were unset.

	    If the protections table has not been initialized, the first user
	    to run a command will initialize the table (as if they had run
	    'p4 protect'). Whilst not recommended, this behavior can be reverted
	    by disabling the new 'dm.user.autoprotections' configurable and
	    deleting the protections table.

	    Server-to-server calls are now restricted to service users. If a
	    standard user was being used for the purposes of replication, etc,
	    they must be replaced with a service user. This is enforced by the
	    server receiving the connection, when 'rmt.enforce.serviceusertype'
	    is enabled.

	    https://help.perforce.com/helix-core/server-apps/p4sag/current/Content/P4SAG/secure-by-default-overview.html

Minor new functionality in 2026.1 (2026.1/2951233) (2026/05/19)

	#2929942 (Jobs #130079, #131678, #131853) **
	    The REST API GET /file/contents endpoint now supports retrieving
	    multiple files in a single request. Pass an archive parameter
	    together with an array of fileSpec arguments to receive the
	    matched files as an uncompressed tar stream. When archive is
	    specified, fileSpec arguments accept wildcard characters.

	#2918859, #2921815 (Job #130893) **
	    Updated REST API GET /depot JSON response key names. Added
	    additional response key names based on depot type.

	#2914119 (Jobs #130897, #130896) **
	    Updated the REST API responses to include Open Worldwide
	    Application Security Project ( OWASP ) recommended security
	    headers.

	#2912818 (Job #130619) **
	    New configurable ( webserver.log.retain ) added to restrict the
	    number of historic log files for the P4 Web Server.

	#2910334 (Jobs #128416, #130870) **
	    Added ability to start webserver in HTTP (insecure) mode when p4
	    server uses SSL certificate.

	#2910196 (Job #131501) **
	    REST API GET /file/contents now returns correct CONTENT_LENGTH
	    header.

	#2910056 (Job #129601) **
	    New configurable ( webserver.log.path ) added to allow setting the
	    directory that P4 Web Server logs are written.

	#2908010, #2909372 (Job #130889) **
	    Created a new structure for the way changelists are returned from
	    the REST API endpoint 'GET ./api/v0/changelist/<changeNumber>'.
	    Changelists are now returned in a format that is tailored for them
	    and with JSON property names that will not arbitrarily change
	    based on the server configuration.

	#2904410 (Job #130668) **
	    The 'p4 webserver' command now supports the 'show' sub command that
	    lists all the currently running webservers.

	#2903960 (Job #129981) **
	    Added --offset and --size query parameters to REST API GET
	    /file/contents

	#2901451 (Job #130890) **
	    Renamed REST API GET /changelist/#/files to GET
	    /changelist/#/revisions

	#2898782 (Job #130873) **
	    Standardized REST API error formats. Previously errors returned
	    directly from the P4 Web Server code and errors returned from the
	    P4 Server had different formats. They now use the same format.
	    Also, the P4 Server's errors would use numbered properties, now it
	    uses arrays of error objects.

	#2898711 (Job #130887) **
	    The '/v0/file/metadata' rest api entry point now accepts multiple
	    'fileSpec' parameters instead of a comma separated list in the
	    parameter 'fileSpecs'

	#2896710 (Job #129986) **
	    Added new search query parameters to webserver's GET
	    /file/revisions endpoint. These are output=[fileSize|globalLock],
	    search=<searchExpression>, sort=[date|head|fileSize|fileType],
	    order=[asc|desc] and fields=<fieldName,fieldName,fieldName>.

	#2893305 (Job #130888) **
	    Renamed the GET ./api/v0/file/metadata REST API endpoint to GET
	    ./api/v0/file/revisions to better reflect the type of data that
	    was being returned.

	#2875578 (Job #70452) **
	    Prevent filtered forwarding replicas from syncing files that are
	    excluded by their filters, fixed commit server ignoring downstream
	    replica filters when commands are forwarded to it.

	#2848335 (Job #129102) **
	    'p4d -xx' now has a check for removing obliterated files from
	    labels.

Bugs fixed in 2026.1 Patch 1 (2026.1/2972966) (2026/06/10)

	#2970995 (Job #134416) * ** *** ****
	    OpenSSL has been updated to 3.5.7

Bugs fixed in 2026.1 (2026.1/2951233) (2026/05/19)

	#2949664, #2949744 (Job #133510) **
	    Fix crash when web server process when x-correlation-id is an empty
	    value.

	#2945544, #2947432 (Job #131769) **
	    When using the '--streamviews' flag with fstat, dirs, or files with
	    tagged output, an 'isMapped' field is printed if and only if the
	    streamFile is in the client's LimitView.

	#2940109, #2941786 (Job #132666) * **
	    cURL (for extensions) has been upgraded 8.20.0.

	#2936634, #2936739 (Job #133144) **
	    The p4 webserver bundled a version of the `openssl` library that
	    was affected by multiple CVEs, including three rated critical at
	    CVSS 9.8 (CVE-2026-41676, CVE-2026-41678, and CVE-2026-41681). The
	    bundled `openssl` library has been updated to a patched version
	    that resolves these vulnerabilities.

	#2932459 (Job #132412) *
	    The JSON formatted message output from 'p4' with the global '-Mj'
	    flag now includes the severity formatted as text as well as the
	    format string and message code for each line output.

	#2931658 (Job #115867) **
	    With a case-sensitive p4d server if a new revision of a file in the
	    depot is created by just doing a case rename, then syncing back
	    the file to the revision before rename would result the file to be
	    removed from the workspace. This change fixes the problem.

	#2931452 (Job #132128) * ** *** ****
	    The localtime and gmtime system calls are now threadsafe on all
	    platforms.

	#2930720 (Job #131331) **
	    Web server application log entries (webserver.log) that were
	    emitted during HTTP request handling did not include the request's
	    correlation_id, making it impossible to trace warnings or errors
	    back to the originating request in the request log.

	#2930521, #2932243 (Jobs #132711, #107092, #130093, #130281, #130282,
	#130283, #131203, #132706) **
	    Under specific conditions, a 'p4 failover' of an edge server could
	    fail due to lock order errors. This has been fixed.

	#2930356 (Job #130618) **
	    An optimization in 'p4 changes' has been corrected so that it no
	    longer performs worse when a client revision specifier is used.

	#2926608 (Job #103279) **
	    On a Forwarding replica 'p4 reload' was failing with error "This
	    command is only supported in a distributed configuration". With
	    this change it is now forwarded to the upstream server where it is
	    handled as expected.

	#2925574 (Job #132012) **
	    For 'p4 -ztag -u <user> describe -c <change>' when change is
	    restricted and user has no permission on any of the files in the
	    change, we were incorrectly showing the path field. This change
	    fixes the problem.

	#2922508 (Job #132237) **
	    Removed totalFileCount field from GET /file/revisions response
	    using sort and fileSpec parameters.

	#2920981 (Job #132070) **
	    Global access time updates for users on replicas are no longer
	    repeated when a user runs multiple commands in parallel.

	#2920210 (Job #130886) **
	    The P4 REST API now returns all JSON response keys in
	    camelCase format. Previously, some response keys used inconsistent
	    casing; for example, ServerID in the GET /api/v0/server/info
	    response.

	    This job specifically updated the response keys for
	    GET /api/v0/server/info and the following keys were renamed:
	    * ServerID => serverID
	    * lbr.replication => lbrReplication
	    * serverLicense-ip => ServerLicenseIP
	    * tzoffset => tzOffset

	    Note: This is a breaking change for any client code that depends on
	    the previous key names. Applications using the P4 REST API
	    must be updated to use the new camelCase key names.

	#2918769 (Job #131407) **
	    'p4 diagnostics' will no longer generate the monitor file without
	    the 'monitor' configurable being set. Previously the monitor file
	    would be created if rt.monitorfile was set.

	#2918113, #2920602 (Jobs #128716, #132094) **
	    If a submit or sync behind parallel transmit operations is not
	    present, the transmit operations can now self terminate. The
	    configuration net.parallel.checkalive is used for this feature.

	#2917597 (Job #130104) **
	    Replica filters will now prioritize exclusion when both client data
	    and revision data filters are used and the db table that is
	    evaluated checks both filters. This change affects 'db.resolve',
	    'db.resolvex', 'db.resolveg', 'db.have', 'db.working',
	    'db.workingx', and 'db.workingg'.

	#2915932 (Jobs #131144, #131147) *** ****
	    Updating the SSL certificate and privatekey used by either a proxy
	    or broker will now be reloaded without requiring a restart.

	#2915572 (Job #129887) **
	    While p4 submit on an edge in background mode is running, a second
	    submit from another edge could complete successfully when it is
	    expected to fail due to being unable to lock the file(s). This
	    change fixes the problem.

	#2913223 (Job #131746) **
	    Changed 'p4 move' for the case of moving a pending branched file
	    which had been resolved and reopened. Now such file must be
	    submitted before it can be moved or renamed, just like any other
	    type of branched file. This prevents the loss of move information.

	#2911943 (Job #130853) **
	    Server-to-server operations now require a service type user to be
	    used. Previously it was possible to use a standard type user with
	    super permissions to authenticate cross server server commands,
	    but doing so is considered dangerous.

	#2911281 (Job #130877) **
	    The 'p4 attribute -f' command was changed to not create a new
	    traitLot when the trait content is unchanged and the reference
	    count exceeds 1. This caused 'p4 attribute -f' to not allow
	    switching a trait from propagating to non-propagating under these
	    circumstances. Now switching the propagating type can be done by
	    that command even when the trait's content is unchanged.

	#2911276 (Jobs #128381, #128472) **
	    The 'p4 dbstat -s' command now correctly displays the
	    partitioned‑table sizes. Error‑handling has also been refined
	    to prevent the generation of unnecessary log noise.

	#2911097 (Job #127144) **
	    It is now possible to do one step stream update from read-only
	    components and imports to writable in the same change along with
	    updates for files in those imports and components. Please note
	    that you probably still need to follow up this step with another
	    stream update to change back imports and components to read-only
	    and pin them at the desired change.

	#2910616 (Job #128435) **
	    'p4 dbpack' lock management is now improved for the partitioned
	    tables and also the error handling clearly distinguishes among the
	    missing configurables, clients, and tables.

	#2908907 (Job #130898) **
	    For configurable 'db.partition.dropondelete', the help message
	    description is now updated to provide clear and required
	    information.

	#2908891 (Job #130986) **
	    The default value for the configurable 'db.partition.dropondelete'
	    is now set to 1.

	#2908834 (Job #130284) **
	    The restapi webserver process now remains in the monitor table.

	#2908008 (Jobs #130200, #130874) **
	    The response for the REST API request `GET ./file/revisions`
	    (formerly `GET ./file/metadata`) has been changed to return an
	    array of 'otherOpen' rather than a set of numbered properties.

	#2902575 (Job #130789) **
	    A stream change submit from edge server could fail with error:
	    "Operation failed on remote server because of data inconsistency".
	    This change fixes the problem.

	#2899498 (Job #125242) **
	    The 'dm.user.hideinvalid' configurable now hides the "no
	    protections" message that can be raised if a user has absolutely
	    no access regardless of whether the user exists.

	#2899493 (Job #130231) **
	    'p4 reopen' no longer deadlocks with other commands that take
	    client entity locks.

	#2898899 (Jobs #130290, #130289) **
	    'p4 info' and 'p4 license -u' now output high level statistics
	    about the server; this includes a count of files and revisions
	    with the sum of their sizes as well as a count of changes and when
	    the first and last were created. These stats are recalculated in
	    the background once a day. The same stats are reported in
	    cleartext as well as in an encrypted form.

	#2896787 (Job #130584) *
	    Added new client configurable 'P4_SYSTEMIGNORE' to prevent
	    syncing/submitting config files, by default this will block files
	    named '.p4enviro', 'p4enviro.txt', '.p4config', 'p4config.txt' and
	    the paths in 'P4ENVIRO' and 'P4CONFIG'. 'P4_SYSTEMIGNORE' can only
	    be set by environment, P4ENVIRO, or service-specific registry (NT
	    only).

	#2896698 (Job #130970) **
	    Prior to 2025.2, using 'p4 attribute -f' to clear multiple traits
	    when one trait did not exist would cause the command to fail to
	    clear any traits without an error message. This was fixed in
	    2025.2 by causing the command to fail in this scenario with an
	    explicit error. That fix caused 'p4 attribute -f' to fail to clear
	    attributes when any of the traits in the command did not exist in
	    a file in a directory specified in the command. Now this scenario
	    is not treated as an error. Instead, each trait that can be
	    cleared will be cleared and each trait that is not set will report
	    'not set', and the command will continue to process all valid
	    traits without failing.

	#2895971 (Job #130790) **
	    A parallel journal restore no longer opens all the partitioned
	    client database files at the same time.

	#2893698 (Job #131039) **
	    Fixes a crash on 'pull -L' on a standby replica involving
	    concurrent updates to a partition-jnl client table and db.config.

	#2892303 (Job #128965) **
	    The free page management in the in-memory db.monitor table has been
	    improved such that non-fatal 'split now new left' errors will no
	    longer occur on page free and that a much clearer message will be
	    reported should the table fill to the pre-allocated limit.

	#2889898 (Job #130522) **
	    Journal recovery, where journal data includes partitioned tables,
	    could fail with "Locking failure: db.config locked after
	    db.have!". This change fixes the problem.

	#2889791 (Job #131012) **
	    'p4 reload' on an edge server no longer crashes on reloading a
	    non-partitioned client with open files when
	    'server.global.client.views=1' is set.

	#2889673 (Job #130699) **
	    Prevent X.509 "invalid version" for clients doing strict
	    certificate validation.

	#2888786 (Job #127676) **
	    A new `p4d --reset-password user` server command has been added to
	    make it simpler and safer to recover from cases where the super
	    user has become locked out of the server. This requires physical
	    access to the server and replaces a previously documented manual
	    procedure.

	#2888660 (Job #130756) **
	    A checkpoint or dump request no longer opens all the partitioned
	    client database files at the same time.

	#2887955 (Job #130924) **
	    Branch and label specs with double slashes in their names are no
	    longer mistaken for the special case of stashes.

	#2886654 (Job #99476) *
	    On Windows the command line client wild card expansion will not
	    attempt expansions on paths beginning with 2 forward slashes.
	    These are now assumed to be a Perforce client or depot path. Paths
	    beginning with 2 back slashes may potentially be expanded as a UNC
	    path.

	#2877175 (Job #129371) **
	    On Windows, in rare cases, a virus scanner may lock a Perforce
	    Database file causing an error. That error is now properly checked
	    and handled.

	#2877083 (Job #130541) **
	    Parallel submit via an edge server without using the explicit
	    '--parallel' option will no longer report a resource locking
	    error.

	#2876413 (Job #129861) **
	    Implemented additional parameter validation to the REST API's "GET
	    ./api/v0/file/metadata" "fileSpecs" parameter to prevent clients
	    from providing values that were not file specifications.

	#2876275 (Job #130100) **
	    There was a problem that on edge servers real-time update for
	    DataFilter changes were not taking effect. This change fixes the
	    problem.

	#2875493, #2880220 (Jobs #130266, #127264, #128656, #129104, #129173,
	#129291, #129416, #129558, #129711, #129759, #130571) * **
	    Fixed 'invalid cross-device link' errors when multiple 'p4 sync'
	    operations involving delta transfer enabled archives where
	    different volumes are used for P4ROOT and archives.

	#2875393 (Job #130102) **
	    Write the 'skip obliterate have/label' journal note for each batch
	    of deleted rev records in 'p4 admin replica-filter-reconcile'
	    purge operation.

	#2874252 (Job #129974) **
	    The command p4 admin replica-filter-reconcile now gives an error
	    when not issued against a replica.

	#2874127, #2932243 (Jobs #131203, #107092, #130093, #130281, #130282,
	#130283, #132706, #132711) **
	    When 'server.rolechecks' was enabled, 'p4 change' would fail on a
	    chained edge server because the role check was performed before
	    the command was forwarded to the commit server. The command is now
	    forwarded first and the role check is applied on the commit
	    server.

	#2873962 (Job #127830) **
	    When 'dm.info.hide' is enabled, 'p4 info' commands run by
	    non-existent users are now logged correctly.

	#2872180, #2900381 (Job #131392) **
	    Service user authentication errors are now displayed with more
	    context as to which server rejected the command.

	#2870662 (Job #129913) **
	    Prevent crash on 'p4 admin replica-filter-replica' with rpl tracing
	    greater than 1.

	#2870020 (Job #129806) **
	    A 'p4 storage -l //...' request will no longer mark the terminating
	    RCS revision for removal from an imported CVS file.

	#2869630 (Job #41899) **
	    The logic for Startup process termination is changed so that it
	    will not ignore entries after a gap in the sequence number.

	#2867447, #2880220 (Jobs #129711, #127264, #128656, #129104, #129173,
	#129291, #129416, #129558, #129759, #130266, #130571) **
	    When using a client template, comments are propagated in the View
	    and LimitView. If client syntax mappings are specified in
	    ChangeView or LimitView, these are updated to reflect the new
	    client's name.

	#2867237 (Job #128945) **
	    A request to scan the depots using 'p4 storage -l start //...' now
	    includes streams, unload, extension, tangent and spec depots.

	#2864291 (Job #128697) **
	    When opening a file with implicit storage-modifier coming from
	    typemap, it was incorrectly assuming an explicit storage-modifier.
	    This change fixes the problem.

	#2862444 (Job #129719) **
	    Archive pull threads could fail doing delta transfers with "open
	    for read: <archive-File>: No such file or directory". This problem
	    is now fixed.

	#2859939 (Job #129858) * ** *** ****
	    OpenSSL has been updated to 3.5.5

	#2858226 (Job #128901) **
	    'p4 diagnostics' no longer places the checkpoint history into the
	    default 'diags' file. Rather the checkpoint history must now be
	    explicitly requested using the new '-h' option, which will create
	    a 'ckphist' file to contain this data.

	#2857916 (Job #129167) **
	    'p4 storage -d -y -t /movedir' now first attempts to move/rename
	    the deleted non RCS lbr files into 'movedir' rather than use copy
	    followed by delete.

	#2857915 (Job #125162) **
	    The command 'p4 diagnostics' now supports the long options
	    '--diagdir', create a local directory to hold the diagnostic
	    files, '--journal-logs', request the journal and log files,
	    '--ps', request the output from the 'ps' command, '--json',
	    request the data in JSON format and '--top', request the output of
	    the 'top' command.

	#2857767 (Job #129891) **
	    Improved performance of using change numbers in revision specifiers
	    with fstat when combined with the "-e" or "-c" parameter. This
	    also improved the performance of the REST API "GET
	    ./v0/changelist/{changeNum}/files" endpoint.

	#2857489, #2870606, #2871239, #2872667, #2876767, #2880220 (Jobs
	#129173, #127264, #128656, #129104, #129291, #129416, #129558, #129711,
	#129759, #130266, #130295, #130571) **
	    In journal replay where the journal includes a note 31 for deleting
	    a partitioned table, it no longer fails with the error: "dbdel" or
	    "dbput" and "db.have:no write lock!".

	#2853916 (Job #129293) **
	    In replication if it fails to do Delta-transfer, it can now
	    successfully fall back to complete-file-transfer.

	#2852939 (Job #129750) **
	    Fixed server crash when combining custom extension config fields
	    and running p4d -xf.

	#2851368 (Job #129553) **
	    The lock tracking information now correctly updates the held time
	    for all active server locks.

	#2850381 (Job #112113) **
	    Shelves belonging to clients that no longer exist are now treated
	    as if they are owned by the commit server. If deleting a client
	    from an edge server, shelves are now promoted as part of that
	    client delete.

	#2848833 (Job #129085) **
	    'p4 obliterate' now defaults to skipping have and label records
	    (this is equivalent to specifying '-h' and '-l'). To explicitly
	    remove have and label records during an obliterate, the '-H' and
	    '-L' flags can be used. It's also possible to revert to the prior
	    defaults by setting 'dm.obliterate.skiphave=0' and
	    'dm.obliterate.skiplabel=0'.

	#2848828, #2869137, #2870857, #2880220 (Jobs #129416, #127264, #128656,
	#129104, #129173, #129291, #129558, #129711, #129759, #130266, #130571)
	**
	    Replication of filtered out records no longer cause replicas to
	    wait for those transactions to complete.

	#2848656 (Job #129290) ** *** ****
	    Self-signed certificates created with the `-Gc` option on p4d, p4p
	    or p4broker are now signed with a SHA256 hash.

	#2848249 (Job #129432) **
	    'p4 prune' now skips the label scan on the commit server and
	    downstream edge servers.

	#2847048 (Job #128937) **
	    Forwarding replicas now log forwarded commands and monitoring data
	    in the local logfile.

	#2846308 (Job #128028) **
	    If an edge server cannot rename the archive of a shelved file
	    during promote, it now returns a clear error rather than enter a
	    loop.

	#2845020 (Job #129397) **
	    Resolving a moved file with accept theirs (accept the move) when
	    the file has been moved to a path not mapped by the client no
	    longer reports superfluous database warnings.

	#2842696 (Job #129256) **
	    For edge servers SyncTime on submit is now populated.

--------------------------------------------------------------------------

Major new functionality in 2025.2 (2025.2/2852709) (2025/11/13)

	#2843340 (Jobs #129400, #128104) **
	    This release introduces the initial version of the P4 REST API
	    hosted on the built-in P4 Web Server.

	    This initial version of the REST API is limited in scope and is
	    being released as a tech preview feature. This is because we
	    want to get feedback from our users on the functionality and
	    behavior they want in a REST API. While we want our customers
	    to try out this feature, note that we do expect this API to change
	    as we incorporate feedback and work towards a stable release.

	    The initial REST API endpoints include:
	    - GET /api/version
	    - GET /api/v0/server/info
	    - GET /api/v0/depot
	    - GET /api/v0/file/metadata
	    - GET /api/v0/file/contents
	    - GET /api/v0/changelist/{changelistNumber}
	    - GET /api/v0/changelist/{changelistNumber}/files

	#2808880 (Job #127920) **
	    The client spec has a new 'LimitView' field which restricts the
	    client's 'View' to specific paths specified in either client or
	    depot syntax. This is particularly useful for streams clients
	    where the 'View' is generated by the stream. Although virtual
	    streams allow for the same narrowing of the 'View', it is not
	    always practical to create a virtual stream for every permutation
	    of stream path subsets a project may need.

	#2785894, #2824258 (Jobs #125830, #88499) **
	    The new command 'p4 admin replica-filter-reconcile' has been added
	    to delete database records that are excluded by changes to replica
	    filters and to acquire records that were previously excluded from
	    the upstream server. There is no longer any need to reseed a replica
	    from checkpoint when the replica filters are changed.

	    The 'rpl.filter.restrict.batch' and 'rpl.filter.restrict.threads'
	    configurables can be set to change the number of records to be
	    batched for delete and the number of tables to process in parallel;
	    the default values are batches of 1000 deletes and 6 threads.

	    The 'rpl.filter.expand.batch' and 'rpl.filter.expand.threads'
	    configurables can be set to change the block size of records
	    compared with the upstream server and the number of tables to
	    process in parallel; the default values are blocks of 1000 records
	    and 6 threads.

	    This command is launched automatically by the replication process
	    when a filter change is detected. This can be disabled by setting
	    'rpl.filter.restrict' and 'rpl.filter.expand' to 0.

	#2758979 (Jobs #129398, #124307) **
	    There is a new P4 command, 'webserver { start | stop }' which can
	    be used to start and stop the P4 Web Server. The web server hosts
	    the P4 REST API which is a new technical preview feature for this
	    release. The 'p4 webserver start' command can be run from the
	    command line or added as a server startup command.

Behavior Changes 2025.2 (2025.2/2852709) (2025/11/13)

	#2809202 (Job #127152) **
	    The 'p4 attribute -f' command would silently fail to clear
	    any attributes in its list if one of the attributes did not exist.
	    The informational message would also report a misleading
	    'not set' message for each item in the list. Now the command
	    will report an error if an attribute does not exist, showing
	    clearly that the command has failed and no attributes have
	    been cleared.

	#2801196 (Job #127416) **
	    When extension configurations fail validation before being saved,
	    they now return an error instead of a warning.

	#2767760, #2832628 (Job #125126) **
	    The output of 'p4 storage -s' has been simplified to display the
	    reference and revision counts for each storage record. If an error
	    is encountered, the number of active records in each rev table is
	    displayed along with the total reference counts from the
	    'db.storage' and 'db.storagesh' tables.

	#2747073 (Job #101072) **
	    The default value for db.monitor.shared has been increased from 256
	    to 1024 8K pages (8MB of memory reserved). This does not impact
	    servers where the db.monitor.shared configurable has been set.

Minor new functionality in 2025.2 (2025.2/2852709) (2025/11/13)

	#2827503 (Job #127536) **
	    Added 'p4d -xf disable.extension' command line option to disable an
	    extension with a given UUID.

	#2827502 (Job #127739) **
	    Extension manifests have a new field 'require_user' which
	    determines whether the 'ExtP4USER' field in global or instance
	    extension configurations is required or optional.

	#2826295 (Job #117897) **
	    A 'p4 fetch' run from a local unicode mode server to a remote
	    nonunicode mode server is now supported. The translation into
	    UTF-8 is performed by the local machine by using the new
	    'RemoteCharset' value in the remote specification for the remote
	    server. If the 'RemoteCharset' field is set to 'utf8', then no
	    translation is performed but instead checked to make sure there
	    are no invalid UTF-8 sequences. Any translation errors will fail
	    the fetch.

	#2824600, #2825522, #2826445 (Job #125232) **
	    Changes to 'startup.N' configurables are detected and the relevant
	    startup commands are automatically restarted when both
	    configurables 'server.startup.autorestart' and 'monitor' are
	    enabled.

	#2820161 (Job #122971) **
	    Improved messaging when opening a file. Instead of: "<depotFile> -
	    can't add exclusive file already opened", the message includes the
	    action the other client did that locked the file. For example,
	    "<depotFile> - can't add exclusive file already opened for add".

	#2818595 (Job #113094) **
	    Updates to SSL certificates are now picked up automatically. The
	    modtime of the certificate.txt or privatekey.txt must be increased
	    to trigger the reload.

	#2818554 (Job #124619) **
	    The 'dm.topology.lastseenupdate' configurable can now be set to
	    zero (0) to disable topology collection.

	#2811718 (Job #127351) **
	    The copy, merge, and integration commands for sparse stream targets
	    do an autosync at the end of the command. This behavior can now be
	    disabled with the virtual integration flag '-v', which prevents
	    branched and deleted files from affecting the workspace.

	#2792903 (Job #108873) **
	    A new 'limit_instance' field has been added to the extension
	    manifest file to limit the number of instance configurations for
	    an extension. This may be set to either 'multiple' or 'single'.

	#2768654 (Job #122776) **
	    The 'p4 storage -U' command now updates any unset serverSize fields
	    in the storage tables along with unset digests. To force the
	    setting of the serverSize field for RCS based revisions, the new
	    '--server-size-rcs' option must be specified.

	#2766666, #2808791 (Job #127673) **
	    Users of type 'service' now have unlimited timeout tickets by
	    default; this means that an unlimited ticket timeout group is no
	    longer required to prevent replicas from being logged out after
	    the prior default of 12 hours. If a service user is a member of
	    one or more groups, the highest set 'Timeout' value will still
	    apply as before.

	#2761073, #2834961 (Job #61562) **
	    The new configurable 'lbr.unloaddepot.compress' can be set to '1'
	    to compress all data unloaded with the 'p4 unload' command and
	    labels created with the autoreload option.

Bugs fixed in 2025.2 Patch 2 (2025.2/2907753) (2026/03/09)

	#2905017 (Job #129719) **
	    Archive pull threads could fail doing delta transfers with "open
	    for read: <archive-File>: No such file or directory". This problem
	    is now fixed.

	#2903635, #2899493 (Job #130231) **
	    'p4 reopen' no longer deadlocks with other commands that take
	    client entity locks.

	#2903592, #2902575 (Job #130789) **
	    A stream change submit from edge server could fail with error:
	    "Operation failed on remote server because of data inconsistency".
	    This change fixes the problem.

	#2902340, #2893698 (Jobs #131039, #131153) **
	    Fixes a crash on 'pull -L' on a standby replica involving
	    concurrent updates to a partition-jnl client table and db.config.

	#2902070, #2896787 (Job #130584) *
	    Added new client configurable 'P4_SYSTEMIGNORE' to prevent
	    syncing/submitting config files, by default this will block files
	    named '.p4enviro', 'p4enviro.txt', '.p4config', 'p4config.txt' and
	    the paths in 'P4ENVIRO' and 'P4CONFIG'. 'P4_SYSTEMIGNORE' can only
	    be set by environment, P4ENVIRO, or service-specific registry (NT
	    only).

	#2901623, #2896698 (Job #130970) **
	    Prior to 2025.2, using 'p4 attribute -f' to clear multiple traits
	    when one trait did not exist would cause the command to fail to
	    clear any traits without an error message. This was fixed in
	    2025.2 by causing the command to fail in this scenario with an
	    explicit error. That fix caused 'p4 attribute -f' to fail to clear
	    attributes when any of the traits in the command did not exist in
	    a file in a directory specified in the command. Now this scenario
	    is not treated as an error. Instead, each trait that can be
	    cleared will be cleared and each trait that is not set will report
	    'not set', and the command will continue to process all valid
	    traits without failing.

	#2897908, #2889898 (Job #130522) **
	    Journal recovery, where journal data includes partitioned tables,
	    could fail with "Locking failure: db.config locked after
	    db.have!". This change fixes the problem.

	#2891784, #2889791 (Job #131012) **
	    'p4 reload' on an edge server no longer crashes on reloading a
	    non-partitioned client with open files when
	    'server.global.client.views=1' is set.

	#2890316 (Job #130907) * ** *** ****
	    OpenSSL has been upgraded to 3.0.19

	#2890128 (Job #129891) **
	    Improved performance of using change numbers in revision specifiers
	    with fstat when combined with the "-e" or "-c" parameter. This
	    also improved the performance of the REST API "GET
	    ./v0/changelist/{changeNum}/files" endpoint.

Bugs fixed in 2025.2 Patch 1 (2025.2/2882317) (2026/01/27)

	#2881098, #2877083 (Job #130541) **
	    Parallel submit via an edge server without using the explicit
	    '--parallel' option will no longer report a resource locking
	    error.

	#2880138 (Job #129085) **
	    'p4 obliterate' now defaults to skipping have and label records
	    (this is equivalent to specifying '-h' and '-l'). To explicitly
	    remove have and label records during an obliterate, the '-H' and
	    '-L' flags can be used. It's also possible to revert to the prior
	    defaults by setting 'dm.obliterate.skiphave=0' and
	    'dm.obliterate.skiplabel=0'.

	#2878251, #2877175 (Job #129371) **
	    On Windows, in rare cases, a virus scanner may lock a Perforce
	    Database file causing an error. That error is now properly checked
	    and handled.

	#2878161, #2875493 (Jobs #130266, #130571) * **
	    Fixed 'invalid cross-device link' errors when multiple 'p4 sync'
	    operations involving delta transfer enabled archives where
	    different volumes are used for P4ROOT and archives.

	#2877728, #2876275 (Job #130100) **
	    There was a problem that on edge servers real-time update for
	    DataFilter changes were not taking effect. This change fixes the
	    problem.

	#2876767, #2857489, #2870606, #2871239, #2872667 (Jobs #129173,
	#130295) **
	    In journal replay where the journal includes a note 31 for deleting
	    a partitioned table, it no longer fails with the error: "dbdel" or
	    "dbput" and "db.have:no write lock!".

	#2870857, #2866301, #2869137 (Job #129416) **
	    Replication of filtered out records no longer cause replicas to
	    wait for those transactions to complete.

	#2870850 (Job #112113) **
	    Shelves belonging to clients that no longer exist are now treated
	    as if they are owned by the commit server. If deleting a client
	    from an edge server, shelves are now promoted as part of that
	    client delete.

	#2868456 (Job #128028) **
	    If an edge server cannot rename the archive of a shelved file
	    during promote, it now returns a clear error rather than enter a
	    loop.

	#2868019, #2853916 (Job #129293) **
	    In replication if it fails to do Delta-transfer, it can now
	    successfully fall back to complete-file-transfer.

	#2867447 (Job #129711) **
	    When using a client template, comments are propagated in the View
	    and LimitView. If client syntax mappings are specified in
	    ChangeView or LimitView, these are updated to reflect the new
	    client's name.

	#2864292 (Job #129290) ** *** ****
	    Self-signed certificates created with the `-Gc` option on p4d, p4p
	    or p4broker are now signed with a SHA256 hash.

Bugs fixed in 2025.2 (2025.2/2852709) (2025/11/13)

	#2837121 (Job #128588) **
	    The p4d commands 'p4d -xv', 'p4d -xvU', 'p4d -xr', 'p4d -xrU' and
	    'p4 dbverify' have been updated to improve handling of partitioned
	    have tables.
	    When processing all tables (no arguments), these commands no
	    longer process the per-client tables for readonly or partitioned
	    type clients. The per-client tables for partitioned-jnl type
	    clients will be processed only if the 'db.partition.verify'
	    configurable is set to '1'.
	    When partitioned tables are explicitly specified (for example:
	    'p4d -xv db.have.pt' or 'p4d -xr db.have.pt%pclient'), all
	    per-client tables will be processed regardless of client type.
	    These commands no longer create empty tables if a per-client table
	    does not exist.

	#2835292 (Job #128850) **
	    Synctime updates made by 'p4 reconcile' are now written to the
	    database in batches for smoother replication.

	#2835080 (Job #127882) **
	    Permission errors no longer occur when a delta transfer map file
	    was deleted and later simultaneous syncs were issued for the
	    corresponding file revision.

	#2832943 (Job #128946) * **
	    cURL (for extensions) has been upgraded 8.16.0.

	#2832558 (Job #127302) **
	    A non-unicode configured server now translates all paths from
	    ISO8859_1 into UTF8 in its S3 requests.

	#2832305 (Job #127911) **
	    Replicas of type 'build-server' now use per-client partitioned have
	    tables for clients of types 'read-only', 'partitioned' and
	    'partitioned-jnl' instead of the replica specific db.have.rp
	    alternative have table.

	#2832157 (Job #128842) **
	    'p4 describe -a -S' now correctly shows the diff for files open for
	    add in the shelf.

	#2829337 (Job #128614) **
	    Fixed an issue where inconsistent topology records could cause 'p4
	    diagnostics' to loop while holding locks on db.monitor and
	    db.config.

	#2829299 (Job #128849) **
	    'p4 journaldbchecksums -u', 'p4 journaldbchecksums -s', 'p4
	    dbstat', 'p4 dbpack' and 'p4d -jc' no longer try to access
	    partitioned tables that are not expected to be present on the
	    server.

	#2828453 (Job #105807) **
	    The edge server log no longer shows the "Operation 'dmr-Sequence'
	    failed" error when an edge-submit fails after a shelved change is
	    created.

	#2827789 (Job #125371) **
	    'p4 istat' no longer takes read locks when 'db.peeking' is set to 1
	    or greater.

	#2826356 (Job #128816) **
	    Writes to partitioned have tables can no longer append journal
	    records to the end of a rotated journal.

	#2825144 (Job #128688) **
	    The command 'p4 undo' now works with the partitioned and
	    partitioned-jnl client types.

	#2824339 (Job #123439) **
	    'p4 reopen' now writes to the database in batches to improve the
	    performance of downstream replication. The batch size is
	    controlled by the new 'dm.reopen.batch' configurable.

	#2823797 (Job #112076) **
	    The default values of 'dm.flushtry' and 'dm.flushforce' have been
	    increased from 100 to 10000 and 10000 to 100000 respectively. This
	    reduces the number of times tables are locked to write batched
	    records, which is especially impactful on downstream replicas.

	#2823741 (Job #125149) **
	    Integrations into sparse streams now take much less time.

	#2823492, #2830260 (Job #125630) **
	    Replication will no longer halt in the case where a partition have
	    delete journal note (31) and a change or block checksum note (15
	    or 17) are encapsulated by a longer running transaction.

	#2822606 (Job #128566) **
	    The order of precedence for properties returned by 'p4 property -l'
	    is now sequence (highest first), user, group (earliest
	    alphabetically) and then global. Previously a global scoped
	    property would have taken precedence over any user or group scoped
	    properties with the same sequence number. As before, the sequence
	    number can be used to explicitly control the order.

	#2821377 (Job #126106) **
	    Fixed binary+l file mistakenly registered as an orphaned locked
	    file after a copy from a sparse stream, where the file was not
	    resident in the sparse stream.

	#2820220 (Job #126349) **
	    When 'server.rolechecks' is set to 1, servers without the rmt-auth
	    role will no longer accept commands forwarded from remote servers
	    if they were forwarded due to P4AUTH being configured on the
	    remote server.

	#2817781 (Job #127084) **
	    Improved performance of 'p4 shelve' for a change on keyed files
	    that has an action of branch or integ.

	#2817398 (Job #88586) *
	    If a Control-C was issued to P4 during a sync operation, the client
	    could end up inconsistent with the Server. This has been
	    corrected.

	#2815636 (Job #85540) **
	    Unicode enabled servers can no longer cause invalid UTF8 sequences
	    by truncating description text between multi-byte boundaries.

	#2808500 (Job #127858) **
	    Two new configurables control the multipart protocol used in S3
	    transfers. Only transfers greater than the value in
	    'lbr.s3.multipart' will use the multipart protocol. This value is
	    specified in megabytes, the default is 4096. 'lbr.s3.multipartsz'
	    specifies the largest size of an individual multipart transfer
	    request. This value is specified in megabytes, the default is 5.

	#2808454 (Jobs #125669, #128002, #128003) **
	    Reloading a partitioned client on an edge server with
	    'server.global.client.views=1' set will now correctly restore the
	    client's have records.

	#2808454 (Jobs #128002, #125669, #128003) **
	    Reloading a stream client on an edge server with
	    'server.global.client.views=1' set will no longer send the
	    generated 'View' or 'ChangeView' to the commit server.

	#2808454 (Jobs #128003, #125669, #128002) **
	    Reloading a client with a 'ChangeView' on an edge server with
	    'server.global.client.views=1' set will now correctly send both
	    the 'View' and 'ChangeView' to the commit server.

	#2808010 (Job #127686) **
	    In 'p4 verify' the feature to do rdb.lbr cleanup was causing
	    performance issues. This change removes that feature. For rdb.lbr
	    cleanup when files are already in place, please look into using
	    'p4 pull -R'.

	#2807748 (Job #126265) **
	    When a 'p4 attribute -f' command would result in identical trait
	    content and the traitLot reference count is greater than 1, the
	    identical content would be copied to a new traitLot. This could
	    cause unnecessary resolves in later 'p4 copy' operations. This
	    attribute command scenario has been changed to not create
	    the redundant new traitLot and content when the trait content is
	    unchanged.

	#2807148 (Job #122815) **
	    The formatted ISO8601 date in the structured logs is now correctly
	    converted to UTC.

	#2805269 (Job #127573) * **
	    A performance issue when reading RCS file content for commands that
	    compare revision content has been fixed.

	#2804607 (Job #127760) **
	    Fixed 'invalid out-of-bounds conversion of DmtStreamPathType'
	    error.

	#2804323 (Job #124713) **
	    'p4d -xvU' and 'p4 dbverify -U' no longer process partitioned have
	    tables when the 'db.partition.verify' configurable is set to '0'.

	#2804114 (Job #127726) **
	    Fixed crash with replication delta transfer when debug logging was
	    enabled.

	#2799909 (Job #127315) **
	    The P4Lua autoconnect() method exposed in server-side extensions
	    now uses the server's listening P4PORT to resolve the client
	    P4PORT so that tickets are always issued for the correct
	    networking interface.

	#2799787 (Jobs #127051, #127074) **
	    The orphan scanner, 'p4 storage -l start', no longer assumes that
	    RCS files start with "1.".

	#2799787 (Jobs #127074, #127051) **
	    The orphan scanner, 'p4 storage -l start', is now able to process
	    directory names that contain revision (#) and changelist (@)
	    markers.

	#2799786 (Job #126882) **
	    All S3 operations can now be retried, not just upload requests. Two
	    new configurables, 's3.credentialerror.retry' and
	    's3.error.retry', allow the customization of which errors can be
	    retried. The 's3.credentialerror.retry' configurable reloads the
	    credentials on each retry attempt.

	#2798444, #2804550 (Job #127550) **
	    The server will now only try to delete the db.sendq.pt table for
	    any given client after all parallel sync/submit/shelve/unshelve
	    commands that affect that client have completed.

	#2797908 (Job #127414) **
	    Archives in the unload depot are now written to temp files before
	    being moved to their final location on success like archives in
	    other depots.

	#2795402, #2795405 (Job #127413) **
	    Fixed a client version compatibility issue in 'p4 add' that could
	    result in a false insufficient disk space error on submit

	#2795330 (Job #127529) * **
	    JSON for Modern C++ has been updated to 3.12.0

	#2795308 (Job #126938) **
	    'p4 login' will now return a distinct error when
	    'dm.user.setinitialpasswd' is disabled and the user has no
	    password set, informing the user that a super user must set their
	    initial password.

	#2794241, #2799220 (Jobs #127507, #126292, #127579) **
	    Delta transfer no longer reports an error when 'server.depot.root'
	    ends with a '/'.

	#2793768 (Job #127029) **
	    The journal note written by 'p4 obliterate' with the -h and/or -l
	    flags is now correctly re-written to the journal when replayed or
	    replicated.

	#2793233 (Job #126602) **
	    If replication is stalled or it is slow, the edge server could send
	    a change-update up to its target server based on an outdated
	    record, and cause data inconsistency. This change prevents such a
	    change-update and returns this message: "Operation failed on
	    remote server because of data inconsistency, possibly due to
	    stalled or slow replication".

	#2792404 (Job #127436) **
	    'p4 copy' will now ignore files that only differ by attributes when
	    the 'dm.copy.attributes' configurable is set to 0.

	#2792087 (Job #127398) **
	    The stream spec permission checking is no longer applied to submits
	    to streams that do not include a change to the stream spec.

	#2791646 (Job #127310) **
	    Edge servers no longer try to delete db.have.pt tables for clients
	    not associated with that edge server and no longer propagate that
	    journal note to downstream servers.

	#2791095 (Job #125480) **
	    A recommended value of a relative path to the server's root
	    directory has been added to the help message of the
	    client.readonly.dir configurable.

	#2790241 (Job #99980) *
	    Tickets specified with 'p4 -P' or P4PASSWD are now handled
	    correctly during parallel operations.

	#2790232 (Job #127027) **
	    Edge servers processing obliterates from the upstream server no
	    longer perform full scans of the db.working table.

	#2789624 (Job #125649) **
	    Operations like 'p4d -c <command>' that lock all tables now wait
	    for any simultaneous work on partitioned tables to finish before
	    proceeding.

	#2787818 (Job #118452) **
	    Forwarding replicas of edge servers now correctly handle shelves
	    that are not managed by the first upstream edge server.

	#2787728 (Job #127264) **
	    The storage record refcount of revisions with a filetype of +Sx in
	    a task stream are now correctly decremented and the archive is
	    removed when no longer referenced.

	#2787215 (Job #127308) **
	    The modtime of binary files with either the +m modifier or with the
	    modtime option enabled in the client are now correctly passed to
	    altsync agents.

	#2785826 (Job #127243) *
	    Improved error handling when unable to open file during reconcile.

	#2782186 (Job #126984) **
	    Replication Delta Transfer temporary files which were not removed
	    under some circumstances are now removed.

	#2778273 (Job #114608) **
	    Extension instance configurations can no longer use the same name
	    as the extension itself.

	#2777466 (Job #126880) **
	    S3 uploads to AWS no longer fail with files greater than 4Gb in
	    size.

	#2776804 (Job #126852) **
	    TinyXML2 has been upgraded to 11.0.0

	#2775291 (Job #126354) **
	    The server type in the topology table is now correctly recorded as
	    'commit-server' after upgrade instead of a list of roles.

	#2773409 (Job #126534) **
	    Fixed the following issue: When doing parallel recovery using
	    multifile checkpoint and the source includes a partitioned client,
	    if the partitioned client-name ends in an underscore followed by
	    eight digits, valid for a multifile checkpoint file sequence
	    number, recovery could fail with an error like
	    "..._00000001.ckp.gz: No such file or directory".

	#2772883, #2791743 (Job #123929) **
	    Fixed istat crash due to inconsistencies in stream spec data
	    originating from pre-19.1 servers. Run 'p4d -xf 123929' to fix
	    inconsistent data.

	#2771409 (Job #123558) **
	    'p4 diagnostics' now produces a new 'info' file by default
	    containing the tagged output from 'p4 info' and 'p4 servers -J'
	    along with all the non-default configurable settings.

	#2768501, #2787777 (Job #126773) **
	    The sync operation no longer causes the database open error to
	    occur on the db.sendq.pt database table when the frequency of
	    syncs is high.

	#2767902 (Job #123209) **
	    Topology updates from replicas now release locks earlier and no
	    longer wait for replication to synchronize.

	#2766621 (Job #123091) **
	    On a case-insensitive server with server.depot.root set, files with
	    names containing an uppercase character no longer fail to be
	    uploaded to an S3 bucket.

	#2766591 (Job #126570) **
	    Upgrading a version 1 record of a db.change table no longer fails
	    to initialize the new fields, which was causing an 'High order bit
	    set in a IntV field error' on recovery.

	#2766264 (Job #125471) **
	    Fixed an intermittent 'no write lock' error with journal replay
	    into an offline db when the location of the client.readonly.dir is
	    shared between the p4d server and the offline db.

	#2764800 (Job #126179) **
	    The compare routine for the lbrRev type used in the storage tables
	    no longer ignores the first "1." part of the field. This was
	    causing problems for imported CVS files.

	#2763565, #2822608 (Job #128567) **
	    Server startup commands are now logged as running as "background"
	    rather than "remote" if no serviceUser has been set. This change
	    only affects the user recorded in the logs and not the operation
	    of any background commands.

	#2763193 (Job #125360) **
	    The code that loads/sets configurable variables will parse the
	    input on commas to allow the setting of multiple variables with a
	    single command. This processing can cause problems with string
	    tunables that use a comma. This fix checks the type of the first
	    configurable specified and if it is a 'string' type no parsing is
	    performed on the input.

	#2759828 (Job #126261) *
	    The failure of a merge tool is now handled consistently across
	    platforms, and no longer results in a false merge.

	#2758830 (Job #124125) **
	    p4d -xv will now skip the partitioned client database tables that
	    are not on the server instead of reporting the 'table not known'
	    error.

	#2756918 (Jobs #126183, #126084) * **
	    Fixed an issue where the 'p4 reconcile' command would match
	    multiple deletes to the same add when the files have identical
	    content. This was causing a subsequent submit of the incorrectly
	    moved files to fail with missing resolve records.

	#2756537, #2781936, #2781938, #2793291 (Jobs #126141, #127054, #127223)
	**
	    The move detection feature in 'p4 reconcile', 'p4 status' and 'p4
	    move' now works as expected with pre-2025.1 clients.

	#2755654 (Jobs #110808, #121743, #123079) ** *** ****
	    The server no longer sends multiple duplicate certificates from a
	    certificate chain to the client after a 'p4 admin restart'.

	#2755654 (Jobs #121743, #110808, #123079) **
	    After restart or failover, the server now reloads relevant
	    network-related configurables and reloads certificates from the
	    certificate file, which prevents a SSL handshake error after
	    failover when the certificate file has been modified. The
	    certificate file is now checked for out-of-order certificates and
	    logs a message ("NetSslEndPoint::Listen() - invalid certificate
	    chain") if any are found, but does not produce an error because
	    these issues often do not cause problems.

	#2749653 (Job #125760) **
	    'p4 configure show' now displays all the string-based tunables.

	#2746192 (Job #125639) **
	    The journal note type 31 now deletes the respective partitioned-jnl
	    table during the journal replay operation.

	#2745433 (Job #122235) **
	    The syncTime field in the db.have table no longer uses '0' as the
	    unset indicator, avoiding 'High order bit set in IntV database
	    field' errors.

--------------------------------------------------------------------------

Major new functionality in 2025.1 (2025.1/2761706) (2025/05/09)

	#2738086, #2746310 (Jobs #27609, #95793, #113569) **
	    An IdleTimeout can now be set on a per-group basis to invalidate a
	    user's ticket after a specified period of inactivity. Users who
	    have an IdleTimeout applied to them will have their access time
	    updated periodically during and at the end of commands (in
	    addition to at command start) based on the thresholds defined by
	    'dm.user.accessupdate' and 'dm.user.accessforce'; the idle timeout
	    for a user will always be the highest of either of these
	    configurables if the IdleTimeout specified in the group is lower.

	#2727284, #2728738, #2738456 (Job #123527) **
	    Replication now uses Delta Transfer by default. When an archive
	    pull thread ('p4 pull -u') requests a file revision from an
	    upstream server, the replica asks for the file to be sent via
	    delta transfer if certain requirements are met: if there is one
	    other file revision on the replica, the file is an uncompressed
	    binary file (binary+F), the file size is greater than
	    'net.delta.rpl.minsize', and 'net.delta.rpl.threshold' is not 0.
	    Upon receiving a delta transfer request, the upstream server makes
	    the same checks on the file revision. In addition, it checks to
	    see if the number of deltas to send is below the
	    'net.delta.rpl.threshold' for that server. If these requirements
	    are met, then the file revision is sent via delta transfer;
	    otherwise, the full file transfer occurs. Note that if either
	    'net.delta.rpl.minsize' or 'net.delta.rpl.threshold' are 0, then
	    delta transfer is disabled. The upstream server uses its own
	    version of 'net.delta.rpl.threshold' to determine the threshold.
	    Replication delta transfer is available for all replica types, but
	    only for 'lbr.replication' values 'readonly' and 'cached'. If the
	    'p4 pull -u' archive pull thread uses the '--batch' or '--trigger'
	    parameters, delta transfer is not used.

	#2683248 (Job #123442) **
	    Passwords stored by P4 are now hashed with scrypt.

	    For users with passwords stored with the stronger hashing algorithm,
	    plaintext and prehashed passwords will no longer be accepted via the
	    '-P' global flag, the P4PASSWD environment variable or setters in
	    the P4API; these were previously only accepted up to security
	    level 2.

	    Users with passwords stored prior to upgrading to 2025.1 or above
	    will be unaffected: the legacy password storage and behaviours at
	    low security levels will continue to work until the users reset
	    their passwords.

	    To force all users with legacy passwords to reset their passwords
	    and upgrade to scrypt storage, a super user can run
	    'p4 admin resetpassword -a -l'. The password storage type is now
	    shown in the output of 'p4 -ztag users -l'.

Behavior Changes 2025.1 (2025.1/2761706) (2025/05/09)

	#2752228 (Jobs #125825, #126025) **
	    The special 'remote' user is now disabled by default. Previously
	    the 'remote' user was only explicitly disabled at security levels
	    4 and above, but scope of access could be controlled by
	    protections. The 'remote' user is used by server-to-server
	    connections when a 'serviceUser' has not been configured: you may
	    need to configure and authenticate the 'serviceUser' for any
	    servers that need to make connections to other server (notably
	    this may affect any server configured to use remote depots, P4AUTH
	    or is a commit server and doesn't already have the service user
	    configured for communication with edge servers; 'p4 push' and 'p4
	    fetch' are unaffected by this change.

	#2703003 (Job #123704) * **
	    Starting with the 2025.1 release, the 'p4 reconcile' command will
	    only find matching added and deleted files and reopen them as
	    move/adds and move/deletes when the new -M or --match-moves option
	    is specified. The 'p4 move' command also has a new syntax to
	    support the new option, 'p4 move -M [-c changelist#]', which finds
	    matching moves in the existing pending changelist and reopens the
	    added and deleted files as moves.

Minor new functionality in 2025.1 (2025.1/2761706) (2025/05/09)

	#2752931 (Job #125948) **
	    P4AUTH servers now require that the connecting server has a
	    'serviceUser' configured and is upgraded to at least 2025.1.

	#2749935, #2750448 (Job #125890) * ** *** ****
	    The defaults for TCP keepalive configurables have been changed such
	    that the keepalive is now enabled by default.

	#2745695, #2746796 (Jobs #120806, #125609, #125644, #125705)
	* ** *** ****
	    Added two configurables to tune network performance:
	      net.nagle and net.quickack.

	    - net.nagle=0 : disable the Nagle algorithm (ie, send data ASAP)
	    - net.nagle=1 : enable Nagle (ie, delay sending data)
	    - net.nagle=2 : disable Nagle for SSL but use the system default
	      for TCP (which on most systems is to enable Nagle); this setting
	      provides the same behavior as the current code
	    - net.quickack=0 : disable quick ACKs (delay sending ACKs)
	    - net.quickack=1 : enable quick ACKs (send ACKs immediately)

	    Note that changes to either of these new configurables do not
	    require restarting p4d; they take effect for all new connections,
	    but existing connections will be unaffected.  These configurables
	    apply to clients as well as server components.

	    The current default values are:
	    	net.nagle=2
	    	net.quickack=0
	    These values provide the same behavior as the previous release.
	    Customers using a broker may find improved network performance
	    by changing them to:
	    	net.nagle=0
	    	net.quickack=1

	    macOS Note:
	    macOS does not support enabling or disabling QuickAck on individual
	    connections, so setting net.quickack does not change any socket
	    options.

	    To enable QuickAck globally before MacOS 11 (Big Sur):
	    - add net.inet.tcp.delayed_ack=0 to /etc/sysctl.conf

	    To enable QuickAck in macOS Big Sur or later:
	    - add this XML document to
	          /Library/LaunchDaemons/com.startup.sysctl.plist:

	    <?xml version="1.0" encoding="UTF-8"?>
	    <!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN"
	          "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
	    <plist version="1.0">
	    <dict>
	        <key>Label</key>
	        <string>com.startup.sysctl</string>
	        <key>LaunchOnlyOnce</key>
	        <true/>
	        <key>ProgramArguments</key>
	        <array>
	            <string>/usr/sbin/sysctl</string>
	            <string>net.inet.tcp.delayed_ack=0</string>
	        </array>
	        <key>RunAtLoad</key>
	        <true/>
	    </dict>
	    </plist>

	    For all macOS versions, these changes take effect after rebooting.

	#2742376, #2743841 (Job #125478) **
	    The @ex@ entry in the journal for the partitioned-jnl have table is
	    now generated after the group of @dv@ entries during the
	    respective client deletion operation when the configurable
	    db.partition.dropondelete is unset.

	#2741561 (Job #123690) **
	    By default 'p4 diagnostics' now creates a single gzipped tar file
	    rather than a directory of the diagnostic files.

	#2739481 (Job #125156) **
	    Reduce memory usage on syncs when peeking at db.have and db.rev.
	    This can also have a modest performance improvement when the
	    filesystem cache is warm.

	#2738086 (Jobs #95793, #27609, #113569) **
	    User access times are now global. By default, access times are only
	    updated at the start of commands, except for users who have an
	    IdleTimeout applied to them; this can be changed by setting
	    'dm.user.accessmode' to 2 or higher, which will update users
	    access times periodically during commands and at the end.

	#2738086 (Jobs #113569, #27609, #95793) **
	    Access times for service type users will now be recorded if
	    'dm.user.accessmode' is set to 3.

	#2734545 (Job #113716) **
	    Allow '-u' and '-g' flags to filter the list of properties (p4
	    property -l) by user or group.

	#2730108 (Job #124352) **
	    Updated help documentation for map.overlay.legacy.

	#2729732 (Job #124817) **
	    Added an error message when a user tries to obliterate a file
	    within the extensions depot.

	#2728283 (Job #108578) **
	    New configurable dm.dvcs.allowcasemismatch allows fetch/push
	    between servers whose case-handling is configured differently.

	#2725636 (Job #118711) **
	    server startup commands set in 'startup.N' will auto restart if
	    terminated for any reason, when the new configurable
	    'server.startup.autorestart' is set to 1.

	#2724590 (Job #124686) **
	    For pull -ls new options -v and -h are added: pull -lsv : Show
	    separate numbers for each category: Active, Queued, Failed and
	    Retry. pull -lsvh : Same as -lsv but shows byte numbers in
	    human-readable format. pull -lsh : Same as -ls but shows byte
	    numbers in human-readable format.

	#2724379 (Job #109955) **
	    For 'p4 pull -l' a new -C option removes file-transfer records from
	    rdb.lbr for archive files that are not needed (they are already in
	    place or are not referenced in db.storage/db.storagesh).

	#2724226 (Job #123691) **
	    The 'p4 diagnostics' command's default file size limit of the
	    journal and log file is now 10Mb and these files are only
	    downloaded if the '-J' option is specified.

	#2723845 (Jobs #124571, #124572) **
	    Removed the additional empty lines within the topology file.

	#2723845 (Jobs #124572, #124571) **
	    Stopped the 'p4 diagnostics' command from creating empty file.

	#2719907 (Jobs #78692, #103380) **
	    Improved `p4 pull` comments for pull threads when pulling journal
	    or archives, and 3 new realtime monitor counters added for journal
	    recovery. `rtv.jnl.recover.in` number of all journal recs
	    processed, some might be discarded. `rtv.jnl.recover.buffered`
	    number of recs added to the buffer to be written.
	    `rtv.jnl.recover.out` number of recs written.

	#2717749, #2727059 (Job #124500) * **
	    The move detection performance of the 'p4 reconcile' command has
	    been much improved in 2025.1. A new --parallel=n option is added
	    to enable the p4 client to perform the client-side portion of the
	    move detection algorithm using multiple threads.

	#2715099 (Job #117712) **
	    Added a timer to check and update the license information of the P4
	    server if the license file has been changed externally.

	#2712255 (Job #107086) **
	    This change enhances 'p4 verify' so that after successfully
	    verifying a library file it will remove any pending record in
	    rdb.lbr for that file.

	#2711531 (Job #124593) **
	    Setting both 'dm.user.resetpassword' and 'dm.user.setinitialpasswd'
	    will now require that a user must immediately change their
	    password after a super user sets the user's initial password.

	#2709258 (Job #119486) **
	    'p4 -ztag monitor -e' now includes the cmd ident and group. The cmd
	    ident and group is also logged in 'track.log' when the 'server'
	    configurable is >= 4.

	#2708144 (Job #123998) **
	    The 'p4 reconcile' command when used with the -M or --match-moves
	    option will first open files for add, edit and delete in a pending
	    changelist before performing the move detection algorithm which
	    may be time consuming.

	#2706862 (Job #119329) **
	    A new option --filter for 'p4 pull -l' is introduced to filter
	    output based on status. With 'p4 pull -l --filter=retry' only
	    files that have failed before but still will be retried will be
	    displayed. With 'p4 pull -l --filter=failed' only files that have
	    failed and will not be retried will be displayed. With 'p4 pull -l
	    --filter=active' all other files that are valid for transfer will
	    be displayed.

	#2706852, #2708463 (Job #123705) * **
	    The 'p4 reconcile' and 'p4 move' commands now support progress
	    indicators using the -I global option.

	#2702460, #2713087 (Job #124102) **
	    Depots backed by S3 can now retrieve credentials from
	    '~/.aws/credentials' or the EC2 role endpoint by specifying the
	    'profile' name or 'role' name respectively in the depot's
	    'Address' field. Only one set of credentials can be specified at
	    once.

	#2702459 (Job #123197) * *** ****
	    The 'ssl.client.cipher.list' and 'ssl.client.cipher.suites'
	    configurables can now be used on clients, proxies and brokers.

	#2701257 (Jobs #124360, #124361) * ** *** ****
	    If the minimum TLS version is set higher than the maximum, the
	    minimum value is still allowed instead of disallowing all TLS
	    versions.

	#2701257 (Jobs #124361, #124360) * ** *** ****
	    The default TLS cipher suite has been upgraded to
	    ECDHE-RSA-AES128-GCM-SHA256 for services that only accept TLS 1.2
	    and greater.

	#2698778, #2699265, #2701645 (Job #83704) **
	    'p4 monitor show' will now show command arguments for 'p4 pull'
	    instead of being replaced by the state comments. The comments are
	    still included and a new field 'comment' added to `p4 -ztag
	    monitor show`.

	#2691924 (Jobs #124164, #123313) *
	    Include server version in altsync protocol.

	#2688375 (Job #122581) **
	    'p4 diagnostics' now reports the directory name it creates in the
	    current directory and the types of diagnostics files produced
	    within that directory.

	#2687790 (Job #122999) **
	    The 'p4 diagnostics' command now uses the server's timezone to
	    construct the name of the output directory on the client.

	#2680556 (Job #123371) **
	    A new '-l' option has been added to the 'p4d -jd -R server-type'
	    command that displays the list of excluded tables that would be
	    applied to this dump request. A dump is not performed.

	#2673289 (Job #123186) **
	    'p4 topology' now displays the version strings of the services that
	    have provided that information.

Bugs fixed in 2025.1 Patch 4 (2025.1/2907437) (2026/03/09)

	#2905019 (Job #129719) **
	    Archive pull threads could fail doing delta transfers with "open
	    for read: <archive-File>: No such file or directory". This problem
	    is now fixed.

	#2902341, #2893698 (Jobs #131039, #131153) **
	    Fixes a crash on 'pull -L' on a standby replica involving
	    concurrent updates to a partition-jnl client table and db.config.

	#2897907, #2889898 (Job #130522) **
	    Journal recovery, where journal data includes partitioned tables,
	    could fail with "Locking failure: db.config locked after
	    db.have!". This change fixes the problem.

	#2897104 (Job #130266) * **
	    Fixed 'invalid cross-device link' errors when multiple 'p4 sync'
	    operations involving delta transfer enabled archives where
	    different volumes are used for P4ROOT and archives.

	#2890751, #2889791 (Job #131012) **
	    'p4 reload' on an edge server no longer crashes on reloading a
	    non-partitioned client with open files when
	    'server.global.client.views=1' is set.

	#2890316 (Job #130907) * ** *** ****
	    OpenSSL has been upgraded to 3.0.19

Bugs fixed in 2025.1 Patch 3 (2025.1/2880859) (2026/01/22)

	#2876766, #2857489, #2870606, #2871239, #2872667 (Jobs #129173,
	#130295) **
	    In journal replay where the journal includes a note 31 for deleting
	    a partitioned table, it no longer fails with the error: "dbdel" or
	    "dbput" and "db.have:no write lock!".

	#2872238 (Job #105807) **
	    The edge server log no longer shows the "Operation 'dmr-Sequence'
	    failed" error when an edge-submit fails after a shelved change is
	    created.

	#2871599, #2850381 (Job #112113) **
	    Shelves belonging to clients that no longer exist are now treated
	    as if they are owned by the commit server. If deleting a client
	    from an edge server, shelves are now promoted as part of that
	    client delete.

	#2870855, #2848828, #2869137 (Job #129416) **
	    Replication of filtered out records no longer cause replicas to
	    wait for those transactions to complete.

	#2870470 (Job #88586) *
	    If a Control-C was issued to P4 during a sync operation, the client
	    could end up inconsistent with the Server. This has been
	    corrected.

	#2868463, #2846308 (Job #128028) **
	    If an edge server cannot rename the archive of a shelved file
	    during promote, it now returns a clear error rather than enter a
	    loop.

	#2868020, #2853916 (Job #129293) **
	    In replication if it fails to do Delta-transfer, it can now
	    successfully fall back to complete-file-transfer.

	#2865786, #2832558 (Jobs #127302, #127776, #127832, #127858, #127908,
	#127955, #128360, #129280) **
	    A non-unicode configured server now translates all paths from
	    ISO8859_1 into UTF8 in its S3 requests.

	#2865786 (Jobs #127858, #127302, #127776, #127832, #127908, #127955,
	#128360, #129280) **
	    Two new configurables control the multipart protocol used in S3
	    transfers. Only transfers greater than the value in
	    'lbr.s3.multipart' will use the multipart protocol. This value is
	    specified in megabytes, the default is 4096. 'lbr.s3.multipartsz'
	    specifies the largest size of an individual multipart transfer
	    request. This value is specified in megabytes, the default is 5.

	#2864375, #2834961 (Job #61562) **
	    The new configurable 'lbr.unloaddepot.compress' can be set to '1'
	    to compress all data unloaded with the 'p4 unload' command and
	    labels created with the autoreload option.

	#2864293, #2848656 (Job #129290) ** *** ****
	    Self-signed certificates created with the `-Gc` option on p4d, p4p
	    or p4broker are now signed with a SHA256 hash.

	#2863367 (Job #126106) **
	    Fixed binary+l file mistakenly registered as an orphaned locked
	    file after a copy from a sparse stream, where the file was not
	    resident in the sparse stream.

	#2862272 (Job #127351) **
	    The copy, merge, and integration commands for sparse stream targets
	    do an autosync at the end of the command. This behavior can now be
	    disabled with the virtual integration flag '-v', which prevents
	    branched and deleted files from affecting the workspace.

	#2860972, #2832943 (Job #128946) * **
	    cURL (for extensions) has been upgraded 8.16.0.

	#2860880 (Job #126349) **
	    When 'server.rolechecks' is set to 1, servers without the rmt-auth
	    role will no longer accept commands forwarded from remote servers
	    if they were forwarded due to P4AUTH being configured on the
	    remote server.

	#2859691 (Job #122815) **
	    The formatted ISO8601 date in the structured logs is now correctly
	    converted to UTC.

	#2859558 (Job #126261) *
	    The failure of a merge tool is now handled consistently across
	    platforms, and no longer results in a false merge.

	#2858862 (Job #118452) **
	    Forwarding replicas of edge servers now correctly handle shelves
	    that are not managed by the first upstream edge server.

	#2858856 (Job #126852) **
	    TinyXML2 has been upgraded to 11.0.0

	#2855878, #2835080 (Job #127882) **
	    Permission errors no longer occur when a delta transfer map file
	    was deleted and later simultaneous syncs were issued for the
	    corresponding file revision.

	#2855488 (Job #125149) **
	    Integrations into sparse streams now take much less time.

	#2854340, #2837121 (Job #128588) **
	    The p4d commands 'p4d -xv', 'p4d -xvU', 'p4d -xr', 'p4d -xrU' and
	    'p4 dbverify' have been updated to improve handling of partitioned
	    have tables.
	    When processing all tables (no arguments), these commands no
	    longer process the per-client tables for readonly or partitioned
	    type clients. The per-client tables for partitioned-jnl type
	    clients will be processed only if the 'db.partition.verify'
	    configurable is set to '1'.
	    When partitioned tables are explicitly specified (for example:
	    'p4d -xv db.have.pt' or 'p4d -xr db.have.pt%pclient'), all
	    per-client tables will be processed regardless of client type.
	    These commands no longer create empty tables if a per-client table
	    does not exist.

	#2854097 (Job #128849) **
	    'p4 journaldbchecksums -u', 'p4 journaldbchecksums -s', 'p4
	    dbstat', 'p4 dbpack' and 'p4d -jc' no longer try to access
	    partitioned tables that are not expected to be present on the
	    server.

	#2846298 (Jobs #126882, #127741) **
	    All S3 operations can now be retried, not just upload requests. Two
	    new configurables, 's3.credentialerror.retry' and
	    's3.error.retry', allow the customization of which errors can be
	    retried. The 's3.credentialerror.retry' configurable reloads the
	    credentials on each retry attempt.

	#2844205, #2832157 (Job #128842) **
	    'p4 describe -a -S' now correctly shows the diff for files open for
	    add in the shelf.

	#2837462 (Job #122971) **
	    Improved messaging when opening a file. Instead of: "<depotFile> -
	    can't add exclusive file already opened", the message includes the
	    action the other client did that locked the file. For example,
	    "<depotFile> - can't add exclusive file already opened for add".

	#2837446, #2832305 (Job #127911) **
	    Replicas of type 'build-server' now use per-client partitioned have
	    tables for clients of types 'read-only', 'partitioned' and
	    'partitioned-jnl' instead of the replica specific db.have.rp
	    alternative have table.

	#2837445 (Job #124713) **
	    'p4d -xvU' and 'p4 dbverify -U' no longer process partitioned have
	    tables when the 'db.partition.verify' configurable is set to '0'.

	#2835855 (Job #126265) **
	    When a 'p4 attribute -f' command would result in identical trait
	    content and the traitLot reference count is greater than 1, the
	    identical content would be copied to a new traitLot. This could
	    cause unnecessary resolves in later 'p4 copy' operations. This
	    attribute command scenario has been changed to not create
	    the redundant new traitLot and content when the trait content is
	    unchanged.

	#2835404 (Job #128688) **
	    The command 'p4 undo' now works with the partitioned and
	    partitioned-jnl client types.

Bugs fixed in 2025.1 Patch 2 (2025.1/2831954) (2025/09/26)

	#2829942, #2827789 (Job #125371) **
	    'p4 istat' no longer takes read locks when 'db.peeking' is set to 1
	    or greater.

	#2828648 (Job #127310) **
	    Edge servers no longer try to delete db.have.pt tables for clients
	    not associated with that edge server and no longer propagate that
	    journal note to downstream servers.

	#2828452, #2826356 (Job #128816) **
	    Writes to partitioned have tables can no longer append journal
	    records to the end of a rotated journal.

	#2827666, #2817781 (Job #127084) **
	    Improved performance of 'p4 shelve' for a change on keyed files
	    that has an action of branch or integ.

	#2825402 (Jobs #125669, #128002, #128003) **
	    Reloading a partitioned client on an edge server with
	    'server.global.client.views=1' set will now correctly restore the
	    client's have records.

	#2825402 (Jobs #128002, #125669, #128003) **
	    Reloading a stream client on an edge server with
	    'server.global.client.views=1' set will no longer send the
	    generated 'View' or 'ChangeView' to the commit server.

	#2825402 (Jobs #128003, #125669, #128002) **
	    Reloading a client with a 'ChangeView' on an edge server with
	    'server.global.client.views=1' set will now correctly send both
	    the 'View' and 'ChangeView' to the commit server.

	#2823492 (Job #125630) **
	    Replication will no longer halt in the case where a partition have
	    delete journal note (31) and a change or block checksum note (15
	    or 17) are encapsulated by a longer running transaction.

	#2821146 (Jobs #125360, #125760, #125814) **
	    The code that loads/sets configurable variables will parse the
	    input on commas to allow the setting of multiple variables with a
	    single command. This processing can cause problems with string
	    tunables that use a comma. This fix checks the type of the first
	    configurable specified and if it is a 'string' type no parsing is
	    performed on the input.

	#2821146 (Jobs #125760, #125360, #125814) **
	    'p4 configure show' now displays all the string-based tunables.

	#2813253 (Job #127760) **
	    Fixed 'invalid out-of-bounds conversion of DmtStreamPathType'
	    error.

Bugs fixed in 2025.1 Patch 1 (2025.1/2810567) (2025/08/05)

	#2809802, #2804114 (Job #127726) **
	    Fixed crash with replication delta transfer when debug logging was
	    enabled.

	#2809027, #2799220 (Jobs #127507, #126292, #127579) **
	    Delta transfer no longer reports an error when 'server.depot.root'
	    ends with a '/'.

	#2808885, #2790241 (Job #99980) *
	    Tickets specified with 'p4 -P' or P4PASSWD are now handled
	    correctly during parallel operations.

	#2808002, #2782186 (Job #126984) **
	    Replication Delta Transfer temporary files which were not removed
	    under some circumstances are now removed.

	#2806393, #2805269 (Job #127573) * **
	    A performance issue when reading RCS file content for commands that
	    compare revision content has been fixed.

	#2804852, #2777466 (Job #126880) **
	    S3 uploads to AWS no longer fail with files greater than 4Gb in
	    size.

	#2801978, #2795308 (Job #126938) **
	    'p4 login' will now return a distinct error when
	    'dm.user.setinitialpasswd' is disabled and the user has no
	    password set, informing the user that a super user must set their
	    initial password.

	#2801977, #2792404 (Job #127436) **
	    'p4 copy' will now ignore files that only differ by attributes when
	    the 'dm.copy.attributes' configurable is set to 0.

	#2801498, #2781936, #2781938, #2793291, #2796444 (Jobs #126141,
	#127054, #127223) **
	    The move detection feature in 'p4 reconcile', 'p4 status' and 'p4
	    move' now works as expected with pre-2025.1 clients.

	#2800985, #2790232 (Job #127027) **
	    Edge servers processing obliterates from the upstream server no
	    longer perform full scans of the db.working table.

	#2800598, #2793233 (Job #126602) **
	    If replication is stalled or it is slow, the edge server could send
	    a change-update up to its target server based on an outdated
	    record, and cause data inconsistency. This change prevents such a
	    change-update and returns this message: "Operation failed on
	    remote server because of data inconsistency, possibly due to
	    stalled or slow replication".

	#2799238, #2793768 (Job #127029) **
	    The journal note written by 'p4 obliterate' with the -h and/or -l
	    flags is now correctly re-written to the journal when replayed or
	    replicated.

	#2797338, #2791095 (Job #125480) **
	    A recommended value of a relative path to the server's root
	    directory has been added to the help message of the
	    client.readonly.dir configurable.

	#2796972 (Job #127424) **
	    In 'p4 verify' the enhancement to do rdb.lbr cleanup was causing
	    performance issues. This change disables that enhancement.

	#2795402 (Job #127413) **
	    Fixed a client version compatibility issue in 'p4 add' that could
	    result in a false insufficient disk space error on submit

	#2794278, #2772883 (Job #123929) **
	    Fixed istat crash due to inconsistencies in stream spec data
	    originating from pre-19.1 servers. Run 'p4d -xf 123929' to fix
	    inconsistent data.

	#2793726, #2792087 (Job #127398) **
	    The stream spec permission checking is no longer applied to submits
	    to streams that do not include a change to the stream spec.

	#2792655, #2789624 (Job #125649) **
	    Operations like 'p4d -c <command>' that lock all tables now wait
	    for any simultaneous work on partitioned tables to finish before
	    proceeding.

	#2792012, #2766621 (Job #123091) **
	    On a case-insensitive server with server.depot.root set, files with
	    names containing an uppercase character no longer fail to be
	    uploaded to an S3 bucket.

	#2791196, #2764800 (Job #126179) **
	    The compare routine for the lbrRev type used in the storage tables
	    no longer ignores the first "1." part of the field. This was
	    causing problems for imported CVS files.

	#2789604, #2768501, #2770953, #2787777 (Job #126773) **
	    The sync operation no longer causes the database open error to
	    occur on the db.sendq.pt database table when the frequency of
	    syncs is high.

	#2789590, #2787215 (Job #127308) **
	    The modtime of binary files with either the +m modifier or with the
	    modtime option enabled in the client are now correctly passed to
	    altsync agents.

	#2789104 (Jobs #110808, #121743, #123079) ** *** ****
	    The server no longer sends multiple duplicate certificates from a
	    certificate chain to the client after a 'p4 admin restart'.

	#2789104 (Jobs #121743, #110808, #123079) **
	    After restart or failover, the server now reloads relevant
	    network-related configurables and reloads certificates from the
	    certificate file, which prevents a SSL handshake error after
	    failover when the certificate file has been modified. The
	    certificate file is now checked for out-of-order certificates and
	    logs a message ("NetSslEndPoint::Listen() - invalid certificate
	    chain") if any are found, but does not produce an error because
	    these issues often do not cause problems.

	#2788866, #2785826 (Job #127243) *
	    Improved error handling when unable to open file during reconcile.

	#2787214, #2767902 (Job #123209) **
	    Topology updates from replicas now release locks earlier and no
	    longer wait for replication to synchronize.

	#2783849 (Jobs #126183, #126084) * **
	    Fixed an issue where the 'p4 reconcile' command would match
	    multiple deletes to the same add when the files have identical
	    content. This was causing a subsequent submit of the incorrectly
	    moved files to fail with missing resolve records.

	#2779346, #2766264 (Job #125471) **
	    Fixed an intermittent 'no write lock' error with journal replay
	    into an offline db when the location of the client.readonly.dir is
	    shared between the p4d server and the offline db.

	#2778788, #2773409 (Job #126534) **
	    Fixed the following issue: When doing parallel recovery using
	    multifile checkpoint and the source includes a partitioned client,
	    if the partitioned client-name ends in an underscore followed by
	    eight digits, valid for a multifile checkpoint file sequence
	    number, recovery could fail with an error like
	    "..._00000001.ckp.gz: No such file or directory".

	#2777813 (Job #125639) **
	    The journal note type 31 now deletes the respective partitioned-jnl
	    table during the journal replay operation.

	#2775291 (Job #126354) **
	    The server type in the topology table is now correctly recorded as
	    'commit-server' after upgrade instead of a list of roles.

	#2772170 (Job #124125) **
	    p4d -xv will now skip the partitioned client database tables that
	    are not on the server instead of reporting the 'table not known'
	    error.

Bugs fixed in 2025.1 (2025.1/2761706) (2025/05/09)

	#2753114 (Job #125945) **
	    The 'commit-server' server services no longer includes P4AUTH. When
	    'server.rolechecks' is set to 1, a server configured as a commit
	    server will no longer allow other servers to use it as a P4AUTH
	    server.

	#2752228 (Jobs #126025, #125825) **
	    The cross-server exclusive locking feature 'p4 edit --remote' now
	    correctly uses either the current user or the user specified in
	    the remote spec to authenticate the connection to the remote
	    server.

	#2749180, #2749959 (Job #125223) **
	    We were mistakenly checking the permissions to stream spec when
	    doing submit to a classic depot. We have now stopped checking
	    stream permissions when submitting for a classic depot.

	#2745283, #2746796 (Jobs #125609, #120806, #125644, #125705) **
	    For the following configurables, "p4 -ztag configure show" returned
	    the wrong values for the "RestartRequired" field; they previously
	    returned "ExplicitStop" and now return the correct value ("No"):
	    net.tcpsize, ssl.client.ca.path, ssl.client.cipher.list,
	    ssl.client.cipher.suites, ssl.cipher.list and ssl.cipher.suites.

	#2745283, #2746796 (Jobs #125644, #120806, #125609, #125705)
	* ** *** ****
	    Correct a Windows-specific problem: setting "net.keepalive.idle" or
	    "net.keepalive.interval" to values greater than 127 would succeed
	    but would not actually set the corresponding socket options to the
	    requested values. Each subsequent connection might log a message
	    like the following when it attempted to set the keepalive option
	    (the numbers in the message will vary according to the values used
	    in the "p4 configure set" commands): C:\> p4.exe -p 127.0.0.1:1666
	    configure set any#net.keepalive.idle=180 NetTcpTransport: not
	    setting TCP keepalive idle = -76 secs, interval = 20 secs because
	    both must be positive The existing workaround is to set both
	    configurables to values positive values less than 128; note that
	    p4d will need to be restarted for this change to take effect. All
	    legal values for these configurables now work properly.

	#2744599, #2745144 (Job #121299) **
	    Fixed server crash where altsync agent response did not include the
	    program version.

	#2742809, #2744325 (Job #125450) **
	    The 'p4 move' command is now disallowed in a ready-only client
	    workspace.

	#2741593 (Job #125093) **
	    Both 'journalcopy' and 'pull -L' accessing journal-files at the
	    same time could result in bad data in the state file and cause
	    replication to stop. This change fixes the problem.

	#2741273 (Job #125241) **
	    Use of server-side Extensions that themselves run client commands
	    via the P4API while on a Unicode-mode server no longer interfere
	    with the server process charset, which could result in errors
	    finding files with non-ASCII characters in them.

	#2740333 (Job #125163) **
	    These network configurables used to require a restart to take
	    effect on p4d, but now take effect on all subsequent connections
	    even without a restart: net.autotune, net.keepalive.disable,
	    net.keepalive.idle, net.keepalive.interval, net.keepalive.count,
	    net.tcpsize, ssl.client.cipher.list, ssl.client.cipher.suites,
	    ssl.cipher.list and ssl.cipher.suites.

	#2737504 (Job #125287) **
	    The partitioned-jnl, partitioned and readonly client types can now
	    be converted into writeable client type.

	#2734766, #2735348 (Job #125218) **
	    Fixed delta transfer server failure with error message about moving
	    a file pointer before the beginning of a file.

	#2733431 (Job #124867) **
	    The writeable client type can now be converted into partitioned,
	    partitioned-jnl or readonly client type. If there are any opened
	    files, then the conversion to readonly client type results in an
	    error.

	#2732560 (Job #125135) **
	    Updated `p4 configure help` output URLs to 'help.perforce.com'.

	#2732488 (Job #124576) **
	    Recovering an incompatible checkpoint will no longer report an
	    incorrect line number in the error message.

	#2731160 (Job #125123) **
	    'p4 changes' has been optimised such that where possible, revision
	    scans are reduced and overloaded arguments no longer cause
	    optimisations to be skipped.

	#2727978 (Job #124938) **
	    'p4 reload' on an edge server no longer crashes on reloading a non
	    partitioned client.

	#2727123 (Job #123169) **
	    Add new optional long opt `--sync-time`, which can be used to
	    update the file modification time in the metadata, see `p4 help
	    sync` for usage. The new flag can be used by altsync agents to
	    support the hydrated hotfiles feature. The altsync agent should
	    call `p4 sync -k --sync-time=N ...` after hydrating any
	    placeholder files to set the file modification time and any
	    further syncs will consider the file a hotfile, dehydrating a file
	    should call `p4 sync -k -q ...`.

	#2726952 (Job #124578) **
	    Parallel checkpoints were incorrectly taking a read lock on the
	    db.monitor table and not releasing it until the checkpoint had
	    completed. This has been fixed.

	#2726783 (Job #124922) **
	    The topology.dot file created by 'p4 diagnostics' did not quote
	    node names, producing syntax errors when processed by 'dot'. This
	    has been fixed.

	#2726500 (Job #124999) * **
	    cURL has been upgraded to 8.12.1.

	#2724373 (Job #124807) **
	    The 'p4 diskspace' command now reports on the diskspace at the
	    following additional locations (if configured): P4AUDIT,
	    client.readonly.dir, client.sendq.dir, pull.trigger.dir,
	    rt.monitorfile, server.extensions.dir, server.locks.dir and each
	    serverlog.file.N

	#2722543 (Job #124603) **
	    A checkpoint created using '-jc' with more than a single thread
	    enabled that contains partitioned clients could place the
	    db.config table entries after those for the partitioned clients,
	    making it unrecoverable.

	#2722542 (Job #124865) **
	    The correct error message is now displayed during the conversion of
	    partitioned or partitioned-jnl clients with opened files to a
	    readonly client.

	#2720824 (Jobs #124618, #124617) **
	    'p4 diagnostics' now supports the '-t' and 'p' flags to request
	    that the output from the 'top' and 'ps' commands respectively be
	    returned from the server. Only supported on Linux platforms.

	#2720760 (Job #124748) **
	    The conversion between the partitioned-jnl and the readonly or
	    partitioned client types now updates partitioned have tables on
	    the replica servers appropriately.

	#2719920 (Job #124759) **
	    'p4 list' will now correctly update a temporary label on a most
	    recent update basis when using multiple overlapping arguments or
	    when the same label is specified multiple on multiple commands
	    within the same connection.

	#2719311 (Job #120859) **
	    Fixed excessive scanning of db.revsh by 'p4 verify -S' on a shelf
	    containing many files marked for delete.

	#2717964 (Job #124712) **
	    In rare cases the setup to run p4diag automatically can fail on
	    Windows Server 2022 Enterprise without a desktop installed. This
	    has been corrected.

	#2716897 (Job #123811) **
	    In certain cases 'p4 add' for a file with long path could
	    incorrectly pass the length limit test and get added for submit
	    when it was expected to fail. This change fixes the problem.

	#2716524 (Job #123694) **
	    Edge servers will no longer reject submit commands if a depot not
	    involved in the submit has less free space than the
	    'filesys.depot.min' threshold.

	#2716062 (Job #124590) **
	    The configurable server.start.unlicensed is now documented. This
	    configurable has been present since 2016.1.

	#2715929 (Job #123810) **
	    If a file with path length longer than 1024 is committed, doing a
	    'p4 sync' on edge-server for this file could cause the edge-server
	    to crash. This change fixes the problem.

	#2715482, #2719024 (Jobs #121960, #117688) **
	    'p4 switch' performed a sync to #have which could remove all
	    unmodified files from a user's workspace if the user had
	    previously switched streams using the '--no-sync' option. The sync
	    to #have was added to switch in 2024.1 to address an issue found
	    related to pruned files. This fix removes that sync to #have from
	    the 'p4 switch' logic in favor of updating how 'p4 switch' uses
	    reconcile to avoid the issue with pruned files.

	#2714158 (Job #124532) **
	    The 'p4 diagnostics' command now supports the '-j' option that will
	    encode the 'diags' and 'monitor' files in JSON.

	#2713178 (Job #124533) *
	    Fixed an issue that causes a parallel sync to sometimes produce
	    zero-byte binary+F files when connected to a Unicode server.

	#2711988 (Job #124604) **
	    When recovering a checkpoint containing partitioned clients that
	    mismatches the case of the server, a parallel recovery would
	    report an extra spurious error about a missing configurable. This
	    has been fixed.

	#2711976 (Job #122574) **
	    The command 'p4 -c readonlyclient client -d writeableclient' with
	    the partitioned type now successfully deletes the client.

	#2711712 (Job #124526) **
	    Changed 'p4 pull -R' to make it work on commit-servers too.

	#2711526 (Job #124613) **
	    Setting 'auth.ldap.ssllevel=2' on a Windows server will no longer
	    allow connections to LDAP servers with self-signed certificates
	    unless that certificate is installed into the CA store or is
	    specified with 'auth.ldap.cafile'.

	#2709467 (Job #124534) **
	    Serverlocks on Windows servers are no longer deleted in such a way
	    that on rare occasions synchronous operations could occur in
	    parallel.

	#2708864 (Job #124517) **
	    'p4 diagnostics' could fail with an "Infinite loop in Layout" error
	    when generating the topology data for a large network. This has
	    been fixed.

	#2708858 (Job #124284) **
	    A 'p4 diagnostics -s' request for an strace of the server and
	    associated processes is now supported on Linux platforms.

	#2708446 (Job #124496) **
	    The 'p4 diagnostics' command now produces a 'topology.dot' file in
	    the diagnostics directory. This file is in graphviz format that
	    can produce a graphical diagram of the network topology.

	#2705995 (Jobs #124317, #124320) * **
	    P4ALTSYNC agents are now provided with a 'time' field containing
	    the modtime to set on add/added files of type +m or when the
	    modtime client option is enabled.

	#2705985 (Job #124350) **
	    'p4 diagnostics' returns a 'file not found' error if a logfile is
	    not configured on the server. This has been fixed.

	#2705691, #2706864 (Job #122189) * ** *** ****
	    When using either the tcp64 or ssl64 protocols (IPv6 or IPv4), IPv4
	    addresses are now always formatted as IPv4 addresses rather than
	    mapped IPv6 addresses.

	#2704826 (Job #124281) **
	    'p4d -jd' no longer creates empty directories for partitioned
	    clients.

	#2704294 (Job #122963) **
	    On an edge server with submit.allowbgtransfer=1 and
	    submit.autobgtransfer=1, when a file edit is submitted without
	    change, the option '-f submitunchanged' of submit would fail to
	    override 'revertunchanged' from the client spec. This would result
	    in the submit failing with: "No files to submit". This change
	    fixes the problem.

	#2703879 (Job #121661) **
	    There was a problem in 'p4 unload' that when unloading many files
	    at once it would lock tables in a way that would block other
	    commands like 'p4 monitor'. This change fixes the problem.

	#2703054 (Job #124145) **
	    Fixed a conflict between writable components and Ignored paths.

	#2702307 (Job #123764) **
	    'p4 diagnostics' could fail with an 'infinite loop' error if the
	    topology table contained a large number of broker or proxy entries
	    that did not have a serverID set. These records are now ignored.

	#2702148 (Jobs #124070, #121658) **
	    Checkpoint files created with the parallel and multifile options
	    now use a '#' character to mark the start of the batch number
	    encoded within the filename. Previously the server would use a '_'
	    character that could clash with a client name for a partitioned
	    client.

	#2701937 (Job #124079) **
	    'p4 pull' will not retry previously failed RCS type revs, if the
	    failure was due to a RCS parse error.

	#2700625 (Job #123919) *
	    With AltSync client on Windows concurrent multiple 'p4 sync'
	    commands could fail with "All pipe instances are busy". Problem is
	    now fixed.

	#2696571 (Job #121788) **
	    'p4 verify -v -U' was not fixing bad digest or size in the unload
	    depot. This change fixes the problem.

	#2696546 (Job #124006) **
	    Changed the k-value for configurable 'net.delta.transfer.minsize'
	    from 1 to 1024.

	#2695509 (Job #118107) **
	    'p4 copy -v' could fail with "Error opening librarian file". This
	    change fixes the problem.

	#2695495 (Job #123050) **
	    For 'p4 changes -m <max> -e <change>' it would excessively scan
	    records from db.change. This change fixes the problem.

	#2691611 (Job #123904) **
	    Deletion of a partitioned database table now deletes only the
	    numbered partitioned directory.

	#2691574 (Job #123912) **
	    A partitioned database table path could be incorrectly parsed. This
	    has been fixed.

	#2690826 (Job #100587) **
	    A new option has been added to the 'p4 storage -l start'
	    subcommand, '--nonlbr', that requests that the scanner remove any
	    files that are not in archive format. A report file is generated
	    when the '--nonlbr' option is specified that can be viewed by
	    using the optional '--nonlbr' option to 'p4 storage -l status'.

	#2689932, #2693095 (Job #120059) **
	    There was a race condition between directory removal and archive
	    creation on an edge during a 'p4 submit -e' for binary file types.

	#2689388 (Job #122377) **
	    'p4 submit' on edge could fail when a changelist had a lot of files
	    with long paths due to edge running out of rpc buffer. This change
	    fixes the problem by sending lock requests in batches. The number
	    of files in each batch is controlled by the setting in the
	    configurable dm.locks.global.batch.net (default is 10,000).

	#2689296 (Job #123856) **
	    The 'svrRecType' topology field is no longer unset during replica
	    restart when an upstream server is older than 2022.2.

	#2689260 (Job #123774) ***
	    Reuse of a ClientApi object across connections that involve a proxy
	    no longer causes "Unknown command" errors after client statistics
	    should have been reported to the server.

	#2688723 (Job #123797) **
	    Delta commit against a file with missing server-side content for
	    the prior revision, or against a deleted prior revision could fail
	    with a "zero length chunk map" error.

	#2686689 (Job #123487) **
	    `p4 verify -t` can now be run on unicode enabled servers.

	#2686390, #2689821 (Job #109468) **
	    For commands with a filetype parameter when run with '-t text', it
	    used to mean 'text+D'. With this change the default is decided
	    based on the setting for configurable lbr.autocompress: If
	    lbr.autocompress=1 storage modifier will be '+C', otherwise it
	    will be '+D'. The new behavior also affects commands like fstat
	    that output filetype. These commands now show the storage
	    modifier, '+D' or '+C', in the output (for fstat in the lbrType
	    field). Users can revert back to the old behavior by either using
	    a -Zapi < 98 or by setting the configurable
	    sys.types.text.storage.behavior to 0.

	#2685672, #2686815 (Jobs #123022, #119098) **
	    The sync operation no longer causes the database open error to
	    occur on the db.sendq.pt database table.

	#2685390 (Job #123351) **
	    'p4 logexport' now performs more thorough validation of endpoint
	    addresses.

	#2683230 (Job #123521) **
	    Clients of 'readonly' type now work correctly as revision
	    specifiers.

	#2682685 (Job #123438) **
	    Prevent crash on journal replay with an update, then delete, of a
	    db.config record with a specific serverID within the same journal.

	#2682684 (Job #123524) **
	    Improved performance of p4 zip, fetch and pull commands when
	    running with large number of revision data or changelists.

	#2680592, #2682374 (Job #123443) **
	    Commands run through a broker and then forwarded to another server
	    will no longer cause hangs for successive commands run on the same
	    connection after a client could have reported client stats.

	#2679606, #2680298 (Job #123346) **
	    A 'p4 sync' on an edge server with lbr.replication=cache could
	    cause server to hang. This change fixes the problem.

	#2678893 (Job #123279) **
	    'p4 changes --explain' is updated to include descriptions for
	    --user-case-insensitive and --client-case-insensitive.

	#2677295 (Job #121121) **
	    Corrected an unexpected 'Files are missing as a result of one or
	    more move operations' error in the fetch, push, and zip commands.

	#2676128 (Job #123359) **
	    The commands 'p4d -K db.have.pt' and 'p4d -k db.have.pt' now
	    exclude and include all the available partitioned have tables.

	#2674505 (Job #122687) **
	    Commands that specify multiple arguments using different
	    partitioned clients as the revision specifiers will now return the
	    correct results for each argument.

	#2668074 (Job #123024) **
	    p4 diagnostics and the lock reporting subsystem of the monitor now
	    parse the old output format of 'lsof' correctly.

--------------------------------------------------------------------------

Major new functionality in 2024.2 (2024.2/2675662) (2024/10/31)

	#2652338, #2663960, #2664633 (Job #120954) * **
	    The 'p4 sync' command now sends files of type 'binary+F' using
	    delta transfer to improve performance. This builds on the delta
	    transfer support added to 'p4 submit' in 2024.1 and uses the same
	    configurables to tune the behavior.

	#2629301, #2662459, #2668029, #2668972 (Jobs #121018, #123039, #123047)
	**
	    OpenTelemetry Logging Integration

	    Structured logs may now be exported via OTLP to a range of log
	    aggregation services. This works for structured logs in either CSV
	    or JSON formats by configuring `p4 logexport` as a startup command
	    (see 'p4 help logexport' for details). Logs will be exported in JSON
	    format to avoid the log aggregator needing to be configured to parse
	    the CSV structures. Log rotation will be followed and any log files
	    still being exported will not be removed by the structured log's
	    retention policy.

	#2622736, #2647879 (Jobs #121117, #122257) * **
	    Support for 'hotfiles' with altsync clients.

	    Files that match the criteria (path, size and/or type based)
	    specified in the 'p4 hotfiles' spec will be transferred to the
	    client during sync rather than the altsync agent creating
	    placeholders to be hydrated later.
	    See 'p4 help hotfiles' for more details.

Technology Preview features 2024.2 (2024.2/2675662) (2024/10/31)

	#2652025 (Job #87744) **
	    A new command, 'p4 diagnostics', has been added to aid Perforce's
	    support team to generate server diagnostics.

Minor new functionality in 2024.2 (2024.2/2675662) (2024/10/31)

	#2666581, #2668972 (Jobs #123047, #121018, #123039) **
	    Structured logs now rotate with the correct filename when the log
	    is configured to override a differently named log configured via
	    the 'any' server specifier.

	#2659482 (Job #59679) **
	    JSON format structured logs, defined with the '.json' extension,
	    are now supported. This includes compatibility with 'p4 logparse'.

	#2658019, #2673369, #2673937 (Job #122086) **
	    This change alters 'p4 changes' command to allow multiple -c
	    options. Each -c value can include wildcards and possibly start
	    with '-' to exclude changes with certain clients from the result.

	#2656556, #2657260, #2673999, #2674204 (Job #121864) **
	    This change alters the -c option of 'p4 changes' to allow it to
	    work as a search pattern possibly with wildcards. Adding a -E flag
	    ( or the long --client-case-insensitive flag) makes the matching
	    case-insensitive even on a case-sensitive server. Similar change
	    is also applied to the -u option. Note that we can have multiple
	    -u options and each can now be a search pattern that supports
	    wildcards and can start with '-' to exclude specific users. The -E
	    flag ( or the long --user-case-insensitive flag ) can be used to
	    control case-sensitiveness.

	#2655555 (Job #122085) **
	    With this change the 'p4 changes' command allows multiple -u
	    options to allow filtering of the results on multiple users.

	#2651326, #2658004 (Job #119824) **
	    For 'p4 clients' the -u option can now work as a filter pattern
	    possibly with wildcards. If wildcards are used the filter pattern
	    should be enclosed in double quotes. This filter follows the
	    server's normal case-sensitivity rules. Adding the
	    --user-case-insensitive flag makes the matching case-insensitive,
	    even on a case-sensitive server. Similar change is also applied to
	    the -u option for the 'p4 labels' and 'p4 branches' commands.

	#2643597 (Jobs #120959, #120763) **
	    Enabled 'p4 unshelve -S //stream [-P //parent]' for sparse streams.
	    A merge down may be required before unshelving from the parent
	    stream.

	#2627572, #2627714 (Jobs #119476, #119575) **
	    The command 'p4 journaldbchecksums -u unloadfile -t dbtable' now
	    unload the files successfully for the partitioned-jnl have tables.

	#2623791 (Job #121131) ** *** ****
	    SSL certificates that use EC, ED25519 or ED448 keys are now
	    supported.

	#2621152, #2621158 (Job #119512) **
	    'p4d -xx' command can now be used to check the integrity between
	    the tables 'db.working' and 'db.have.pt%pclient', where the later
	    represents a specific partitioned have table.

	#2616805, #2641818 (Job #38882) **
	    This change improves performance for the unlock command with force
	    flag: 'p4 unlock -f -c <chg>'.

	#2614611 (Job #119863) **
	    This change introduces a new flag, '-l', for 'p4 obliterate'. When
	    this flag is set the command will skip deleting db.label records
	    for the purged files. This also introduces a new journal note,
	    note number 33, to signal obliterate flags -l and -h to
	    edge-servers. The new journal note has one parameter, an integer,
	    that with value 1 signals -h and value=2 signals -l. Please note
	    this functionality changes purge behavior on edge servers. The new
	    journal note when sent without an -h flag will now purge records
	    on that edge.

	#2601263, #2602814, #2606491, #2613635 (Jobs #119311, #119719) **
	    The commands 'p4 attribute' and 'p4 fstat -Oa' could fail with
	    'Rpc buffer too big' errors if an attribute value size was
	    too large (greater than 250MB). Now the command 'p4 attribute
	    -I' which reads the attribute value from a file may be used for
	    attribute values that would generate that error. In addition,
	    the 'p4 print -T' command may now be used to print an attribute
	    value that would generate that error from the 'p4 fstat -Oa'
	    command.

	#2599011 (Job #66622) **
	    'p4 clients -S stream' now supports wildcards.

Bugs fixed in 2024.2 Patch 5 (2024.2/2877946) (2026/01/14)

	#2876765, #2857489, #2870606, #2871239, #2872667 (Jobs #129173,
	#130295) **
	    In journal replay where the journal includes a note 31 for deleting
	    a partitioned table, it no longer fails with the error: "dbdel" or
	    "dbput" and "db.have:no write lock!".

	#2874697 (Job #121299) **
	    Fixed server crash where altsync agent response did not include the
	    program version.

	#2872235 (Job #105807) **
	    The edge server log no longer shows the "Operation 'dmr-Sequence'
	    failed" error when an edge-submit fails after a shelved change is
	    created.

	#2871598, #2850381 (Job #112113) **
	    Shelves belonging to clients that no longer exist are now treated
	    as if they are owned by the commit server. If deleting a client
	    from an edge server, shelves are now promoted as part of that
	    client delete.

	#2870853, #2848828, #2869137 (Job #129416) **
	    Replication of filtered out records no longer cause replicas to
	    wait for those transactions to complete.

	#2868883 (Job #88586) *
	    If a Control-C was issued to P4 during a sync operation, the client
	    could end up inconsistent with the Server. This has been
	    corrected.

	#2868455, #2846308 (Job #128028) **
	    If an edge server cannot rename the archive of a shelved file
	    during promote, it now returns a clear error rather than enter a
	    loop.

	#2867342 (Job #124759) **
	    'p4 list' will now correctly update a temporary label on a most
	    recent update basis when using multiple overlapping arguments or
	    when the same label is specified multiple on multiple commands
	    within the same connection.

	#2864294, #2848656 (Job #129290) ** *** ****
	    Self-signed certificates created with the `-Gc` option on p4d, p4p
	    or p4broker are now signed with a SHA256 hash.

	#2860970, #2832943 (Job #128946) * **
	    cURL (for extensions) has been upgraded 8.16.0.

	#2859679 (Job #122815) **
	    The formatted ISO8601 date in the structured logs is now correctly
	    converted to UTC.

	#2858863 (Job #118452) **
	    Forwarding replicas of edge servers now correctly handle shelves
	    that are not managed by the first upstream edge server.

	#2858857 (Job #126852) **
	    TinyXML2 has been upgraded to 11.0.0

	#2856254, #2837121 (Job #128588) **
	    The p4d commands 'p4d -xv', 'p4d -xvU', 'p4d -xr', 'p4d -xrU' and
	    'p4 dbverify' have been updated to improve handling of partitioned
	    have tables.
	    When processing all tables (no arguments), these commands no
	    longer process the per-client tables for readonly or partitioned
	    type clients. The per-client tables for partitioned-jnl type
	    clients will be processed only if the 'db.partition.verify'
	    configurable is set to '1'.
	    When partitioned tables are explicitly specified (for example:
	    'p4d -xv db.have.pt' or 'p4d -xr db.have.pt%pclient'), all
	    per-client tables will be processed regardless of client type.
	    These commands no longer create empty tables if a per-client table
	    does not exist.

	#2855874, #2835080 (Job #127882) **
	    Permission errors no longer occur when a delta transfer map file
	    was deleted and later simultaneous syncs were issued for the
	    corresponding file revision.

	#2855862 (Job #126106) **
	    Fixed binary+l file mistakenly registered as an orphaned locked
	    file after a copy from a sparse stream, where the file was not
	    resident in the sparse stream.

	#2855487 (Job #125149) **
	    Integrations into sparse streams now take much less time.

	#2855485 (Job #127351) **
	    The copy, merge, and integration commands for sparse stream targets
	    do an autosync at the end of the command. This behavior can now be
	    disabled with the virtual integration flag '-v', which prevents
	    branched and deleted files from affecting the workspace.

	#2854328 (Job #124125) **
	    p4d -xv will now skip the partitioned client database tables that
	    are not on the server instead of reporting the 'table not known'
	    error.

	#2854156 (Job #128849) **
	    'p4 journaldbchecksums -u', 'p4 journaldbchecksums -s', 'p4
	    dbstat', 'p4 dbpack' and 'p4d -jc' no longer try to access
	    partitioned tables that are not expected to be present on the
	    server.

	#2844204 (Job #128842) **
	    'p4 describe -a -S' now correctly shows the diff for files open for
	    add in the shelf.

	#2841424 (Job #128816) **
	    Writes to partitioned have tables can no longer append journal
	    records to the end of a rotated journal.

	#2837460 (Job #122971) **
	    Improved messaging when opening a file. Instead of: "<depotFile> -
	    can't add exclusive file already opened", the message includes the
	    action the other client did that locked the file. For example,
	    "<depotFile> - can't add exclusive file already opened for add".

	#2837448 (Job #127084) **
	    Improved performance of 'p4 shelve' for a change on keyed files
	    that has an action of branch or integ.

	#2837443 (Job #124713) **
	    'p4d -xvU' and 'p4 dbverify -U' no longer process partitioned have
	    tables when the 'db.partition.verify' configurable is set to '0'.

	#2836402, #2835855 (Job #126265) **
	    When a 'p4 attribute -f' command would result in identical trait
	    content and the traitLot reference count is greater than 1, the
	    identical content would be copied to a new traitLot. This could
	    cause unnecessary resolves in later 'p4 copy' operations. This
	    attribute command scenario has been changed to not create
	    the redundant new traitLot and content when the trait content is
	    unchanged.

	#2835409 (Job #128688) **
	    The command 'p4 undo' now works with the partitioned and
	    partitioned-jnl client types.

Bugs fixed in 2024.2 Patch 4 (2024.2/2832881) (2025/09/30)

	#2831029 (Jobs #124576, #125630) **
	    Recovering an incompatible checkpoint will no longer report an
	    incorrect line number in the error message.

	#2831029, #2823492 (Jobs #125630, #124576) **
	    Replication will no longer halt in the case where a partition have
	    delete journal note (31) and a change or block checksum note (15
	    or 17) are encapsulated by a longer running transaction.

	#2830504, #2827789 (Job #125371) **
	    'p4 istat' no longer takes read locks when 'db.peeking' is set to 1
	    or greater.

	#2828675 (Jobs #125669, #128002, #128003) **
	    Reloading a partitioned client on an edge server with
	    'server.global.client.views=1' set will now correctly restore the
	    client's have records.

	#2828675 (Jobs #128002, #125669, #128003) **
	    Reloading a stream client on an edge server with
	    'server.global.client.views=1' set will no longer send the
	    generated 'View' or 'ChangeView' to the commit server.

	#2828675 (Jobs #128003, #125669, #128002) **
	    Reloading a client with a 'ChangeView' on an edge server with
	    'server.global.client.views=1' set will now correctly send both
	    the 'View' and 'ChangeView' to the commit server.

	#2828657 (Job #127310) **
	    Edge servers no longer try to delete db.have.pt tables for clients
	    not associated with that edge server and no longer propagate that
	    journal note to downstream servers.

	#2812368 (Job #127760) **
	    Fixed 'invalid out-of-bounds conversion of DmtStreamPathType'
	    error.

Bugs fixed in 2024.2 Patch 3 (2024.2/2809203) (2025/07/31)

	#2804851, #2777466 (Job #126880) **
	    S3 uploads to AWS no longer fail with files greater than 4Gb in
	    size.

	#2801979, #2795308 (Job #126938) **
	    'p4 login' will now return a distinct error when
	    'dm.user.setinitialpasswd' is disabled and the user has no
	    password set, informing the user that a super user must set their
	    initial password.

	#2801971, #2792404 (Job #127436) **
	    'p4 copy' will now ignore files that only differ by attributes when
	    the 'dm.copy.attributes' configurable is set to 0.

	#2800986, #2790232 (Job #127027) **
	    Edge servers processing obliterates from the upstream server no
	    longer perform full scans of the db.working table.

	#2800845, #2793233 (Job #126602) **
	    If replication is stalled or it is slow, the edge server could send
	    a change-update up to its target server based on an outdated
	    record, and cause data inconsistency. This change prevents such a
	    change-update and returns this message: "Operation failed on
	    remote server because of data inconsistency, possibly due to
	    stalled or slow replication".

	#2800277, #2755654, #2789104 (Jobs #110808, #121743, #123079, #126160,
	#126593) ** *** ****
	    The server no longer sends multiple duplicate certificates from a
	    certificate chain to the client after a 'p4 admin restart'.

	#2800277, #2755654, #2789104 (Jobs #121743, #110808, #123079, #126160,
	#126593) **
	    After restart or failover, the server now reloads relevant
	    network-related configurables and reloads certificates from the
	    certificate file, which prevents a SSL handshake error after
	    failover when the certificate file has been modified. The
	    certificate file is now checked for out-of-order certificates and
	    logs a message ("NetSslEndPoint::Listen() - invalid certificate
	    chain") if any are found, but does not produce an error because
	    these issues often do not cause problems.

	#2799244, #2793768 (Job #127029) **
	    The journal note written by 'p4 obliterate' with the -h and/or -l
	    flags is now correctly re-written to the journal when replayed or
	    replicated.

	#2793725, #2792087 (Job #127398) **
	    The stream spec permission checking is no longer applied to submits
	    to streams that do not include a change to the stream spec.

	#2792657, #2789624 (Job #125649) **
	    Operations like 'p4d -c <command>' that lock all tables now wait
	    for any simultaneous work on partitioned tables to finish before
	    proceeding.

	#2791198, #2766621 (Job #123091) **
	    On a case-insensitive server with server.depot.root set, files with
	    names containing an uppercase character no longer fail to be
	    uploaded to an S3 bucket.

	#2791197, #2764800 (Job #126179) **
	    The compare routine for the lbrRev type used in the storage tables
	    no longer ignores the first "1." part of the field. This was
	    causing problems for imported CVS files.

	#2791146 (Job #124284) **
	    A 'p4 diagnostics -s' request for an strace of the server and
	    associated processes is now supported on Linux platforms.

	#2790599, #2766264 (Job #125471) **
	    Fixed an intermittent 'no write lock' error with journal replay
	    into an offline db when the location of the client.readonly.dir is
	    shared between the p4d server and the offline db.

	#2789592, #2768501, #2770954, #2787777 (Job #126773) **
	    The sync operation no longer causes the database open error to
	    occur on the db.sendq.pt database table when the frequency of
	    syncs is high.

	#2788865, #2787215 (Job #127308) **
	    The modtime of binary files with either the +m modifier or with the
	    modtime option enabled in the client are now correctly passed to
	    altsync agents.

	#2778789, #2773409 (Job #126534) **
	    Fixed the following issue: When doing parallel recovery using
	    multifile checkpoint and the source includes a partitioned client,
	    if the partitioned client-name ends in an underscore followed by
	    eight digits, valid for a multifile checkpoint file sequence
	    number, recovery could fail with an error like
	    "..._00000001.ckp.gz: No such file or directory".

	#2777814, #2746192 (Job #125639) **
	    The journal note type 31 now deletes the respective partitioned-jnl
	    table during the journal replay operation.

	#2774158, #2767902 (Job #123209) **
	    Topology updates from replicas now release locks earlier and no
	    longer wait for replication to synchronize.

	#2773068, #2741593 (Job #125093) **
	    Both 'journalcopy' and 'pull -L' accessing journal-files at the
	    same time could result in bad data in the state file and cause
	    replication to stop. This change fixes the problem.

	#2772883 (Job #123929) **
	    Fixed istat crash due to inconsistencies in stream spec data
	    originating from pre-19.1 servers. Run 'p4d -xf 123929' to fix
	    inconsistent data.

	#2770957, #2749180 (Job #125223) **
	    We were mistakenly checking the permissions to stream spec when
	    doing submit to a classic depot. We have now stopped checking
	    stream permissions when submitting for a classic depot.

	#2743839, #2742376 (Job #125478) **
	    The @ex@ entry in the journal for the partitioned-jnl have table is
	    now generated after the group of @dv@ entries during the
	    respective client deletion operation when the configurable
	    db.partition.dropondelete is unset.

	#2738211, #2737504 (Job #125287) **
	    The partitioned-jnl, partitioned and readonly client types can now
	    be converted into writeable client type.

	#2737616, #2733431 (Job #124867) **
	    The writeable client type can now be converted into partitioned,
	    partitioned-jnl or readonly client type. If there are any opened
	    files, then the conversion to readonly client type results in an
	    error.

	#2736502 (Job #124603) **
	    A checkpoint created using '-jc' with more than a single thread
	    enabled that contains partitioned clients could place the
	    db.config table entries after those for the partitioned clients,
	    making it unrecoverable.

	#2736168 (Job #124604) **
	    When recovering a checkpoint containing partitioned clients that
	    mismatches the case of the server, a parallel recovery would
	    report an extra spurious error about a missing configurable. This
	    has been fixed.

	#2736162, #2726952 (Job #124578) **
	    Parallel checkpoints were incorrectly taking a read lock on the
	    db.monitor table and not releasing it until the checkpoint had
	    completed. This has been fixed.

	#2735980, #2734766, #2735348 (Job #125218) **
	    Fixed delta transfer server failure with error message about moving
	    a file pointer before the beginning of a file.

	#2733651, #2727978 (Jobs #124938, #125151) **
	    'p4 reload' on an edge server no longer crashes on reloading a non
	    partitioned client.

	#2733645 (Job #124865) **
	    The correct error message is now displayed during the conversion of
	    partitioned or partitioned-jnl clients with opened files to a
	    readonly client.

	#2733642 (Job #124748) **
	    The conversion between the partitioned-jnl and the readonly or
	    partitioned client types now updates partitioned have tables on
	    the replica servers appropriately.

Bugs fixed in 2024.2 Patch 2 (2024.2/2726408) (2025/02/27)

	#2722541, #2708446 (Job #124496) **
	    The 'p4 diagnostics' command now produces a 'topology.dot' file in
	    the diagnostics directory. This file is in graphviz format that
	    can produce a graphical diagram of the network topology.

	#2722257, #2719311 (Job #120859) **
	    Fixed excessive scanning of db.revsh by 'p4 verify -S' on a shelf
	    containing many files marked for delete.

	#2719772, #2705985 (Job #124350) **
	    'p4 diagnostics' returns a 'file not found' error if a logfile is
	    not configured on the server. This has been fixed.

	#2719510, #2717964 (Job #124712) **
	    In rare cases the setup to run p4diag automatically can fail on
	    Windows Server 2022 Enterprise without a desktop installed. This
	    has been corrected.

	#2719309, #2715482, #2719024 (Jobs #121960, #117688) **
	    'p4 switch' performed a sync to #have which could remove all
	    unmodified files from a user's workspace if the user had
	    previously switched streams using the '--no-sync' option. The sync
	    to #have was added to switch in 2024.1 to address an issue found
	    related to pruned files. This fix removes that sync to #have from
	    the 'p4 switch' logic in favor of updating how 'p4 switch' uses
	    reconcile to avoid the issue with pruned files.

	#2717517, #2711526 (Job #124613) **
	    Setting 'auth.ldap.ssllevel=2' on a Windows server will no longer
	    allow connections to LDAP servers with self-signed certificates
	    unless that certificate is installed into the CA store or is
	    specified with 'auth.ldap.cafile'.

	#2717515, #2716524 (Job #123694) **
	    Edge servers will no longer reject submit commands if a depot not
	    involved in the submit has less free space than the
	    'filesys.depot.min' threshold.

	#2716108, #2705691, #2706864 (Job #122189) * ** *** ****
	    When using either the tcp64 or ssl64 protocols (IPv6 or IPv4), IPv4
	    addresses are now always formatted as IPv4 addresses rather than
	    mapped IPv6 addresses.

	#2715355, #2711976 (Job #122574) **
	    The command 'p4 -c readonlyclient client -d writeableclient' with
	    the partitioned type now successfully deletes the client.

	#2715260, #2713178 (Job #124533) *
	    Fixed an issue that causes a parallel sync to sometimes produce
	    zero-byte binary+F files when connected to a Unicode server.

	#2714515 (Job #121788) **
	    'p4 verify -v -U' was not fixing bad digest or size in the unload
	    depot. This change fixes the problem.

	#2713832, #2709467 (Job #124534) **
	    Serverlocks on Windows servers are no longer deleted in such a way
	    that on rare occasions synchronous operations could occur in
	    parallel.

	#2711966 (Job #122581) **
	    'p4 diagnostics' now reports the directory name it creates in the
	    current directory and the types of diagnostics files produced
	    within that directory.

	#2710884 (Job #122999) **
	    The 'p4 diagnostics' command now uses the server's timezone to
	    construct the name of the output directory on the client.

	#2709876, #2704294 (Job #122963) **
	    On an edge server with submit.allowbgtransfer=1 and
	    submit.autobgtransfer=1, when a file edit is submitted without
	    change, the option '-f submitunchanged' of submit would fail to
	    override 'revertunchanged' from the client spec. This would result
	    in the submit failing with: "No files to submit". This change
	    fixes the problem.

	#2707699, #2705995 (Jobs #124317, #124320) * **
	    P4ALTSYNC agents are now provided with a 'time' field containing
	    the modtime to set on add/added files of type +m or when the
	    modtime client option is enabled.

	#2707194 (Job #124164) *
	    Include server version in altsync protocol.

	#2705683, #2702307 (Job #123764) **
	    'p4 diagnostics' could fail with an 'infinite loop' error if the
	    topology table contained a large number of broker or proxy entries
	    that did not have a serverID set. These records are now ignored.

	#2705178, #2703054 (Job #124145) **
	    Fixed a conflict between writable components and Ignored paths.

	#2704865, #2704826 (Job #124281) **
	    'p4d -jd' no longer creates empty directories for partitioned
	    clients.

	#2704302 (Job #124006) **
	    Changed the k-value for configurable 'net.delta.transfer.minsize'
	    from 1 to 1024.

	#2704119, #2702148 (Jobs #124070, #121658) **
	    Checkpoint files created with the parallel and multifile options
	    now use a '#' character to mark the start of the batch number
	    encoded within the filename. Previously the server would use a '_'
	    character that could clash with a client name for a partitioned
	    client.

	#2702391, #2700625 (Job #123919) *
	    With AltSync client on Windows concurrent multiple 'p4 sync'
	    commands could fail with "All pipe instances are busy". Problem is
	    now fixed.

Bugs fixed in 2024.2 Patch 1 (2024.2/2697822) (2024/12/18)

	#2697082, #2689388 (Job #122377) **
	    'p4 submit' on edge could fail when a changelist had a lot of files
	    with long paths due to edge running out of rpc buffer. This change
	    fixes the problem by sending lock requests in batches. The number
	    of files in each batch is controlled by the setting in the
	    configurable dm.locks.global.batch.net (default is 10,000).

	#2696849, #2689932, #2693095 (Job #120059) **
	    There was a race condition between directory removal and archive
	    creation on an edge during a 'p4 submit -e' for binary file types.

	#2696246, #2695495 (Job #123050) **
	    For 'p4 changes -m <max> -e <change>' it would excessively scan
	    records from db.change. This change fixes the problem.

	#2694774, #2691611 (Jobs #123904, #122088) **
	    Deletion of a partitioned database table now deletes only the
	    numbered partitioned directory.

	#2694762, #2691574 (Jobs #123912, #123992) **
	    A partitioned database table path could be incorrectly parsed. This
	    has been fixed.

	#2694104, #2689260 (Job #123774) ***
	    Reuse of a ClientApi object across connections that involve a proxy
	    no longer causes "Unknown command" errors after client statistics
	    should have been reported to the server.

	#2692845, #2688723 (Job #123797) **
	    Delta commit against a file with missing server-side content for
	    the prior revision, or against a deleted prior revision could fail
	    with a "zero length chunk map" error.

	#2689409, #2689296 (Job #123856) **
	    The 'svrRecType' topology field is no longer unset during replica
	    restart when an upstream server is older than 2022.2.

	#2687980, #2686689 (Job #123487) **
	    `p4 verify -t` can now be run on unicode enabled servers.

	#2687447, #2678893 (Job #123279) **
	    'p4 changes --explain' is updated to include descriptions for
	    --user-case-insensitive and --client-case-insensitive.

	#2685672 (Jobs #123022, #119098) **
	    The sync operation no longer causes the database open error to
	    occur on the db.sendq.pt database table.

	#2685390 (Job #123351) **
	    'p4 logexport' now performs more thorough validation of endpoint
	    addresses.

	#2684738, #2683230 (Job #123521) **
	    Clients of 'readonly' type now work correctly as revision
	    specifiers.

	#2684730, #2676128 (Job #123359) **
	    The commands 'p4d -K db.have.pt' and 'p4d -k db.have.pt' now
	    exclude and include all the available partitioned have tables.

	#2684728 (Job #122687) **
	    Commands that specify multiple arguments using different
	    partitioned clients as the revision specifiers will now return the
	    correct results for each argument.

	#2683843, #2682685 (Job #123438) **
	    Prevent crash on journal replay with an update, then delete, of a
	    db.config record with a specific serverID within the same journal.

	#2682374, #2680592 (Job #123443) **
	    Commands run through a broker and then forwarded to another server
	    will no longer cause hangs for successive commands run on the same
	    connection after a client could have reported client stats.

	#2681776 (Job #123024) **
	    p4 diagnostics and the lock reporting subsystem of the monitor now
	    parse the old output format of 'lsof' correctly.

	#2680577, #2677295 (Job #121121) **
	    Corrected an unexpected 'Files are missing as a result of one or
	    more move operations' error in the fetch, push, and zip commands.

	#2680298, #2679606 (Job #123346) **
	    A 'p4 sync' on an edge server with lbr.replication=cache could
	    cause server to hang. This change fixes the problem.

Bugs fixed in 2024.2 (2024.2/2675662) (2024/10/31)

	#2672959, #2673508 (Job #123250) **
	    Security fix. Addressed CVE-2024-10314, CVE-2024-10344 and
	    CVE-2024-10345

	#2667309, #2670380 (Job #123015) **
	    Fixed locking order bug when obliterating a stream and the
	    configurable index.domain.owner is 1.

	#2666580 (Job #123094) * ** *** ****
	    OpenSSL has been upgraded to 3.0.15

	#2665940, #2668113, #2670007 (Job #123034) **
	    Setting a trigger command to an empty string will now result in an
	    error on execution rather than allow the undefined behavior.

	#2665020, #2666238 (Job #122929) **
	    Revert 'track' configurable default value back to '-1'.

	#2664057 (Job #122520) **
	    Parallel dumps, 'p4d -jdp', did not support filtering for replicas
	    (-P). This has been fixed.

	#2663219 (Job #122411) **
	    In rare cases an unshelve performed by Swarm can cause a crash.
	    This has been corrected.

	#2662475 (Job #120460) **
	    Tamper checking in commands that update the have list has been
	    improved.

	#2661232, #2664152 (Job #122784) **
	    Corrected crash when authentication fails during istat operation.

	#2660919 (Job #117647) **
	    A crash in 'p4 transmit -r' has been corrected.

	#2660734, #2664338 (Job #120977) **
	    Fixed a problem where a user with openstreamspec permission could
	    open a stream spec but not edit the stream spec. Also fixed a
	    problem where a user with writestreamspec permission could not
	    edit and save a new stream spec.

	#2659944, #2668483, #2669324 (Job #122639) **
	    Unlimited group Timeout setting fixed.

	#2658234 (Jobs #122163, #122162) * **
	    Using the 'shelve' command to overwrite a previously shelved stream
	    spec now requires that the user provide the '-f' parameter.
	    Previously the 'shelve' command would overwrite an already shelved
	    stream spec without warning the user, this led to users
	    unintentionally losing those previously shelved changes.

	#2657745 (Job #121673) **
	    Uploads to S3 that generate a response code error between 500 and
	    599 are now retried up to lbr.s3.uploadretries number of times.
	    The default of lbr.s3.uploadretries is 5.

	#2656176 (Job #122643) **
	    Promoting shelved changes with the `-p -c` flags also incorrectly
	    shelved any open stream specs prior to the promotion.

	#2655935 (Job #122569) * **
	    cURL has been upgraded 8.10.1

	#2654300, #2657799 (Job #122472) **
	    A rare infinite loop caused by an over-optimisation when scanning
	    the rev table has been fixed.

	#2652980 (Job #113058) **
	    Fixed stream spec obliterate problem where a super or admin user
	    could not obliterate the stream spec if configurable
	    'dm.protects.streamspec' was set to 1.

	#2652798 (Job #122446) **
	    Command tamper checking integrity has been improved and now uses
	    SHA256 by default. The 'security.digest' configurable maybe used
	    to choose an alternative hashing algorithm.

	#2650419, #2650448 (Job #119098) **
	    The deletion of the partitioned client now ensures that the
	    numbered partitioned client directory is deleted as well.

	#2649655, #2650687 (Job #121134) **
	    Fixed istat crash with noinherit ParentView when db.bodtextcx rows
	    are missing.

	#2648564 (Job #122076) **
	    The command-line client on Windows now prints an error when it
	    detects ambiguous argument encoding.

	#2648445 (Job #108593) **
	    A 'p4 submit' on an edge-server can fail with an "Unknown command"
	    error if it is submitting a large number of files with long
	    path-names all together in one changelist. This has been fixed to
	    report a more meaningful error message, "Rpc buffer too big to
	    send!".

	#2648278, #2654563 (Job #122088) **
	    The empty partitioned have directories are no longer created.

	#2648198 (Job #121666) **
	    Using S3 for archive files can raise 'file not found' errors
	    when the files are accessed concurrently by multiple
	    clients. This has been fixed.

	#2648197 (Job #117955) * **
	    The zlib deflate operation uses x64 instructions not supported on
	    older CPUs raising an illegal instruction exception. This has been
	    fixed.

	#2645910 (Job #122240) **
	    When the configurable 'client.sendq.dir' is set, the partitioned
	    have table is now unlocked and removed during the deletion of the
	    respective partitioned client.

	#2644332 (Job #122058) **
	    Fixed a memory leak when pull-archive triggers are used to
	    perform archive file transfer.

	#2644014 (Job #121944) * **
	    Added net.delta.transfer.minsize and net.delta.transfer.threshold
	    to 'p4 help configurables'. These configurables allow the Helix
	    Core Server and individual clients to enable and disable delta
	    transfer for binary files based on the file size and amount of
	    change between current and prior revisions.

	#2643135, #2643915 (Job #121830) **
	    A recovery operation can fail when the checkpoint file contains
	    multiple partitioned clients. This has been fixed.

	#2639860 (Job #122043) **
	    The commands 'p4d -k -jd' and 'p4d -K -jd' now successfully filter
	    the partitioned have tables as expected.

	#2638204 (Job #119735) **
	    On Windows, network share access permissions for RCS depot archives
	    can cause a crash.  This has been resolved.

	#2637834 (Job #121380) **
	    'p4 reshelve' will now copy shelved stream specs from the source
	    shelf to the destination shelf. The default behavior of reshelve is
	    that it will copy shelved files and stream specs, however this
	    behavior can be controlled by the two new parameters, -Af and -As.
	    If -As is provided then only the shelved stream spec will be
	    copied. If -As is provided then only the shelved files will be
	    copied.

	#2635787, #2636780 (Job #121863) **
	    Fixed a problem where a command following a stream obliteration
	    might give an error the obliterated stream was unknown. The
	    problem only occurred with P4API clients.

	#2632658, #2637044, #2640867 (Job #120711) **
	    The auto pull operation now updates the 'lastSeenDate' field of the
	    respective 'connect' type topology record across the servers.

	#2632065, #2633518 (Job #121790) **
	    If a virus scanner locks a portion of an RCS temp file during
	    a pull operation, a crash may occur. This has been corrected.

	#2631147 (Job #120839) **
	    Failed login delay will now take an exclusive server lock on the
	    client address.

	#2629083 (Job #119346) **
	    In case of a commitServer-Edge-ForwardingReplica chain, there was a
	    problem where on ForwardingReplica a 'p4 submit' after
	    Integ/Resolve could fail because archive files were missing on the
	    Edge server. This change fixes the problem by pulling the missing
	    archive-files for the Edge server when needed, allowing 'p4
	    submit' to succeed.

	#2628801 (Job #120764) **
	    Removed unnecessary error "Error object passsed to database already
	    with an error" when attempting to switch a stream workspace with
	    unresolved issues.

	#2627474 (Job #121555) **
	    When 'dm.user.hideinvalid' is enabled, non-existent users no longer
	    suppress the autologin prompting.

	#2627098 (Job #120925) **
	    Fixed a sparse stream integration problem where an integrate to the
	    sparse stream from the parent was required after an integrate from
	    the sparse stream to parent, even if no changes had occurred in the
	    parent after the first integration.

	#2626264 (Job #121554) *
	    The file system interface now supports the setting of multiple
	    extended attributes with a single system call on Windows. This
	    improves VFS performance.

	#2625760, #2626412, #2628458, #2628645, #2629302 (Job #121621) **
	    Setting a very low value of db.checkpoint.reqlevel can allow a
	    multifile parallel checkpoint or dump to skip small db.files.
	    This has been fixed.

	#2623815, #2625761, #2626380 (Job #121575) **
	    The DateTime server type is now defined as a 64 bit signed integer
	    rather than the system defined time_t. This help interoperability
	    with 32bit clients.

	#2623790 (Job #121563) **
	    'p4 user -Dy' will no longer cause replication of an edge server to
	    hang.

	#2620569 (Job #119795) **
	    For p4 fetch', if '-I' flag is used the command could fail
	    unexpectedly with a 'Cannot import' error. This change fixes
	    the problem.

	#2619224, #2622942 (Job #121237) * **
	    A new client side configurable 'net.delta.transfer.threshold' has
	    been added to specify the maximum percentage of file size to
	    perform a delta transfer before reverting to streaming the
	    complete file for 'p4 submit' of binary+F files. A value of 0
	    disables the delta transfer.

	    On a low-bandwidth remote client, a small reduction in file
	    transfer would provide performance gain therefore a higher
	    threshold for the delta transfer would be beneficial; whereas
	    on a client with faster network, a low or zero threshold
	    would avoid the overhead incurred by the delta transfer.

	#2617863, #2622232 (Jobs #121296, #121297) **
	    Fixed a crash in 'p4 fstat -Sr -Or /outside/of/workspace/file'.

	#2615605, #2622231 (Job #121279) **
	    Improved 'p4 submit' performance with delta transfers by removing
	    extraneous resource locking on the p4d server.

	#2613383 (Job #121119) ** ***
	    Fix for client 'clobber' option being dropped when syncing
	    through a proxy.

	#2611770, #2611791 (Job #121151) **
	    'p4 integ' now correctly integrates the files related to the
	    partitioned-jnl type clients.

	#2611612, #2611624 (Job #121150) **
	    'p4 unshelve' now correctly unshelves the files in the
	    partitioned-jnl client workspaces.

	#2611471, #2611480 (Job #121143) **
	    'p4 reconcile' now correctly handles the partitioned-jnl client
	    workspaces.

	#2611120 (Jobs #120640, #120253) **
	    Using an edge client to populate a stream failed with the error,
	    "file(s) not in client view", when stream components were
	    disabled.

	#2609870, #2610983, #2611896, #2612833, #2617061, #2618069 (Job
	#121091) **
	    Fixed reversion of an open stream spec when using the command
	    'p4 revert -a -Si filelist...'.

	#2609726, #2610446 (Job #121059) **
	    Parallel sync now works correctly from a partitioned client when
	    'client.sendq.dir' is also set.

	#2609587 (Job #120982) **
	    Fixed 'rmt-fileExistsReplica' not exiting properly on commit-server
	    if the calling replica is missing the ExternalAddress field in its
	    server spec.

	#2609119, #2609372, #2609822, #2610994, #2612813, #2617296 (Job
	#121079) **
	    Fixed reversion of an open stream spec when using the command
	    'p4 revert -n -Si filelist...'.

	#2609107, #2609848, #2610973, #2611912, #2617328, #2618078 (Job
	#120791) **
	    Fixed stream obliterate endless loop problem.

	#2607904, #2635328 (Job #120522) **
	    To ensure the consistency among the servers, the 'partitioned-jnl'
	    type client cannot be set or created until all upstream servers have
	    been upgraded to at least 2024.1 server version.

	#2607484, #2609805 (Job #120840) **
	    If a Helix Core Server is configured with no logging, a crash may
	    occur. This has been corrected.

	#2606707 (Job #120873) **
	    In very rare cases, a CPM, DOS or early Windows text file may use a
	    Ctrl-Z as an EOF marker.  Now when such a text file is appended,
	    the EOF is marker is removed before extending the file content.

	#2604549, #2604916 (Jobs #120774, #120775, #120913, #120914, #120916,
	#120918, #120919) **
	    The partition client have tables now encode the invalid filesystem
	    characters.

	#2603099 (Jobs #120824, #120744) **
	    Fixed an error message when unshelving a sparse stream spec which
	    has a lower parent stream changeview than the current stream spec.
	    The previous error message did not make sense in an unshelving
	    context.

	#2602592, #2624868, #2625699 (Job #115232) **
	    This change introduces a new flag, -E, for p4 copy. The -E flag
	    overrides the current setting for the 'dm.integ.tweaks'
	    configurable and its effect is the same as having
	    'dm.integ.tweaks' set to 32. This flag, similar to the
	    configurable 'dm.integ.tweaks', is kept undoc.

	#2602208 (Job #120541) **
	    'p4 unload' and 'p4 reload' operations can now be performed on
	    'readonly' type clients.

	#2601845 (Job #120592) **
	    The correct error message is displayed when trying to convert any
	    client type to 'readonly' client type.

	#2601555 (Job #120765) **
	    Disabled 'p4 unshelve -S' when the current stream is a sparse
	    stream, since unshelving non-resident files into a sparse stream can
	    lead to undesirable behavior.

	#2599439, #2599448, #2599449, #2600088 (Job #119766) **
	    Fixed a problem where switching to a sparse stream at a change
	    would sync parent files at the head revision rather than at the
	    sparse stream changeview change.

	#2599433, #2600195 (Job #120642) **
	    Fixed crash with stream command when server license has expired.

	#2599132 (Job #120602) **
	    There is a rare failure situation that was causing p4d to crash. P4d
	    now outputs an error instead in this case: "No <field> was found
	    for this operation."

	#2599010 (Job #120741) **
	    Integrating a deleted file into a file that is currently open for
	    branch will no longer report "all revisions integrated".

	#2597611 (Job #110263) **
	    This change fixes a performance problem in 'p4 obliterate' where it
	    was causing excessive time on edge-server to purge related db.label
	    records.

	#2597548 (Job #119772) **
	    Fixed a journal inconsistency issue on non-Windows platforms caused
	    by killing a running p4 command.

	#2597197 (Job #108319) **
	    Fixed a case in which old revisions of a file that had been deleted
	    and re-added multiple times were reported as candidates for
	    integration into a different re-added variant of the file.

	#2596797 (Job #93116) **
	    Fixed a case in which a cherry-picked ignore into a moved file
	    caused an earlier changelist to be reported by 'p4 interchanges'.

	#2595243, #2599428, #2600086 (Job #120533) **
	    Fix for "Invalid changelist number 0" when creating a sparse stream
	    just after an upgrade.

	#2595242 (Jobs #74403, #79365, #87038, #92184, #103277) **
	    Integration now includes ancestor branches of the source file when
	    computing the set of outstanding changes. In most cases this
	    distinction doesn't matter because the source file implicitly and
	    recursively inherits changes from ancestor branches, but including
	    the individual revisions of these files in the debit calculation
	    produces better results in complex cases involving backed out
	    changes (e.g. via 'p4 copy' and/or 'p4 undo').

	#2594041 (Job #87618) **
	    Ignored branch records resulting from a cherry-pick now only
	    grant credit for the cherry-picked revisions, rather than
	     implicitly including all prior revisions as is the case for a
	    normal branch record.  This fixes a problem in which an ignored
	    branch of a file that was copied from an old revision did not
	    grant any credit at all on subsequent integrations.

	#2594024 (Job #121240) **
	    The 'p4 lock' and 'p4 unlock' commands can now be cancelled by using
	    'p4 monitor terminate' or pressing Ctrl-C on the client.

	#2591718 (Job #114829) **
	    For 'p4 fstat' locking db.revcx for long period could block other
	    commands like 'p4 submit' to run simultaneously. This change fixes
	    the problem by altering db.revcx lock mode to PEEK mode, if
	    db.peeking is set to greater than 2.

--------------------------------------------------------------------------

Major new functionality in 2024.1 (2024.1/2596294) (2024/05/09)

	#2565297 (Job #101641, #108660) ** ***
	    Commit servers are now able to verify and fetch missing/corrupted
	    archives from replicas.
	    Running 'p4 verify -t' on commit will add any missing archives
	    to the journal to be replicated to downstream replicas.

	    A background thread is run during journal replay on the replica to
	    check if the file exists and that the digest matches; if it matches,
	    this will notify the upstream commit which will add the archive
	    to 'rdb.lbr' and launch a background pull thread which will end
	    once all the pending records are processed.

	    If the archive does not exist on the replica, then it will add its
	    own journal entry for any further downstream replica server.

	    New f_integrityEvent=12 added to structured logs; this is within the 
	    Integrity structured log category.

	    On the replica server, the `f_results` will be one of:
	    * unknown (commit) - if the depotFile/rev could not be found in
	                         either db.rev or db.revsh.
	    * open failed (replica) - if the archive could not be opened for any
	                              reason.
	    * mismatch (replica) - if the digest does not match.
	    * match (replica) - if the digest matches the digest of the archive
	                        requested by the commit.

	    On the commit server, the `f_results` will be one of:
	    * unknown (commit) - same reason as on the replica.
	    * match (commit) - the archive already exists and the digest matches
	                       meaning that it could have already been pulled
	                       from another replica.
	    * pending (commit) - if multiple replicas notify the commit of
	                         having the archive; only the first one will be
	                         added to rdb.lbr.
	    * fail (external address) - if no externalAddress is set on replica.
	    * fail (commit) - there was an error while adding to rdb.lbr.
	    * success (commit) - the archive was added to rdb.lbr.

	#2565074 (Job #116045) **
	    Introduces a new partitioned client type 'partitioned-jnl' to enable
	    the journaling, recovering, dumping, checkpointing and replicating
	    'partitioned have tables'.

	    Journaling the partition have table with the client type
	    'partitioned-jnl':

	    During journaling, the partitioned-jnl have table, 'db.have.pt',
	    is encoded with its respective client name. For example,
	    'db.have.pt%pclientname' in the journal file.

	    During the partitioned client deletion, the records are deleted from
	    the respective partitioned have table and then the table is dropped
	    for the partitioned client types 'readonly', 'partitioned' and
	    'partitioned-jnl'. The records deletion and the table drop events
	    are logged in the journal file for the partitioned-jnl client type.
	    For this table drop, a new journal note (31) is introduced. This
	    helps to recover the deleted partitioned-jnl have table later.

	    A new configurable 'db.partition.dropondelete' is introduced. When
	    this is set, the individual records are not deleted but the table
	    is deleted for the client types 'readonly', 'partitioned' and
	    'partitioned-jnl'. This deletion is followed by the respective
	    new journal note for the client type 'partitioned-jnl'.

	    During the creation of the partitioned have tables, if the
	    partitioned client names have spaces (' ') then these are replaced
	    with underscores ('_h).

	    Dumping the partitioned have table:

	    Enables the dumping of the partitioned have tables using 'p4d -jd'
	    command for the client types 'readonly', 'partitioned' and
	    'partitioned-jnl'. For dumping a single table, the partitioned have
	    table must be appended with the respective partitioned client
	    '%pClientName'. For example, 'p4d -jd - db.have.pt%pclient'.
	    Otherwise, it would result in an error.
	    When dumping all the tables, the partitioned have tables with the
	    client types 'partitioned' and 'readonly' are not dumped to ensure
	    that these are not recovered during the replay operation.
	    The parallel options for dumping partitioned have tables are
	    supported, 'p4d -jdp' and 'p4d -jdpm'.

	    Checkpointing the partitioned have table with the client type
	    'partitioned-jnl':

	    Enables checkpointing the partitioned-jnl have tables using the
	    commands 'p4 admin checkpoint' and 'p4d -jc'.
	    The parallel options for checkpointing partitioned-jnl have tables
	    are supported, 'p4d -jcp' and 'p4d -jcpm'.

	    Recovering the partitioned have table with the client type
	    'partitioned-jnl':

	    Enables replaying the partitioned-jnl have tables using the command
	    'p4d -jr'.

	    The overriding mechanism of the configurable 'client.readonly.dir'
	    during the journal replay is as follows:
	    If the configurable 'client.readonly.dir' is empty on the server on
	    which this replay is run, then, by default, this configurable will
	    be set with the value captured from the journal.
	    A new extended flag '-o' has been introduced for this operation
	    with the usage syntax as 'p4d -jro'.
	    If the configurable 'client.readonly.dir' is already set and there
	    is a new value in the journal then it will be overridden with this
	    new value if the journal restoration is run with '-jro' option.
	    Otherwise, the configurable is not overridden with the new value.

	    The overriding mechanism of the configurable 'client.readonly.dir'
	    during the checkpoint replay is as follows:
	    If 'p4d -jr' is run in a non-empty directory, the configurable
	    'client.readonly.dir' maintains the already existing value if one
	    exists.
	    If 'p4d -jr' is run in an empty directory, the configurable
	    'client.readonly.dir' is set.
	    If 'p4d -jrF' is run in a non-empty directory, the existing
	    'client.readonly.dir' configurable is overridden.
	    'p4d -jro' has no significance in the checkpoint replay. It is
	    applicable only for the journal replay.
	    The parallel option for the replay of partitioned-jnl have tables
	    is supported, 'p4d -jrp'.

	    The 'p4d -h' command outputs this new journal restoration option
	    '-jro'.

	    Enhancing the P4 client and server commands to process the
	    partitioned have tables:

	    The partitioned have tables are processed by the P4 client and
	    server commands. A few have been addressed here:

	    'p4 dbstat': The 'p4 dbstat' command processes the partitioned have
	    tables.

	    'p4 journaldbchecksums': The command 'p4 journaldbchecksums'
	    processes the partitioned have tables with the client type
	    'partitioned-jnl' and ignores the 'reaonly' and 'partitioned' client
	    types. The journal note checksums that are replicated, are processed
	    on the replica servers for the partitioned-jnl have tables integrity
	    check.
	    'p4 journaldbchecksums -t' and 'p4 journaldbchecksums -T' commands
	    with a specific partitioned have table results in a usage error.
	    'p4 journaldbchecksums -u' ignores the partitioned have tables.

	    'p4 unload' and 'p4 reload': The partitioned clients of type
	    'partitioned' and 'partitioned-jnl' can be unloaded and reloaded.
	    Especially during the unload operation, instead of deleting the
	    individual records from the respective db.have.pt table, the table
	    by itself is deleted. The table drop journal note is also added
	    in the journal for the client type 'partitioned-jnl'.

	    'p4 changes -m<maxChanges> @pclient': The command 'p4 changes
	    -m<maxChanges> @pclient' outputs the addressed maximum latest
	    submitted changes for the revisions of the files that are on the
	    specified partitioned client's have list.

	    'p4 dbverify' and 'p4d -xv': The partitioned have tables are
	    validated or verified using the 'p4d -xv' and 'p4 dbverify'
	    commands.
	    A new configurable, 'db.partition.verify', is introduced. By
	    default, this is set. If the partitioned clients do not exist, then
	    the partitioned have tables are not validated or verified.

	    'p4d -xx': Enables the table pair integrity check for the tables
	    'db.working' and 'db.have.pt'.
	    The table 'db.have.pt' represents all the available partitioned have
	    tables (db.have.pt%pclient).
	    In this operation, the presence of the related entries with respect
	    to the partitioned have clients from the db.working table is checked
	    in the respective db.have.pt tables. If not found, then the delete
	    instruction related to the entry in db.working is placed in the
	    jnl.fix file. The non-partitioned client entries from the db.working
	    table are ignored.

	    'p4d -xvU': The command 'p4d -xvU' performs the table-not-unlocked
	    database check for the partitioned have tables.

	    For the details, please read the server documentation.

	#2573125 (Job #119059) * **
	    Commits to files of type 'binary+F' now use a delta transfer
	    mechanism to only send the modified portion of file content from
	    the client to the server.  This is primarily an optimization for
	    low-bandwidth remote users, but also helps reduce server-side CPU
	    usage generally.

	    The new 'net.delta.transfer.minsize' configurable can be set to zero
	    on the server to disable delta transfers globally.  When set to zero
	    on the client, it disables it locally.  Other values on the client
	    represent the minimum file size that a delta transfer will be
	    performed on.

	    Limitations:
	      - Delta transfer of commits through an edge-server is
	        only available via background submits ('p4 submit -b').
	      - Proxy cache-on-submit does not cache delta transfer content.

	#2549738 (Job #117985) **
	    The Sparse Stream feature adds 2 new types of streams, sparsedev and
	    sparserel streams. A client of a sparse stream has view mappings for
	    both the parent and child stream depot paths, overlaid into a single
	    client path. The parent depot paths are fixed to a specific change
	    number; that change number is automatically updated during
	    integrations into the sparse child.
	    
	    When a sparse stream is first created, parent files within a share
	    path are not branched, and the sparse stream contains no depot
	    files. The first time a file within a sparse share path is opened
	    for edit, the file is immediately branched into the sparse stream.
	    
	    Sparse streams are truly sparse, since branching only occurs when a
	    file needs to be changed and the bulk of files that are visible in a
	    sparse stream reside solely in the parent's depot path.
	    
	    Sparse streams are intended to be used with a small number of
	    branched files. To that end, a configurable has been added to limit
	    the number branched files: dm.stream.sparse.branchmax (default 100k,
	    0 removes limit).
	    
	    Once the number of branched files reaches the branch max limit, a
	    sparse stream may be converted to a development or release stream
	    equivalent with the stream sub-command 'p4 stream convertsparse'.
	    
	    Sparse streams have a number of restrictions:
	        - No reparenting; sparse stream parents are fixed.
	        - No partial integrations: only full stream integrations are
	          allowed, and the only revision limit allowed is @<=change.
	        - Each stream must have at least one share path.
	        - No unshelving from a different stream.
	        - No undo.
	        - No editing of pin after any files are populated or added into
	          the sparse stream; the pin may be updated only through
	          integration.
	        - ParentViews are always 'inherit'.
	        - Sparse streams cannot be consumed as components of other
	          streams.
	        - Sparse streams cannot have non-virtual stream children.
	        - Sparse streams can have virtual stream children, but virtual
	          children of sparse streams cannot have children and cannot be
	          integration targets.
	        - Non-sparse streams cannot be converted to sparse streams.

Behavior Changes in 2024.1 (2024.1/2596294) (2024/05/09)

	#2525336 (Job #108001, #117238) **
	    When running 'p4 integrate', 'p4 copy', and 'p4 merge' within a
	    stream client to integrate changes from another stream into the
	    current stream, a stream view is now required, in order to prevent
	    users from accidentally circumventing integration policies defined
	    on a stream by using a manually generated branch view to perform
	    integrations.  Integrations that use manual views but that do not
	    appear to be an attempt to integrate from one stream to another
	    (e.g. where the source is a classic depot) are still permitted.
	    When a stream-to-stream manual integration is detected, an error
	    is now produced along with a suggested alternate command that will
	    use the stream view; in many cases the suggested command may
	    produce the same result that the original command would have.
	    Users and client applications wishing to avoid this error should
	    do one of the following:
	      1. Use a stream view as suggested by the error message.
	         This is the preferred solution since it is the only way to
	         prevent errors that may be caused by manually defined views.
	      2. Set the "api" protocol variable to 95 or lower.  For
	         compatibility purposes, this check is not performed for older
	         client applications, as determined by the "api" variable.
	         Note that client applications built with API libraries before
	         2024.1 will have a corresponding "api" value set by default.
	         Scripts that call the p4 CLI directly and wish to minimize
	         command output changes should always use "-Zapi=N" to set a
	         specific API compatibility version.
	      3. Use the "-F" flag (which is now accepted by "p4 integrate"
	         for this specific purpose) to override this check.

Minor new functionality in 2024.1 (2024.1/2596294) (2024/05/09)

	#2591319 (Job #118242) **
	    All depots types except "remote" can now be backed by S3.

	#2587740 (Job #120109) ** *** ****
	    The mimalloc memory allocator library has been upgraded to 2.1.2.

	#2584762 (Job #119816) **
	    New configurable 'dm.user.hideinvalid' can be set to 1 to hide
	    user specific errors when running 'p4 login' and 'p4 passwd' with
	    an invalid user.

	    With it enabled, 'p4 login' and 'p4 password' will follow the normal
	    authentication process even if the user does not exist and will
	    output an invalid password error or an authentication failure error
	    for ldap.

	    This does not affect 'p4 users' which can still reveal valid users,
	    see 'run.users.authorize' configurable for more information.

	#2584270 (Job #120133) **
	    All structured log events at version 58 now record the formatted
	    date (column 3: f_date) in ISO8601 format.
	    
	    The 'serverlog.version.N' configurable can be used to pin a
	    structured log file to a specific server version's format.
	    To retain the prior structured log events format, set the
	    'serverlog.version.N' configurable to 57.

	#2580017 (Job #105450) **
	    This change helps customers with a reminder when they need to do
	    journal rotations. At login if the last journal rotation is older
	    than a set threshold days a warning will be displayed for admins
	    and users of type operator.
	    The threshold is set through a configurable:
	        db.journalrotate.warnthresh.
	    By default this threshold is unset ( it is 0 )  which means no
	    warning will be displayed. Its maximum is 365 days.

	#2566505 (Job #110500) **
	    This change introduces a new option, -Fd, for 'p4 client' that when
	    used along with the -fd option it will delete the client together
	    with all its shelved files.

	#2564827 (Job #119620) **
	    'p4 labelsync' and 'p4 tag' now apply the label to all file
	    arguments sequentially, such that if multiple arguments reference
	    the same depot file at different revisions, the last argument to
	    reference a given file is used to determine which revision is
	    stored in the label.

	#2558783 (Job #119168) **
	    With this change it is now possible to reset password with
	    'p4 resetpassword' when auth.sso.allow.passwd is set to 1 and user
	    has AuthMode set to 'perforce'. Previously this was failing with
	    error "Cannot reset password with external authentication".

	#2554775 (Job #117979, #118152) **
	    'p4 configure help' now includes '...Option0' to '...Option[N-1]'
	    fields for accepted/possible values for string type configurables. 

	#2552035 (Job #119111) **
	    When resolving a filename change with a different depot file
	    synced to the workspace location that the open file needs to move
	    to, the existing file is now automatically unsynced in order to
	    allow the move to proceed. Note that if the resolved file is then
	    reverted, the original file is not automatically resynced.

	#2551155 (Job #077851) **
	    The 'p4 client', 'p4 branch', and 'p4 label' specs now support
	    comments in the 'View' section by using ##. You can append a ##
	    comment to a valid line in the 'View' section. You also can make an
	    entire line be a comment by putting ## at the beginning of the line.

	#2546660 (Job #118151) **
	    'p4 configure show' now includes the last modified DateTime for a
	    given configurable.

	#2543652 (Job #077851) **
	    The 'p4 typemap' spec now supports comments in the 'Typemap' section
	    by using ##. You can append a ## comment to a valid typemap line.
	    You can also make an entire line be a comment by putting ## at the
	    beginning of the line.

	#2539120 (Job #118569) **
	    Improved the performance of branching a file when the workspace
	    already has the source file revision.

	#2538502 (Job #118546) **
	    Improved the performance of 'p4 renameuser'.

	#2533131 (Job #117980) **
	    Added a configurable to force a mandatory comment when setting a
	    configurable. Set 'dm.configure.comment.mandatory=1' to enable which
	    will cause 'p4 configure set' to fail if no comment is provided.
	    See 'p4 help configure' for more information on setting comments.

	#2528847 (Job #117798) **
	    Removed default values from 'p4 help configurables'; use 
	    'p4 configure help' instead.

	#2527758 (Job #117507) **
	    The previous comment is now outputted when overwriting configurable
	    history with 'p4 configure history'.

	#2525181 (Job #118186) **
	    The ComputeEnd structured log event (1.58) now includes:
	      * the command lapse time (f_lapse)
	      * peak memory for the command so far (f_peakMemCommand)
	      * peak memory for the process so far (f_peakMemProcess)
	      * the command paused time (f_paused)
	    These fields are appended from column 16 (after the command group
	    field).
	    
	    The 'serverlog.version.N' configurable can be used to pin a
	    structured log file to a specific server version's format.
	    To retain the prior structured log events format, set the
	    'serverlog.version.N' configurable to 57.

	#2525176 (Job #99193, #118292) *
	    P4 can now create symlinks on Windows 10 and above, when developer
	    mode is enabled, without needing to run in administrator mode.

	#2524637 (Job #108006) **
	    This change introduces a new -a flag for 'p4 depots' command.
	    With -a flag hidden depots will be included in the output. This is
	    specially useful when user needs to check map paths for all depots.

Bugs fixed in 2024.1 Patch 8 (2024.1/2876055) (2026/01/09)

	#2874696 (Job #121299) **
	    Fixed server crash where altsync agent response did not include the
	    program version.

	#2871597 (Job #112113) **
	    Shelves belonging to clients that no longer exist are now treated as
	    if they are owned by the commit server. If deleting a client from an
	    edge server, shelves are now promoted as part of that client delete.

	#2870854 (Job #129416) **
	    Replication of filtered out records no longer cause replicas to wait
	    for those transactions to complete.

	#2869937 (Job #105807) **
	    The edge server log no longer shows the "Operation 'dmr-Sequence'
	    failed" error when an edge-submit fails after a shelved change is
	    created.

	#2868719 (Job #128028) **
	    If an edge server cannot rename the archive of a shelved file during
	    promote, it now returns a clear error rather than enter a loop.

	#2864314 (Job #129290) ** *** ****
	    Self-signed certificates created with the `-Gc` option on p4d, p4p or
	    p4broker are now signed with a SHA256 hash.

	#2863275 (Job #125149) **
	    Integrations into sparse streams now take much less time.

	#2861696 (Job #127351) **
	    The copy, merge, and integration commands for sparse stream targets
	    do an autosync at the end of the command.  This behavior can now be
	    disabled with the virtual integration flag '-v', which prevents
	    branched and deleted files from affecting the workspace.

	#2861599 (Job #127882) **
	    Permission errors no longer occur when a delta transfer map file was
	    deleted and later simultaneous syncs were issued for the
	    corresponding file revision.

	#2860971 (Job #128946) * **
	    cURL (for extensions) has been upgraded 8.16.0.

	#2860352 (Job #128688) **
	    The command 'p4 undo' now works with the partitioned and
	    partitioned-jnl client types.

	#2859680 (Job #122815) **
	    The formatted ISO8601 date in the structured logs is now correctly
	    converted to UTC.

	#2858864 (Job #118452) **
	    Forwarding replicas of edge servers now correctly handle shelves
	    that are not managed by the first upstream edge server.

	#2858858 (Job #126852) **
	    TinyXML2 has been upgraded to 11.0.0.

	#2856598 (Job #128588) **
	    The p4d commands 'p4d -xv', 'p4d -xvU', 'p4d -xr', 'p4d -xrU' and
	    'p4 dbverify' have been updated to improve handling of partitioned
	    have tables.
	    When processing all tables (no arguments), these commands no longer
	    process the per-client tables for readonly or partitioned type
	    clients. The per-client tables for partitioned-jnl type clients
	    will be processed only if the 'db.partition.verify' configurable is
	    set to '1'.
	    When partitioned tables are explicitly specified (for example:
	    'p4d -xv db.have.pt' or 'p4d -xr db.have.pt%pclient'), all
	    per-client tables will be processed regardless of client type.
	    These commands no longer create empty tables if a per-client table
	    does not exist.

	#2855481 (Job #126106) **
	    Fixed binary+l file mistakenly registered as an orphaned locked
	    file after a copy from a sparse stream, where the file was not
	    resident in the sparse stream.

	#2854335 (Job #128849) **
	    The commands 'p4 journaldbchecksums -u', 'p4 journaldbchecksums -s'
	    , 'p4 dbstat', 'p4 dbpack' and 'p4d -jc' no longer try to access
	    partitioned tables that are not expected to be present on the
	    server.

	#2854333 (Job #124125) **
	    p4d -xv will now skip the partitioned client database tables that
	    are not on the server instead of reporting the 'table not known'
	    error.

	#2853722 (Job #122971) **
	    Improved messaging when opening a file. Instead of: "<depotFile> -
	    can't add exclusive file already opened", the message includes the
	    action the other client did that locked the file. For example,
	    "<depotFile> - can't add exclusive file already opened for add".

	#2847976 (Job #125371) **
	    'p4 istat' no longer takes read locks when 'db.peeking' is set to
	    1 or greater.

	#2844203 (Job #128842) **
	    'p4 describe -a -S' now correctly shows the diff for files open for
	    add in the shelf.

	#2839337 (Job #128816) **
	    This change fixes a bug in 'p4d -jj' where in a certain scenario it
	    would let other tasks write lines into a just rotated journal-file for
	    partitioned tables after the journal closing line for db.counters.

	#2839336 (Job #127084) **
	    This change improves performance of 'p4 shelve' for a change on keyed
	    files that has an action of branch or integ.

Bugs fixed in 2024.1 Patch 7  (2024.1/2834709) (2025/10/06)

	#2844203 (Job #128842) **
	    'p4 describe -a -S' now correctly shows the diff for files open for
	    add in the shelf.

	    Replication will no longer halt in the case where a partition have
	    delete journal note (31) and a change or block checksum
	    note (15 or 17) are encapsulated by a longer running transaction.

	#2831043 (Job #124576) **
	    Recovering an incompatible checkpoint will no longer report an
	    incorrect line number in the error message.

	#2829156 (Job #125669) **
	    Reloading a partitioned client on an edge server with
	    'server.global.client.views=1' set will now correctly restore
	    the client's have records.

	#2829156 (Job #128002) **
	    Reloading a stream client on an edge server with
	    'server.global.client.views=1' set will no longer send the
	    generated 'View' or 'ChangeView' to the commit server.

	#2829156 (Job #128003) **
	    Reloading a client with a 'ChangeView' on an edge server with
	    'server.global.client.views=1' set will now correctly send both
	    the 'View' and 'ChangeView' to the commit server.

	#2828659 (Job #127310) **
	    Prevent edge servers from trying to delete db.have.pt records for
	    clients not associated with the edge server and from propagating
	    them to downstream servers.

	#2812744 (Job #126602) **
	    If replication is stalled or it is slow, it is possible that edge
	    send a change-update up to its target server based on an outdated
	    record, and cause data inconsistency. This change prevents such
	    change-update and fails it with a message that says:
	    "Operation failed on remote server because of data inconsistency,
	    possibly due to stalled or slow replication".

	#2808257 (Job #127760) **
	    Fixed 'invalid out-of-bounds conversion of DmtStreamPathType' error.

Bugs fixed in 2024.1 Patch 6 (2024.1/2805613) (2025/07/24)

	#2801981 (Job ##126938) **
	    'p4 login' will now return a different error id when
	    'dm.user.setinitialpasswd' is disabled and the user has no password set.

	#2793724 (Job #127398) **
	    The stream spec permission checking is no longer applied to submits
	    to streams that do not include a change to the stream spec.

	#2793060 (Job #125649) **
	    For operations like 'p4d -c <command>' that lock all tables, they
	    now wait for concurrent jobs that access the same tables to finish
	    before proceeding.

	#2792562 (Job #123929) **
	    Fixed istat crash due to inconsistencies in stream spec data
	    originating from pre-19.1 servers. Run 'p4d -xf 123929' to fix
	    inconsistent data.

	#2790587 (Job #125471) **
	    Fixed an intermittent 'no write lock' error with journal replay
	    into an offline db when the location of the client.readonly.dir
	    is shared between the p4d server and the offline db.

	#2788867 (Job #127308) **
	    The modtime of binary files with either the +m modifier or with the
	    modtime option enabled in the client are now correctly passed to
	    altsync agents.

	#2786371 (Job #123091) **
	    On a case insensitive server with server.depot.root set, files
	    containing an upper cased character fails to be uploaded to an
	    S3 bucket. This has been fixed.

	#2781918 (Job #125639) **
	    The journal note type 31 now deletes the respective partitioned-jnl
	    table during the journal replay operation.

	#2778790 (Job #126534) **
	    When doing parallel recovery using multifile checkpoint and the source
	    includes partitioned client, if the partitioned client-name end in an
	    underscore followed by eight digits, valid for a multifile checkpoint
	    file sequence number, recovery could fail with an error like 
	    "..._00000001.ckp.gz: No such file or directory". 
	    This change fixes the problem.

	#2777465 (Job #121673) **
	    Uploads to S3 that generate a response code error between 500 and 599
	    are now retried up to lbr.s3.uploadretries number of times. The default
	    of lbr.s3.uploadretries is 5.

	#2773267 (Job #125223) **
	    We were mistakenly checking the permissions to stream spec when doing
	    submit to a classic depot. We have now stopped checking stream permissions
	    when submitting for a classic depot.

	#2770955 (Job #126773) **
	    The sync operation no longer causes the database open error to occur on
	    the db.sendq.pt database table.

	#2763751 (Job #122377) **
	    'p4 submit' on edge could fail when a changelist had a lot of files with
	    long paths due to edge running out of rpc buffer.This change fixes the 
	    problem by sending lock requests in batches. The number of files in each
	    batch is controlled by the setting in the configurable 
	    dm.locks.global.batch.net (default is 10,000).

	#2743835 (Job #125478) **
	    The @ex@ entry in the journal for the partitioned-jnl have table is
	    now generated after the bunch of @dv@ entries during the respective
	    client deletion operation when the configurable
	    db.partition.dropondelete is unset.

	#2738227 (Job #125218) **
	    Fixed delta transfer server failure with error message about moving a
	    file pointer before the beginning of a file.

	#2738209 (Job #125287) **
	    The partitioned-jnl, partitioned and readonly client types can now
	    be converted into writeable client type.

	#2737618 (Job #124867) **
	    The writeable client type can now be converted into partitioned,
	    partitioned-jnl or readonly client type. If there are the opened
	    files, then the conversion to readonly client type results in an
	    error.

	#2736503 (Job #124603) **
	    A checkpoint created using '-jc' with more than a single thread
	    enabled that contains partitioned clients could place the db.config
	    table entries after those for the partitioned clients, making it
	    unrecoverable. This has been fixed.

	#2736167 (Job #124604) **
	    When recovering a checkpoint containing partitioned clients that
	    mismatches the case of the server, a parallel recovery would report
	    an extra spurious error about a missing configurable. This has been fixed.

	#2736163 (Job #124578) **
	    Parallel checkpoints were incorrectly taking a read lock on the
	    db.monitor table and not releasing it until the checkpoint had
	    completed. This has been fixed.

	#2732678 (Job #124938, #125151) **
	    The command 'p4 have' with a partitioned client on a non edge
	    replica server now gets forwarded to the upstream server.

	#2732644 (Job #124865) **
	    The correct error message is now displayed during the conversion of
	    partitioned or partitioned-jnl clients with opened files to a
	    readonly client.

	#2732611 (Job #124748) **
	    The conversion between the partitioned-jnl and the readonly or
	    partitioned client types now updates partitioned have tables on the
	    replica servers appropriately.

Bugs fixed in 2024.1 Patch 5 (2024.1/2724746) (2025/02/24)

	#2722771 (Job #120859) **
	    Fix excessive scanning of db.revsh by 'p4 verify -S' on a shelf
	    containing many files marked for delete.

	#2720916 (Job #124712) **
	    In rare cases the setup to run p4diag automatically can fail on
	    Windows Server 2022 Enterprise without a desktop installed.  This
	    has been corrected.

	#2719308 (Job #121960) **
	    'p4 switch' performed a sync to #have which could remove all
	    unmodified files from a user's workspace if the user had previously
	    switched streams using the '--no-sync' option. The sync to #have
	    was added to switch in 2024.1 to address an issue found related to
	    pruned files. This fix removes that sync to #have from the
	    'p4 switch' logic in favor of updating how 'p4 switch' uses
	    reconcile to avoid the issue with pruned files.

	#2717518 (Job #124613) **
	    Setting 'auth.ldap.ssllevel=2' on a Windows server will no longer
	    allow connections to LDAP servers with self-signed certificates
	    unless that certificate is installed into the CA store or is
	    specified with 'auth.ldap.cafile'.

	#2717514 (Job #123694) **
	    Edge servers will no longer reject submit commands if a depot not
	    involved in the submit has less free space than the
	    'filesys.depot.min' threshold.

	#2716110 (Job #122189) * ** *** ****
	    When using either the tcp64 or ssl64 protocols (IPv6 or IPv4), IPv4
	    addresses are now always formatted as IPv4 addresses rather than
	    mapped IPv6 addresses.

	#2715357 (Job #122574) **
	    The command 'p4 -creadonlyclient client -d writeableclient' with the
	    partitioned type now successfully deletes the client.

	#2714514 (Job #121788) **
	    'p4 verify -v -U' was not fixing bad digest or size in unload depot.
	    This change fixes the problem.

	#2713833 (Job #124534) **
	    Serverlocks on Windows servers are no longer deleted in such a way
	    that on rare occasions synchronous operations could occur in
	    parallel.

	#2711115 (Job #124145) **
	    Fixed conflict between writable components and Ignored paths.

	#2709877 (Job #122963) **
	    On an edge server with configurables submit.allowbgtransfer=1 and
	    submit.autobgtransfer=1 set, when a file edit is submitted without
	    change, the option '-f submitunchanged' of submit would fail to
	    override 'revertunchanged' from client spec and it would result
	    submit failing with: "No files to submit". This change fixes the
	    problem.

	#2707696 (Jobs #124317, #124320) * **
	    P4ALTSYNC agents are now provided with a 'time' field containing
	    the modtime to set on add/added files of type +m or when the
	    modtime client option is enabled.

	#2705555 (Jobs #121658, #124070) **
	    Checkpoint files created with the parallel and multifile options
	    now use a '#' character to mark the start of the batch number encoded
	    within the filename. Previously the server would use a '_' character
	    that could clash with a client name for a partitioned client.

	#2704866 (Job #124281) **
	    'p4d -jd' no longer creates empty directories for partitioned
	    clients.

	#2704303 (Job #124006) **
	    Changed the k-value for configurable 'net.delta.transfer.minsize'
	    from 1 to 1024.

	#2702392 (Job #123919) **
	    With AltSync client on Windows concurrent multiple 'p4 sync' could
	    fail with "All pipe instances are busy". Problem is now fixed.

	#2699567 (Job #123856) **
	    The 'svrRecType' topology field is no longer unset during replica
	    restart when an upstream server is older than 2022.2.

Bugs fixed in 2024.1 Patch 4 (2024.1/2697766) (2024/12/18)

	#2696848 (Job #120059) **
	    There is a race condition between directory removal and archive
	    creation on an edge during a 'p4 submit -e' for binary file types.
	    This has been fixed.

	#2696247 (Job #123050) **
	    For 'p4 changes -m <max> -e <change>' it would excessively scan
	    records from db.change. This change fixes the problem.

	#2694784 (Job #123904) **
	    Deletion of a partitioned database table now deletes only the
	    numbered partitioned directory.

	#2694764 (Job #123912) **
	    A partitioned database table path could be incorrectly parsed. This
	    has been fixed.

	#2694103 (Job #123774) ***
	    Reuse of a ClientApi object across connections that involve a proxy
	    no longer causes "Unknown command" errors after client statistics
	    should have been reported to the server.

	#2692688 (Job #123797) **
	    Delta commit against a file with missing server-side content for the
	    prior revision, or against a deleted prior revision could fail with
	    "zero length chunk map" error.

	#2687982 (Job #123487) **
	    `p4 verify -t` can now be run on unicode enabled servers.

	#2687280 (Job #123022, #122088, #119098) **
	    The sync operation no longer causes the database open error to
	    occur on the db.sendq.pt database table. The empty partitioned
	    have directories are no longer created.

	#2687075 (Job #119735) **
	    On Windows, network share access permissions for RCS depot archives
	    can cause a crash.  This has been resolved.

	#2686825 (Job #122569) * **
	    cURL has been upgraded 8.10.1

	#2683844 (Job #123438) **
	    Prevent crash on journal replay with an update, then delete, of a
	    db.config record with a specific serverID within the same journal.

	#2683255 (Job #123521) **
	    Clients of 'readonly' type now work correctly as revision
	    specifiers.

	#2682371 (Job #123443) **
	    Commands run through a broker and then forwarded to another server
	    will no longer cause hangs for successive commands run on the same
	    connection after a client could have reported client stats.

	#2681835 (Job #122411, #123082)
	    In rare cases an unshelve performed by Swarm can cause a crash.
	    This has been corrected.

	#2680579 (Job #121121) **
	    Corrected an unexpected 'Files are missing as a result of one or
	    more move operations' error in the fetch, push, and zip commands.

	#2680297 (Job #123346) **
	    A 'p4 sync' on an edge server with lbr.replication=cache could
	    cause server to hang. This change fixes the problem.

	#2679316 (Job #123034) **
	    Setting a trigger command to an empty string will now result in an
	    error on execution rather than allow the undefined behavior. 

	#2676564 (Job #123250) **
	    Security fix. Addressed CVE-2024-10314, CVE-2024-10344 and
	    CVE-2024-10345

	#2676557 (Job #122687) **
	    Commands that specify multiple arguments using different partitioned
	    clients as the revision specifiers will now return the correct
	    results for each argument.

	#2676161 (Job #123359) **
	    The commands 'p4d -K db.have.pt' and 'p4d -k db.have.pt' now
	    exclude and include all the available partitioned have tables.

	#2675020 (Job #120977) **
	    Fixed a problem where a user with openstreamspec permission could
	    open a stream spec but not edit the stream spec. Also fixed a
	    problem where a user with writestreamspec permission could not edit
	    and save a new stream spec.

	#2667309 (Job #123015) **
	    Fixed locking order bug when obliterating a stream and the
	    configurable index.domain.owner is 1.

	#2666217 (Job #122929) **
	    Revert 'track' configurable default value back to '-1'.

	#2662757 (Job #113058) **
	    Fixed stream spec obliterate problem where a super or admin user
	    could not obliterate the stream spec if configurable
	    'dm.protects.streamspec' was set to 1.


Bugs fixed in 2024.1 Patch 3 (2024.1/2661979) (2024/10/04)

	#2661232 (Job #122784) **
	    Corrected crash when authentication fails during istat operation.

	#2661134 (Job #117647) **
	    A crash in 'p4 transmit -r' has been corrected.

	#2659944 (Job #122639) **
	    Unlimited group Timeout setting fixed.

Bugs fixed in 2024.1 Patch 2 (2024.1/2655224) (2024/09/18)

	#2654300 (Job #122472) **
	    A rare infinite loop caused by an over-optimisation when scanning
	    the rev table has been fixed.

	#2651891 (Job #122076) **
	    The command-line client on Windows now prints an error when it
	    detects ambiguous argument encoding.

	#2651627 (Job #121134) **
	    Fixed istat crash with noinherit ParentView when db.bodtextcx rows
	    are missing.

	#2649935 (Job #121666) **
	    Using S3 for archive files can raise 'file not found' errors
	    when the files are accessed concurrently by multiple clients.
	    This has been fixed.

	#2648900 (Job #122240) **
	    When the configurable 'client.sendq.dir' is set, the partitioned
	    have table is now unlocked and removed during the deletion of the
	    respective partitioned client.

	#2648897 (Job #117955) * **
	    The zlib deflate operation uses x64 instructions not supported on 
	    older CPUs raising an illegal instruction exception. This has been
	    fixed.

	#2644014 (Job #121944) * **
	    Added net.delta.transfer.minsize and net.delta.transfer.threshold
	    to 'p4 help configurables'. These configurables allow the Helix
	    Core Server and individual clients to enable and disable delta
	    transfer for binary files based on the file size and amount of
	    change between current and prior revisions.

	#2643135 (Job #121830) **
	    A recovery operating can fail when the checkpoint file contains
	    multiple partitioned clients. This has been fixed.

	#2641044 (Job #122043) **
	    The commands 'p4d -k -jd' and 'p4d -K -jd' now successfully filter
	    the partitioned have tables as expected.

	#2640008 (Job #120982) **
	    Fixed 'rmt-fileExistsReplica' not exiting properly on commit-server
	    if the calling replica is missing the ExternalAddress field in its
	    server spec.

	#2639260 (Job #122045) **
	    Linux Arm64 (aarch64) build was recompiled with GCC 8 to resolve
	    a backward compatibility issue.

	#2638504 (Job #120640) **
	    Using an edge client to populate a stream failed with the error,
	    "file(s) not in client view", when stream components were disabled.

	#2638401 (Job #119346) **
	    In case of a commitServer-Edge-ForwardingReplica chain, there was a
	    problem where on ForwardingReplica a 'p4 submit' after Integ/Resolve
	    could fail because archive files were missing on the Edge server.
	    This change fixes the problem by pulling the missing archive-files
	    for the Edge server when needed, allowing 'p4 submit' to succeed.

	#2635787 (Job #121863) **
	    Fixed a problem where a command following a stream obliteration
	    might give an error the obliterated stream was unknown. The problem
	    only occurred with P4API clients.

	#2634780 (Job #120711) **
	   The auto pull operation now updates the 'lastSeenDate' field of the
	   respective 'connect' type topology record across the servers.

	#2634274 (Job #121790) **
	    If a virus scanner locks a portion of an RCS temp file during
	    a pull operation, a crash may occur.  This has been corrected.

	#2633881 (Job #114829) **
	    For 'p4 fstat' locking db.revcx for long period could block other
	    commands like 'p4 submit' to run simultaneously. This change fixes
	    the problem by altering db.revcx lock mode to PEEK mode, if
	    db.peeking is set to greater than 2.

	#2633324 (Job #115232) **
	    This change introduces a new flag, -E, for p4 copy. The -E flag
	    overrides the current setting for the 'dm.integ.tweaks'
	    configurable and its effect is the same as having
	    'dm.integ.tweaks' set to 32. This flag, similar to the
	    configurable 'dm.integ.tweaks', is kept undoc.

	#2633218 (Job# 118689) 
	    The p4dctl package will configure a systemd service on hosts running
	    systemd in order to start and stop the p4dctl-managed server instances.
	    Use the systemctl command to manage the service named "helix-p4dctl".

	#2629813 (Job #119795) **
	    For p4 fetch', if '-I' flag is used the command could fail
	    unexpectedly with a 'Cannot import' error. This change fixes the
	    problem.

	#2629303 (Job #121575) **
	    The DateTime server type is now defined as a 64 bit signed integer
	    rather than the system defined time_t. This help interoperability
	    with 32bit clients.

	#2628645 (Job #121621) **
	    Setting a very low value of db.checkpoint.reqlevel can allow a
	    multifile parallel checkpoint or dump to skip small db.files.
	    This has been fixed.

	#2627572 (Job #119476, #119575) **
	    The command 'p4 journaldbchecksums -u unloadfile -t dbtable' now
	    unload the files successfully for the partitioned-jnl have tables.

	#2627617 (Job #120925) **
	    Fixed a sparse stream integration problem where an integrate to the
	    sparse stream from the parent was required after an integrate from
	    the sparse stream to parent, even if no changes had occurred in the
	    parent after the first integration.

	#2626263 (Job #121119) ** ***
	    Fix for client 'clobber' option being dropped when syncing
	    through a proxy.

Bugs fixed in 2024.1 Patch 1 (2024.1/2625008) (2024/07/15)

	#2621152 (Job #119512) **
	    'p4d -xx' command can now be used to check the integrity between the
	    tables 'db.working' and 'db.have.pt%pclient', where the later
	    represents a specific partitioned have table.

	#2619520 (Job #119772) **
	    Fixed a journal inconsistency issue on non-Windows platforms caused
	    by killing a running p4 command.

	#2619517 (Job #121240) **
	    The 'p4 lock' and 'p4 unlock' commands can now be cancelled by using
	    'p4 monitor terminate' or pressing Ctrl-C on the client.

	#2619224 (Job #121237) * **
	    A new client side configurable 'net.delta.transfer.threshold' has
	    been added to specify the maximum percentage of file size to perform
	    a delta transfer before reverting to streaming the complete file for
	    'p4 submit' of binary+F files. A value of 0 disables the delta transfer.
	    
	    On a low-bandwidth remote client, a small reduction in file transfer
	    would provide performance gain therefore a higher threshold for the
	    delta transfer would be beneficial; whereas on a client with faster
	    network, a low or zero threshold would avoid the overhead incurred by
	    the delta transfer.

	#2617863 (Job #121296, #121297) **
	    Fixed a crash in 'p4 fstat -Sr -Or /outside/of/workspace/file'.

	#2617328 (Job #120791) **
	    Fixed stream obliterate endless loop problem.

	#2617321 (Job #87618) **
	    Ignored branch records resulting from
	    a cherry-pick now only grant credit for the cherry-picked
	    revisions, rather than implicitly including all prior
	    revisions as is the case for a normal branch record.  This
	    fixes a problem in which an ignored branch of a file that
	    was copied from an old revision did not grant any credit
	    at all on subsequent integrations.

	#2617061 (Job #121091) **

	    Fixed reversion of an open stream spec when using the command
	    'p4 revert -a -Si filelist...'.

	#2615784 (Job #119311, #119719 ) **
	    The commands 'p4 attribute' and 'p4 fstat -Oa' could fail with
	    'Rpc buffer too big' errors if an attribute value size was
	    too large (greater than 250MB). Now the command 'p4 attribute
	    -I' which reads the attribute value from a file may be used for
	    attribute values that would generate that error. In addition,
	    the 'p4 print -T' command may now be used to print an attribute
	    value that would generate that error from the 'p4 fstat -Oa'
	    command.

	#2615605 (Job #121279) **
	    Improved 'p4 submit' performance with delta transfers by removing
	    extraneous resource locking on the p4d server.

	#2612813 (Job #121079) **
	    Fixed reversion of an open stream spec when using the command
	    'p4 revert -n -Si filelist...'.

	#2611770 (Job #121151) **
	    'p4 integ' now correctly integrates the files related to the
	     partitioned-jnl type clients.

	#2611612 (Job #121150) **
	    'p4 unshelve' now correctly unshelves the files in the
	     partitioned-jnl client workspaces.

	#2611471 (Job #121143) **
	    'p4 reconcile' now correctly handles the partitioned-jnl client
	    workspaces.

	#2609726 (Job #121059) **
	    Parallel sync now works correctly from a partitioned client when
	    'client.sendq.dir' is also set.

	#2607924 (Job #120522) **
	    To ensure the consistency among the servers, the 'partitioned-jnl'
	    type client cannot be set or created until all upstream servers
	    have been upgraded to at least 2024.1 server version.

	#2607673 (Job #110263) **
	    This change fixes a performance problem in 'p4 obliterate' where it
	    was causing excessive time on edge-server to purge related db.label
	    records.

	#2607484 (Job #120840) **
	    If a Helix Core Server is configured with no logging, a crash may
	    occur. This has been corrected.

	#2606485 (Job #120824) **
	    Fixed an error message when unshelving a sparse stream spec which
	    has a lower parent stream changeview than the current stream spec.
	    The previous error message did not make sense in an unshelving
	    context.

	#2604549 (Job #120774) **
	    The partition client have tables now encode the invalid filesystem
	    characters.

	#2604055 (Job #120765) **
	    Disabled 'p4 unshelve -S' when the current stream is a sparse
	    stream, since unshelving non-resident files into a sparse stream can
	    lead to undesirable behavior.  

	#2602241 (Job #120541) **
	    'p4 unload' and 'p4 reload' operations can now be performed on
	    'readonly' type clients.

	#2601945 (Job #120592) **
	    The correct error message is displayed when trying to convert any
	    client type to 'readonly' client type.

	#2599439 (Job #119766) **
	    Fixed a problem where switching to a sparse stream at a change
	    would sync parent files at the head revision rather than at the 
	    sparse stream changeview change.

	#2599433 (Job #120642) **
	    Fixed crash with stream command when server license has expired.

	#2599428 (Job #120533) **
	    Fix for "Invalid changelist number 0" when creating a sparse stream
	    just after an upgrade.

	#2598134 (Job #119825) **
	    'p4 integrate' now treats pending 'copy' records from the source
	    file as direct credit when determining the initial debit.

Bugs fixed in 2024.1 (2024.1/2596294) (2024/05/09)

	#2587967 (Job #119856) ** 
	    Made error messaging more consistent for integration commands with
	    StreamAtChange clients.

	#2593175 (Job #119797) **
	    S3 uploads over 4GB now use multipart uploads to overcome the 5GB
	    limit on a single upload.

	#2591978 (Job #120194) **
	    Changed error message when unshelving a stream spec in a
	    StreamAtChange client to say that the spec cannot be
	    unshelved in a StreamAtChange client.

	#2591970 (Job #120563) **
	    'p4 submit -e' run against a 'lbr.replication=shared' edge server
	    no fails to calculate checksums/filesizes for files of type +k that
	    where previously deduplicated on the shelf.
	    
	#2591970 (Job #120536) **
	    The paths used for files within an S3 bucket are now relative to the
	    depot path and are no longer affected by absolute depot mappings nor
	    'server.depot.root'.

	#2590936 (Job #120474) **
	    Replication of a journal rotation event from an upstream server
	    using journalcopy can no longer enter a loop.

	#2589959 (Job #120343) **
	    S3 now correctly handles files with tildes (~) in their paths.

	#2588539 (Job #110981) **
	    With 'p4 sync -L' when fileSpec arguments include #0 revision,
	    the command could miss syncing some of the files.
	    This change fixes the problem.

	#2585389 (Job #120187, #120193) **
	    Changed error message when opening a stream spec in a
	    StreamAtChange client to say that the spec cannot be
	    opened in a StreamAtChange client.

	#2580908 (Job #120021) **
	    Fixed 'p4 add ...' when it is run in a workspace whose client map
	    does not contain a wildcard mapping (%, *, or ...) against multiple
	    new files. Previously, the command only opened one file to be
	    added.

	#2587752 (Job #115877) **
	    On an edge-server 'p4 submit' following a 'p4 integ -v' could fail
	    with "No such file or directory". This change fixes the problem.

	#2587687 (Job #111184) **
	    This change fixes a problem in 'p4 submit' on edge-server where
	    after reshelving a delete revision 'p4 submit' could fail with:
	    "Can't map  to archive!".

	#2587164 (Job #118519, #118583, #118622) **
	    Fix configurable validation routine where large integer values are
	    possible, including 'auth.ldap.timeout' and 'auth.ldap.pagesize',
	    and clarify some default configurable settings.

	#2579882 (Job #119854) ** ***
	    Client stats are no longer collected when a proxy server prior to
	    this patch is used, preventing a potential hang when multiple
	    commands are run on the same connection.

	#2578431 (Job #119853) **
	    Fixed a performance degradation introduced in the 2023.1 release
	    in the 'p4 fstat' command with a large client map. The command
	    performance has been restored to the previous release levels.

	#2576718 (Job #119914) **
	    'p4 dbpack' now reorders the database index pages for the
	    partitioned have tables as well.

	#2573910 (Job #119810) **
	    The error message, "db.group locked after db.stream", no longer
	    appears when submitting a stream spec on an edge server and
	    then issuing a stream command. Previously, this error could
	    occur in P4V or any client that uses a shared connection.

	#2573319 (Job #118904) **
	    A new -Om option was added to the 'p4 fstat' command to output
	    ditto mapped files when the client file syntax is used.

	#2572153 (Job #119521) **
	    If 'p4 switch' cannot fully reconcile all files in the user's
	    workspace the switch will now fail with an appropriate error.

	#2568009 (Job #119493) **
	    Fixed stream view generation at a specific change causing an 
	    endless loop during upgrade, where the loop occurs for the stream's
	    ancestors and the stream itself is not in the loop.

	#2566644 (Job #119638) **
	    Ensure all interfaces are listed in tagged output for
	    'p4 license -L'.

	#2563515 (Job #119203) **
	    A non-parallel checkpoint request using more than one thread
	    did not ensure that the CHECKPOINT_HEADER note appeared as the
	    first line in the output file. Also the same checkpoint on
	    a Windows platform did not use the correct line ending. This
	    has been fixed.

	#2563050 (Job #119453) **
	    Fixed "db.streamview locked after db.domain" error when submitting
	    an opened stream spec.

	#2561836 (Job #118023) **
	    Attempting to unsubmit a change that affected a stream specification
	    is now blocked. Unsubmit has never supported undoing changes to
	    stream specifications and would previously unsubmit the files in a
	    change while leaving the stream specification still submitted.

	#2561877 (Job #118997) **
	    'dm.protects.exclusioncheck' no longer blocks the owner of
	     sub-protection table from modifying it.

	#2559739 (Job #112564) **
	    Added 'dm.protects.exclusioncheck' check to 'p4 servers',
	    'p4 remotes', 'p4 switch', and 'p4 print'.

	#2557637 (Job #119417) **
	    Fixed a crash when 'p4 unshelve -b/-S' encountered an error.

	#2556267 (Job #119435) **
	    A deleted stream may now be re-created with a different
	    ParentView.

	#2554783 (Job #109776) * ** *** ****
	    The SSL certificate validation no longer assumes that P4PORT will
	    be set to a FQDN.

	#2551531 (Job #118961) **
	    'p4 diskspace' now correctly handles symlinks. Additionally, the
	    output now also includes the mount point for each location used by
	    the server.
	    
	    The formatted output can be reverted to the prior format by setting
	    the 'api' level to 95 or lower; for example 'p4 -Zapi=95 diskspace'.

	#2550748 (Job #119133, #119153) **
	    The performance of 'p4 streams --viewmatch //...' and similar
	    wildcarded paths has been improved by changing the output to
	    include all lines in the stream whose depot mappings intersect
	    with the wildcarded path, rather than identifying the specific
	    line that is used to map a given file in the stream. Specific
	    matching lines are still returned when a single file is used as
	    the --viewmatch argument.

	#2546650 (Job #118998) * ** *** ****
	    Improve SSL error detection and handling to prevent reporting
	    non-existent SSL errors. Previously this was theoretically
	    possible but had not been observed.

	#2546586 (Job #118566) **
	    Parallel recoveries did not detect a character set mismatch between
	    the server and recovery files. This has been fixed.

	#2545744 (Job #113441) **
	    The 'p4 sync' command with multiple user specified file patterns
	    will now batch compute all sync arguments and collate file actions
	    before sending files to the client.

	#2544325 (Jobs #118375, #112333) **
	    On Windows the atomic rename api is limited in scope by the OS.
	    With this change the atomic rename is first attempted, if the
	    atomic rename fails the operation falls back to a copy truncate.

	#2543769 (Job #116539) **
	    It was possible for the table dump command 'p4d -jd' to create
	    the MD5 checksum file even when the command had failed. This
	    has been fixed.

	#2542406 (Job #107457) * ** *** ****
	    Improve SSL connection establishment under heavy load. In particular
	    this eliminates the "wrong version number" error when the client
	    is slow to initiate the SSL handshake after establishing the TCP
	    connection.

	#2540339 (Job #118002) **
	    'p4 obliterate' can no longer write archive delete journal notes
	    when a journal rotation is in progress.

	#2539409 (Job #118756) **
	    Attempts to assign a negative value to a date field are now
	    blocked.

	#2539408 (Job #118549) **
	    The server does not handle date fields containing negative values
	    correctly. This has been fixed.

	#2536499 (Job #118593) **
	    Adding an Extension that implements a 'pressure-pause' event no
	    longer prevents updates to triggers.

	#2536202 (Job #118635) **
	    The range of dates that can be represented and queried in Date job
	    fields has been increased from the year 2038 to the year 2286.

	#2534366 (Job #118342) **
	    The monitor level stored by 'rt.monitorfile' is no longer reset to
	    0 when each new command starts.

	#2534366 (Job #116191) **
	    Fixed DVCS fetch, push and zip commands incorrectly reporting a
	    split move across changelists.
	    
	#2534072 (Job #118559) * ** *** ****
	    Clients now call shutdown() before closing a network connection
	    in order to process all pending packets and ensure a clean
	    connection shutdown. In particular, pending packets will not
	    be lost when a client is terminated via control-c (^C).

	#2531031 (Job #658) **
	    'p4 resolved //depot/file' will now return matches for the 'yours'
	    file as well as the 'theirs' file.

	#2531128 (Job #118495) **
	    Extensions installed on a Windows commit server and run on a
	    Unix replica will now work.

	#2530847 (Job #516) **
	    'p4 add' of a file opened for branch with 'p4 integ -v' will no
	    longer attempt to make the workspace file writable, since there
	    is no depot file present in the workspace in that scenario.

	#2530479 (Job #118395) **
	    Set digest/filesize on text+k files for 'p4 change -t' command. 

	#2530372 (Job #118360) **
	    Replacing a trait value that had been saved in the trait depot
	    with a value that is saved in db.traits would cause the
	    trait depot depotfile to not be removed. This has been fixed.

	#2530369 (Job #433) **
	    The "//xxx/... - must refer to client 'yyy'" error message now
	    includes the phrase "or a depot", since in the context in which
	    this error appears it is valid for "xxx" to be either the current
	    client or any accessible depot.

	#2529691 (Job #118150) **
	    Fixed 'p4 configure show allservers' output inconsistency.
	    Output now includes the self-doc fields from 'p4 configure help'.

	#2529474 (Job #118397) **
	    The command 'p4 configure help' for a particular configurable now
	    results in a command usage error.

	#2527918 (Job #114849) **
	    The fix for job #84375 inadvertently caused issues for the
	    'SearchBindPasswd' field of the 'p4 ldap' specification, resulting 
	    in authentication failures when using that LDAP connection; this
	    has been fixed

	#2527606 (Job #112369) **
	    The 'p4 fstat' command with multiple user specified filespecs will
	    now batch compute all command arguments before displaying
	    information about each file to the client. When run against an edge
	    server with the global lock option -OL, this has the effect of
	    improved performance due to reduced rmt-GlobalLockFetch calls.

	#2527036  (Job #114420) **
	    'p4 renameuser' no longer takes long write locks on db.monitor.
	    
	#2526915 (Job #115632) **
	    Fixed auto-shelve of modified content on distribution server when
	    switching between streams.

	#2526838 (Job #116689) **
	    Replicas configured with 'lbr.replication=cache' will now check for
	    a running archive pull thread before triggering deferred archive
	    replication for files being sync'ed.

	#2522789 (Job #115864) **
	    The client filesize cache data is now replicated. If filesize data
	    needs to be generated on a replica, the required archives are pulled
	    on-demand if not already replicated.

	#2522653 (Job #118004) **
	    On-demand fetching of archives from a replica will now cause the
	    commit server to perform a fetch on-demand if the archive has not
	    yet been transferred from an edge server as part of a background
	    submit. The client requesting the file content will no longer
	    receive a librarian error in this situation.

	#2522208 (Job #118198) **
	    'p4 license -L' no longer reports the MAC addresses of network
	    interfaces that do not have IPv4 or IPv6 addresses.

	#2519364 (Job #102151) **
	    This change improves performance for 'p4 sync' for cases where
	    client view is complex and has many entries.

	#2519175 (Job #122751) **
	    'p4 interchanges -S' now consistently reports changes that require
	    integration, as it is documented to.  Previously, it would
	    sometimes partially mimic the behavior of 'p4 copy' and report
	    changelists associated with arbitrary revisions of differing files
	    rather than changelists associated with unintegrated revisions,
	    with additional special-casing to eliminate some of the most
	    obviously nonsensical results.  In the interests of simplicity and
	    performance, the behavior is now consistent with 'p4 integrate'.

	#2518835 (Job #118062) **
	    Files that are known to the server to be modified in a workspace,
	    i.e. open files, are now considered "modified" for the purposes of
	    'p4 obliterate -b' and 'p4 prune'.

	#2516156 (Job #117862) **
	    The --from flag now works correctly when integrating into a
	    mainline stream from one of its children.

	#2515370 (Job #112901) **
	    If a file was added with the same name as a file which had
	    previously been moved, then a 'p4 verify' might erroneously
	    report the readded file was missing.  This has been fixed.

	#2511533 (Job #117953) **
	    'p4 diff' now produces more consistent results with a diff against
	    the default (#have) revision when diffing against the same revision
	    by explicitly providing it as a command argument.

	#2509774 (Job #117916) **
	    Now 'p4d -xx db.working db.have' table pair integrity check does
	    not result in partitioned client files deletion entries in jnl.fix
	    file.

	#2506947 (Job #116293) **
	    'p4 search' could get stuck when putting a read-lock on the ixtext
	    table. This change fixes the problem by switching to lockless access
	    for the table.

	#2506405 (Job #114542) *
	    A 'p4' request now reports invalid character encodings passed in
	    the program aruments.

	#2504413 (Job #117741) * **
	    cURL (for extensions) has been upgraded 8.4.0 to address multiple
	    cURL CVEs: CVE-2023-38545 and CVE-2023-38546

	#2502624 (Job #113605) **
	    When 'p4 verify -S @=<change#>' is run with a change# that is not
	    shelved, or was shelved previously and then the shelf was deleted,
	    'p4 verify' for this case would incorrectly output files from other
	    shelved changes. This change fixes the problem.

	#2501687 (Job #117719) * ** *** ****
	    Ignore spurious SSL errors detected during SSL client and server
	    initialization to prevent reporting non-existent SSL errors.
	    Previously this was theoretically possible but had not been
	    observed.

	#2498308 (Job #91847) **
	    'p4 sync' could fail to schedule a resolve against newer revisions
	    of a file that had been opened for move if the move/add revision
	    had a higher revision number than the corresponding move/delete.

	#2492795 (Job #117470) * ** *** ****
	    Make SSL error handling more robust and provide more detailed
	    and user-friendly SSL error messages.

--------------------------------------------------------------------------

Major new functionality in 2023.2 (2023.2/2519561) (2023/11/14)

	#2489411 (Job #116768) **
	    Initial support S3 backed depots
	    This is initially limited to depots of type archive, but will be
	    extended to support other depot types in the future.

	#2486446 (Job #115674) **
	    New attribute values may now be optionally stored in a traits depot
	    rather than in the db.traits table when the size of the value
	    meets or exceeds a configured size (in bytes) as set by the new
	    configurable 'trait.storagedepot.min'. The 'p4 fstat -Oa' option
	    will fetch and display the value from its storage location, which
	    will be either the trait depot or the db.traits table. A new
	    command, 'p4 fstat -On' will display the attribute names with
	    their storage locations rather than their trait values. The
	    'p4 attribute' command now has options to override the configurable
	    under certain circumstances. Please see 'p4 help attribute' and
	    'p4 help fstat' for further details.

Minor new functionality in 2023.2 (2023.2/2519561) (2023/11/14)

	#2499053 (Job #112875, #117469) **
	    Validate IP/MAC address or FQDN against valid addresses on the
	    server host before applying a new license with 'p4 license -i'.
	    No server server restart is needed for any license update.

	#2495109 (Job #97048) ***
	    Added a new p4p option, --cache-purge, for clearing proxy cache
	    files that have not been accessed recently. The threshold for access
	    time is set by the new configurable 'proxy.clearcachethresh'.

	#2491355 (Job #116606) **
	    Added a new comment field to config history records: long option 
	    --comment can be used to set the comment for the last history record
	    for a given configurable, or used with set/unset.

	    See 'p4 help configure' for usage details.

	#2487108 (Job #117327, #113690) **
	    The new journalPrefixBackup Commit Server configurable makes it
	    possible to manually move rotated journal files to a secondary
	    storage location and still support edge server activity.  See
	    the Command Reference for details.

	#2486366 (Job #116822) **
	    New command 'p4 configure help' outputs all documented configurables.
	    Shows their value, description, value type, min value (if available),
	    max value (if available), default value, recommended value (if available),
	    restart requirements, support level, category and URL of the online
	    help.

	#2485308 (Job #110741) **
	    The performance of 'p4 reload' has been improved by optimising its
	    memory usage.

	#2483722 (Job #112874) **
	    Use 'p4 license -L' to obtain a list of valid IP or MAC addresses
	    from your server host.

	#2483011 (Job #095924) * ** ***
	    Log the number of files sent/received by the server/proxy/client and
	    size in bytes for more visibility.

	    Unstructured logs will show separate logs for server/client/proxy as
	    '--- filetotals (svr) send/recv files+bytes 0+0mb/0+0mb'
	    '--- filetotals (client) send/recv files+bytes 0+0mb/0+0mb'
	    '--- filetotals (cache) send/recv files+bytes 0+0mb/0+0mb'

	    The following changes have been made for structured logs:
	      1. The existing DMG_LOG_TRACK_RPC event now has 4 new fields:
	          f_sendDirectFiles
	          f_recvDirectFiles
	          f_sendDirectBytes
	          f_recvDirectBytes
	      2. New event DMG_LOG_CLIENT_STATS (event number 25) with 4 fields:
	          f_sendClientFiles
	          f_recvClientFiles
	          f_sendClientBytes
	          f_recvClientBytes
	      3. New event DMG_LOG_PROXY_STATS (event number 26) with 4 fields:
	          f_sendCacheFiles
	          f_recvCacheFiles
	          f_sendCacheBytes
	          f_recvCacheBytes

	    CURRENT LIMITATIONS:
	      1. Only proxies will forward the client stats to the commit server,
	         and any cached delivers, file total logging disabled on broker,
	         and forwarding-replica will log locally instead of forwarding
	         the stats to the upstream commit server. 
	    
	      2. Neither forwarding replica or proxy will log filetotals cached
	         during transfer, from either commit->proxy/replica or from
	         client->proxy/replica.

	#2482034 (Job #117182) **
	    'p4 streams --viewmatch' now accepts a revision specifier.

	#2470778 (Job #116585) * ** *** ****
	    P4PORT transport prefixes (e.g., 'tcp', 'tcp4', 'tcp46, 'tcp6', 
	    'tcp64', and their SSL equivalents) are no longer required to be 
	    lowercase. The alphabetic characters in a transport prefix may be
	    uppercase, lowercase, or mixed case.

	#2442141 (Job #053773, #034662) * **
	    The 'zlib.compression.level' configurable has been added to allow
	    for specifying the amount of compression attempted for various
	    activities.  The configurable has a range from -1 to 9, with 9 being
	    the slowest and highest compression level.  The -1 setting corresponds
	    to the default setting of the zlib library, which is currently level 6.

	    This allows admins to trade compression time for file size.
	    The difference in file size can be smaller than the gains had
	    by spending less time compressing files, so allowing for this
	    choice offers a useful setting to expose since spending less time
	    waiting for 'p4 submit' is cheaper than using a bit more storage.

	    E.g. a 'p4 submit' of a binary file with the default compression level
	    of 6 takes 4.75s and results in a 49MB archive file.  Changing the
	    level to 2 takes 2.98s and results in a 54MB archive file - that's
	    a 37% faster commit and 10% bigger binary, and ~54% faster than
	    the 22.2 release.

	    The setting is primarily applied server-side, intended for archive
	    file activities, but can also be used client-side, e.g. for the
	    client spec 'compress' option.

Bugs fixed in 2023.2 Patch 10 (2023.2/2873834) (2026/01/05)
	
	#2869936 (Job #105807) **
	    The edge server log no longer shows the "Operation 'dmr-Sequence'
	    failed" error when an edge-submit fails after a shelved change is
	    created.

	#2865069 (Job #126938) **
	    'p4 login' will now return a distinct error when
	    'dm.user.setinitialpasswd' is disabled and the user has no password
	    'p4 login' will now return a distinct error when
	    'dm.user.setinitialpasswd' is disabled and the user has no password
	    set, informing the user that a super user must set their initial
	    password.

	#2864312 (Job #129290) ** *** ****
	    Self-sign certificates created with the `-Gc` option on p4d, p4p
	    or p4broker are now signed with a SHA256 hash.
	
	#2864281 (Job #128946) * **
	    cURL (for extensions) has been upgraded 8.16.0.

	#2863283 (Job #126852) **
	    TinyXML2 has been upgraded to 11.0.0.

	#2844201 (Job #128842) **
	    'p4 describe -a -S' now correctly shows the diff for files open for
	    add in the shelf.

	#2805374 (Job #127760) **
	    Fixed 'invalid out-of-bounds conversion of DmtStreamPathType' error.

Bugs fixed in 2023.2 Patch 9 (2023.2/2797379) (2025/07/11)

	#2793723 (Job #127398) **
	    The stream spec permission checking is no longer applied to submits
	    to streams that do not include a change to the stream spec.

	#2792259 (Jobs #123929) **
	    Fixed istat crash due to inconsistencies in stream spec data
	    originating from pre-19.1 servers. Run 'p4d -xf 123929' to fix
	    inconsistent data.

	#2788868 (Job #127308) **
	    The modtime of binary files with either the +m modifier or with the
	    modtime option enabled in the client are now correctly passed to
	    altsync agents.
	    
	#2775893 (Job #125223) **
	    We were mistakenly checking the permissions to stream spec when doing
	    submit to a classic depot. We have now stopped checking stream permissions
	    when submitting for a classic depot.

Bugs fixed in 2023.2 Patch 8 (2023.2/2723144) (2025/02/19)

	#2720920 (Job #124712) **
	    In rare cases the setup to run p4diag automatically can fail on
	    Windows Server 2022 Enterprise without a desktop installed.  This
	    has been corrected.

	#2717519 (Job #124613) **
	    Setting 'auth.ldap.ssllevel=2' on a Windows server will no longer
	    allow connections to LDAP servers with self-signed certificates
	    unless that certificate is installed into the CA store or is
	    specified with 'auth.ldap.cafile'.

	#2717513 (Job #123694) **
	    Edge servers will no longer reject submit commands if a depot not
	    involved in the submit has less free space than the
	    'filesys.depot.min' threshold.

	#2716109 (Job #122189) * ** *** ****
	    When using either the tcp64 or ssl64 protocols (IPv6 or IPv4), IPv4
	    addresses are now always formatted as IPv4 addresses rather than
	    mapped IPv6 addresses.

	#2713834 (Job #124534) **
	    Serverlocks on Windows servers are no longer deleted in such a way
	    that on rare occasions synchronous operations could occur in
	    parallel.

	#2712308 (Job #124563) **
	    'p4 labelsync' and 'p4 tag' now apply the label to all files
	    arguments sequentially, irrespective of the type of the
	    revision specifiers provided, such that the last argument to
	    reference a given file is used to determine which revision is
	    stored in the label.

	#2711117 (Job #124145) **
	    Fixed conflict between writable components and Ignored paths.

	#2709879 (Job #122963) **
	    On an edge server with configurables submit.allowbgtransfer=1 and
	    submit.autobgtransfer=1 set, when a file edit is submitted without
	    change, the option '-f submitunchanged' of submit would fail to
	    override 'revertunchanged' from client spec and it would result
	    submit failing with: "No files to submit". This change fixes the
	    problem.

	#2707698 (Jobs #124317, #124320) * **
	    P4ALTSYNC agents are now provided with a 'time' field containing
	    the modtime to set on add/added files of type +m or when the
	    modtime client option is enabled.

	#2702455 (Job #123774) ***
	    Reuse of a ClientApi object across connections that involve a proxy
	    no longer causes "Unknown command" errors after client statistics
	    should have been reported to the server.

 	#2698309 (Job #120059) **
	    There is a race condition between directory removal and archive
	    creation on an edge during a 'p4 submit -e' for binary file types.
	    This has been fixed.

Bugs fixed in 2023.2 Patch 7 (2023.2/2690760) (2024/12/04)

	#2686057 (Job #122076) **
	    The command-line client on Windows now prints an error when it
	    detects ambiguous argument encoding.

	#2685395 (Job #122569) * **
	    cURL has been upgraded 8.10.1

	#2684191 (Job #122784) **
	    Corrected crash when authentication fails during istat operation.

	#2684190 (Job #119735) **
	    On Windows, network share access permissions for RCS depot archives
	    can cause a crash.  This has been resolved.

	#2682372 (Job #123443) **
	    Commands run through a broker and then forwarded to another server
	    will no longer cause hangs for successive commands run on the same
	    connection after a client could have reported client stats.

	#2682087 (Job #117647) **
	    A crash in 'p4 transmit -r' has been corrected.

	#2680581 (Job #121121) **
	    Corrected an unexpected 'Files are missing as a result of one or
	    more move operations' error in the fetch, push, and zip commands.

	#2678661(Job #123034) **
	    Setting a trigger command to an empty string will now result in an
	    error on execution rather than allow the undefined behavior.

	#2676563 (Job #123250) **
	    Security fix. Addressed CVE-2024-10314, CVE-2024-10344 and
	    CVE-2024-10345

	#2672451 (Job #120977) **
	    Fixed a problem where a user with openstreamspec permission could
	    open a stream spec but not edit the stream spec. Also fixed a
	    problem where a user with writestreamspec permission could not edit
	    and save a new stream spec.

	#2670374 (Job #123015) **
	    Fixed locking order bug when obliterating a stream and the
	    configurable index.domain.owner is 1.

	#2666580 (Job #123094) * ** *** ****
	    OpenSSL has been upgraded to 3.0.15

	#2660857 (Job #113058) **
	    Fixed stream spec obliterate problem where a super or admin user
	    could not obliterate the stream spec if configurable
	    dm.protects.streamspec was set to 1.

	#2659107 (Job #122472) **
	    A rare infinite loop caused by an over-optimisation when scanning
	    the rev table has been fixed.

	#2656735 (Job #121134) **
	    Fixed istat crash with noinherit ParentView when db.bodtextcx rows
	    are missing.

	#2648896 (Job #117955) * **
	    The zlib deflate operation uses x64 instructions not supported on older
	    CPUs raising an illegal instruction exception. This has been fixed.

	#2648680 (Job #120764) **
	    Removed unnecessary error "Error object passsed to database already
	    with an error" when attempting to switch a stream workspace with
	    unresolved issues. 

	#2641569 (Job #119153) *
	    The performance of 'p4 streams --viewmatch //...' and similar
	    wildcarded paths has been improved by changing the output to
	    include all lines in the stream whose depot mappings intersect
	    with the wildcarded path, rather than identifying the specific
	    line that is used to map a given file in the stream. Specific
	    matching lines are still returned when a single file is used as
	    the --viewmatch argument.

	#2639165 (Job #115877) **
	    On an edge-server 'p4 submit' following a 'p4 integ -v' could fail
	    with "No such file or directory". This change fixes the problem.

Bugs fixed in 2023.2 Patch 6 (2023.2/2633816) (2024/08/02)

	#2633514 (Job #121790) **
	    If a virus scanner locks a portion of an RCS temp file during
	    a pull operation, a crash may occur.  This has been corrected.

	#2631134 (Job #119346) **
	    In case of a commitServer-Edge-ForwardingReplica chain, there was a
	    problem where on ForwardingReplica a 'p4 submit' after Integ/Resolve
	    could fail because archive files were missing on the Edge server.
	     This change fixes the problem by pulling the missing archive-files
	     for the Edge server when needed, allowing 'p4 submit' to succeed.

	#2631130 (Job #119795) **
	    For p4 fetch', if '-I' flag is used the command could fail
	    unexpectedly with a 'Cannot import' error. This change fixes the
	    problem.

	#2630390 (Job #121621) **
	    Setting a very low value of db.checkpoint.reqlevel can allow a
	    multifile parallel checkpoint or dump to skip small db.files.
	    This has been fixed.

	#2620238 (Job #121119) ** ***
	    Fix for client 'clobber' option being dropped when syncing
	    through a proxy.

	#2619519 (Job #119772) **
	    Fixed a journal inconsistency issue on non-Windows platforms caused
	    by killing a running p4 command.

	#2619516 (Job #121240) **
	    The 'p4 lock' and 'p4 unlock' commands can now be cancelled by
	    using 'p4 monitor terminate' or pressing Ctrl-C on the client.

	#2613923 (Job #110263) **
	    This change fixes a performance problem in 'p4 obliterate' where it
	    was causing excessive time on edge-server to purge related db.label
	    records.

	#2613565 (Job #114829) **
	    For 'p4 fstat' locking db.revcx for long period could block other
	    commands like 'p4 submit' to run simultaneously. This change fixes
	    the problem by altering db.revcx lock mode to PEEK mode, if
	    db.peeking is set to greater than 2.

	#2613267 (Job #115232) **
	    This change introduces a new flag, -E, for p4 copy. The -E flag
	    overrides the current setting for the 'dm.integ.tweaks'
	    configurable and its effect is the same as having
	    'dm.integ.tweaks' set to 32. This flag, similar to the
	    configurable 'dm.integ.tweaks', is kept undoc.

	#2612833 (Job #121091) **
	    Fixed reversion of an open stream spec when using the command
	   'p4 revert -a -Si filelist...'.

	#2611936 (Job #87618) **
	    Ignored branch records resulting from a cherry-pick now only
	    grant credit for the cherry-picked revisions, rather than
	    implicitly including all prior revisions as is the case for a
	    normal branch record.  This fixes a problem in which an ignored
	    branch of a file that was copied from an old revision did not
	    grant any credit at all on subsequent integrations.

	#2611912 (Job #120791) **
	    Fixed stream obliterate endless loop problem.

	#2610994 (Job #121079) **
	    Fixed reversion of an open stream spec when using the command
	    'p4 revert -n -Si filelist...'.

	#2608651 (Job #120840) **
	    If a Helix Core Server is configured with no logging, a crash may
	    occur. This has been corrected.

Bugs fixed in 2023.2 Patch 5 (2023.2/2605454) (2024/05/31)

	#2605272 (Job #112564) **
	    Added 'dm.protects.exclusioncheck' check to 'p4 servers',
	    'p4 remotes', 'p4 switch', and 'p4 print'. 

	#2604189 (Job #118997) **
	    'dm.protects.exclusioncheck' no longer blocks the owner of
	    sub-protection table from modifying it.

	#2601050 (Job #115864) **
	    The client filesize cache data is now replicated. If filesize data
	    needs to be generated on a replica, the required archives are pulled
	    on-demand if not already replicated.
	
	#2600788 (Job #120474) **
	    Replication of a journal rotation event from an upstream server
	    using journalcopy can no longer enter a loop.
	
	#2600787 (Job #116689) **
	    Replicas configured with 'lbr.replication=cache' will now check for
	    a running archive pull thread before triggering deferred archive
	    replication for files being sync'ed.

	#2583561 (Job #119810) **
	    The error message "db.group locked after db.stream" no longer
	    appears when submitting a stream spec on an edge server and
	    then issuing a stream command. Previously, this error could
	    occur in P4V or any client that uses a shared connection.

	#2581410 (Job #119854) ** ***
	    Client stats are no longer collected when a proxy server prior to
	    this patch is used, preventing a potential hang when multiple
	    commands are run on the same connection.

	#2580609 (Job #113605) **
	    When 'p4 verify -S @=<change#>' is run with a change# that is not
	    shelved, or was shelved previously and then the shelf was deleted,
	    'p4 verify' for this case would incorrectly output files from other
	    shelved changes. This change fixes the problem.

	#2579716 (Job #119203) **
	    A non-parallel checkpoint request using more than one thread
	    did not ensure that the CHECKPOINT_HEADER note appeared as the
	    first line in the output file. Also the same checkpoint on
	    a Windows platform did not use the correct line ending. This
	    has been fixed.

Bugs fixed in 2023.2 Patch 4 (2023.2/2578891) (2024/03/29)

	#2578808 (Job #119853) **
	    A performance regression introduced in the 2023.1 release for the
	    'p4 fstat' command with a large client map has been corrected to
	    previous release levels.

	#2576343 (Job #112901) **
	    If a file was added with the same name as a file which had
	    previously been moved, then a 'p4 verify' might erroneously
	    report the readded file was missing.  This has been fixed.

	#2576339 (Job #119453) **
	    Fixed "db.streamview locked after db.domain" error when submitting
	    an opened stream spec.

	#2571460 (Job #119638) **
	    Ensure all interfaces are listed in tagged output for
	    'p4 license -L'.

	#2571445 (Job #119620) **
	    The initial 2023.2 release changed the order of precedence for
	    multiple 'p4 labelsync' arguments that reference the same depot
	    file.  This change reverts it to the 2022.2 behavior.  Note that
	    the behavior of conflicting labelsync arguments is not currently
	    documented or formally defined, so any workflows that depend on
	    it are unsupported, and may be negatively impacted by this patch.

	#2567132 (Job #119493) **
	    Fixed stream view generation at a specific change causing an 
	    endless loop during upgrade, where the loop occurs for the stream's
	    ancestors and the stream itself is not in the loop.

	#2567021 (Job #119441) **
	    The aggregate MD5 was not created for a parallel checkpoint on a 
	    replica. This has been fixed.

	#2569178 (Job #114849) **
	    The fix for job #84375 inadvertently caused issues for the
	    'SearchBindPasswd' field of the 'p4 ldap' specification, resulting 
	    in authentication failures when using that LDAP connection; this
	    has been fixed

Bugs fixed in 2023.2 Patch 3 (2023.2/2563409) (2024/02/27)

	#2558646 (Jobs #118375, #112333) **
	    On Windows the atomic rename api is limited in scope by the OS.
	    With this change the atomic rename is first attempted, if the
	    atomic rename fails the operation falls back to a copy truncate.

	#2557887 (Job #119417) **
	    Fixed a crash when 'p4 unshelve -b/-S' encountered an error.

	#2556700 (Job #102151) **
	    This change improves 'p4 sync' performance with complex views by
	    increasing the lookback limit from the previous value of 8 to a
	    value set by the new configurable maxLookBack with a default value
	    of 1000.

	#2555959 (Job #116293) **
	    'p4 search' could get stuck when putting a read-lock on the ixtext
	    table. This change fixes the problem by switching to lockless access
	    for the table.

	#2555497 (Job #116539) **
	    It was possible for the table dump command 'p4d -jd' to create
	    the MD5 checksum file even when the command had failed. This
	    has been fixed.

	#2553624 (Job #119254) **
	    A parallel recovery would leak memory on note entries in the
	    replay file(s). This has been fixed.

	#2554082 (Job #119336) **
	    OpenLDAP has been upgraded 2.4.17

	#2552714 (Job #118004) **
	    On-demand fetching of archives from a replica will now cause the
	    commit server to perform a fetch on-demand if the archive has not
	    yet been transferred from an edge server as part of a background
	    submit. The client requesting the file content will no longer
	    receive a librarian error in this situation.

	#2551998 (Job #118593) **
	    An Extension implementing a 'pressure-pause' hook no longer prevents
	    updates to the trigger table.

	#2548434 (Job #118559) * ** *** ****
	    Clients now call shutdown() before closing a network connection
	    in order to process all pending packets and ensure a clean
	    connection shutdown. In particular, pending packets will not
	    be lost when a client is terminated via control-c (^C).

	#2548082 (Jobs #107457, #117470, #118998, #117719) * ** *** ****
	    Improve SSL connection establishment under heavy load. In particular,
	    this eliminates the "wrong version number" error when the client
	    is slow to initiate the SSL handshake after establishing the TCP
	    connection.

	    Improve SSL error detection and handling to prevent reporting
	    non-existent SSL errors. Previously this was theoretically
	    possible but had not been observed.

	    Ignore spurious SSL errors detected during SSL client and server
	    initialization to prevent reporting non-existent SSL errors.
	    Previously this was theoretically possible but had not been
	    observed.

	    Make SSL error handling more robust and provide more detailed
	    and user-friendly SSL error messages.

	#2547699 (Job #118566) **
	    Parallel recoveries did not detect a case handling mismatch between
	    the server and recovery files. This has been fixed.

	#2546176 (Job #118002) **
	    'p4 obliterate' can no longer write archive delete journal notes
	    when a journal rotation is in progress.

	#2544323 (Job #118360) **
	    Replacing a trait value that had been saved in the trait depot
	    with a value that is saved in db.traits would cause the
	    trait depot depotfile to not be removed. This has been fixed.

	#2541675 (Job #115632) **
	    Fixed auto-shelve of modified content on distribution server when
	    switching between streams.

	#2538285 (Job #118756) **
	    Attempts to assign a negative value to a date field are now
	    blocked.

	#2538275 (Job #118549) **
	    The server does not handle date fields containing negative values
	    correctly. This has been fixed.

Bugs fixed in 2023.2 Patch 2 (2023.2/2535420) (2023/12/19)

	#2534278 (Job #118635) **
	    A severe performance regression for 'p4 jobs -e Date>=yyyy/mm/dd'
	    and similar queries was introduced in the initial 2023.2 release,
	    causing all numeric db.ixtext entries to be scanned in the course
	    of retrieving dates matching the specified range.  This is fixed.

	#2533190 (Job #114420) **
	    'p4 renameuser' no longer takes long write locks on db.monitor.

	#2528293 (Job #118342) **
	    The monitor level stored by 'rt.monitorfile' is no longer reset to
	    0 when each new command starts.

	#2532094 (Job #116191) **
	    Fixed DVCS fetch, push and zip commands incorrectly reporting a
	    split move across changelists.

	#2531016 (Job #118395) **
	    Set digest/filesize on text+k files for 'p4 change -t' command. 

Bugs fixed in 2023.2 Patch 1 (2023.2/2523307) (2023/11/22)

	#2523153 (Job #118298) **
	    Back out change 2490421 as it has not had the desired effect
	    in customer environments.

	#2521944 (Job #118198) **
	    'p4 license -L' no longer reports the MAC addresses of network
	    interfaces that do not have IPv4 or IPv6 addresses.

Bugs fixed in 2023.2 (2023.2/2519561) (2023/11/14)

	#2516988 (Job #116628) **
	    Revisions without an archive that were retyped using the force flag
	    could cause an error when replicated to an edge. These revisions
	    are now marked as 'missing' and ignored for replication.
	    'p4 fstat' in tagged mode will report the 'isMissing' tag for
	    these revisions.

	#2512340 (Job #117646) **
	    'p4 unshelve' with multiple files as parameters, if this file-list
	    is not sorted, could erroneously report 'can't unshelve (already
	    opened for edit using a different client view path)'. This change
	    fixes the problem.

	#2508491 (Job #116102) * ** *** ****
	    OpenSSL has been upgraded to 3.0.12
	    
	#2505273 (Job #112432) **
	    'p4 fetch' and 'p4 push' commands now update LastFetch/LastPush
	    when user provided filespec argument does not limit remote view.

	#2504803 (Job #117741) * **
	    cURL (for extensions) has been upgraded 8.4.0 to address multiple
	    cURL CVEs: CVE-2023-38545 and CVE-2023-38546

	#2499611 (Job #90618, #117153) * ** *** ****
	    Security fix. Addressed CVE-2023-5759.

	#2496083 (Job #117185) **
	    The 'db.checkpoint.threads' configurable override was not
	    supported for non-parallel checkpoint and dump requests started
	    directly with 'p4d' via the '-N threads' option and requests
	    started by the 'p4 admin checkpoint' command via the '-n threads'
	    option. This has been fixed.

	#2495972 (Job #114613) **
	    If 'p4 unlock -f' is run for a bunch of individual files, it could
	    result unnecessary scanning of db.domain and holding lock on this
	    table for a long period of time, blocking out other commands. This
	    change fixes the problem.

	#2494767 (Job #117156) **
	    Security fix. Addressed CVE-2023-35767.

	#2493556 (Job #117155) **
	    Security fix. Addressed CVE-2023-45849.

	#2491456 (Job #107898) **
	    'p4 annotate' unnecessarily scanned additional db.rev records
	    when following integration history through files with protection
	    exclusions.  This has been fixed.

	#2491397 (Job #117154) **
	    Security fix. Addressed CVE-2023-45319.

	#2490421 (Job #107457) * ** *** ****
	    Failed SSL connection attempts now produce more detailed
	    and accurate error messages, making it easier to diagnose
	    incorrect SSL configurations. In particular, if a server
	    is experiencing more simultaneous SSL connection attempts
	    than it can handle then it will produce a message to that
	    effect rather than producing a generic SSL failure message.
	    Additionally, transient connection errors are retried more
	    robustly, so some connection attempts that would previously
	    have failed may now succeed.

	#2489148 (Job #117392) **
	    There was a data race between threads in the 'p4 storage -U' command.
	    This has been fixed.

	#2488264 (Job #117222) **
	    Ensures that 'p4d -jr' command to replay the checkpoint in a
	    non empty directory does not update the existing database files.

	#2488070 (Job #117270) **
	    Fixed a component stream validation error when reparenting a stream.

	#2487821 (Job #114933) **
	    When a lazy copy file is sent using 'p4 unzip', 'p4 push' or
	    'p4 fetch' and the source is not part of the package, it will be
	    imported as a non-lazy copy file.

	#2484430 (Job #113319) **
	    Using 'p4 unzip' with -I option to exclude integration records
	    no longer causes a crash when the source of a lazy copy is not
	    included in the zip.

	#2482627 (Job #106491) **
	    'p4 zip' correctly includes archives for lazy copies when used with
	    a revision range.

	#2482523 (Jobs #117098, #117137) **
	    For a parallel checkpoint operation, the start time and end time
	    in the checkpoint history record were the same and the
	    'checkpoint' and 'journal' fields in the 'rotate-journal'
	    trigger were not set. This has been fixed.

	#2481875 (Job #117071) **
	    For 'changes -m -u' it may produce less than m lines, missing valid
	    records in the output. For 'p4 changes' with -i closure option,
	    it may produce result that does not include changes for the files
	    in the source of integration.

	#2479809 (Job #117093) **
	    The orphan scanner, 'p4 storage -l', does not work with space in
	    the depotdirectory argument. This has been fixed.

	#2475698 (Job #114250) **
	    Concurrent 'p4 unlock' and 'p4 lock' commands can result a deadlock
	    and system hang. This change fixes the problem.

	#2474301 (Job #116821) **
	    Some commands that take file paths with changelists specifiers will
	    now position in db.rev to get to the next file instead of scanning.

	#2469524 (Job #116678) **
	    'p4 submit' will no longer clear the commandGroup identifier during
	    the submit process.

	#2468060 (Job #111780) **
	    For 'p4 shelve' with a lot of content that dedups to existing
	    content, it produces lots of shelf archives to be deleted. In these
	    cases database tables stay locked for extended periods of time,
	    resulting performance degradation for other commands. This change
	    improves on this kind of database lock time.

	#2467384 (Job #115204) **
	    For 'p4 changes -m<maxChanges> <filepath>@<change>', this change
	    improves performance by quickly skipping over changes that have a
	    non-matching path.

	#2464103 (Job #115529) **
	    Many 'p4 diff2' commands run simultaneously can hold lock on
	    db.revsh blocking other commands for long periods of time. This
	    change improves performance by making db.revsh access lockless.

	#2463813 (Job #115585) **
	    'p4 topology --explain' now displays the long-form syntax for all
	    the topology options.

	#2463373 (Job #116078) **
	    A chained edge uses the server protocol version of the upstream
	    edge rather than the server protocol version of the commit
	    server. This has been fixed.

	#2463256 (Job #115584) **
	    'p4 topology -m' command now results in topology usage error when
	    used with the options '-a' or '-d'.

	#2462781 (Job #116121) **
	    P4ALTSYNC will now generate a digest on the fly for files that do
	    not have checksums stored in the database.

	#2462372 (Job #116376) **
	    The precedence of overlapping ChangeView entries, including those
	    generated for streams with multiple "import @change" Paths, was
	    not honored correctly.  This has been fixed.

	#2462343 (Job #116382) **
	    'p4 fstat -e CHANGE' would unnecessarily scan db.rev records for
	    files open in other changelists, making it very inefficient when
	    there were many such files.  This has been fixed.

	#2461940 (Job #116409) **
	    The stdout is now flushed after the starting checkpoint message is
	    generated. This is to help scripts determine the current checkpoint
	    number in use.

	#2461702 (Job #116306) **
	    Multifile checkpoints and dumps could contain duplicate records.
	    This has been fixed.

	#2461701 (Job #116373) **
	    The p4d help message now includes details on the -xj option to 
	    display db.ckphist records.

	#2460758 (Job #115558) **
	    'p4 unshelve' is no longer allowed for altsync enabled clients when
	    P4ALTSYNC is not configured correctly.

	#2459572 (Job #116187) **
	    P4ALTSYNC now works as expected with forwarding replicas.

	#2459572 (Job #116348) **
	    Command group logging information is now correctly passed upstream
	    from forwarding-replicas.

	#2459453 (Job #116334) **
	    Tracking metrics for 'rdb.lbr' activity is now reported for
	    scheduling the transfers of missing and bad depot files during
	    a 'p4 verify -t' command.

	#2457982 (Job #116141, #116277) **
	    Fixed problems with upgrade when a stream's view could not be
	    generated.

	#2456741 (Job #116101) * **
	    cURL (for extensions) has been upgraded 8.1.2 to address multiple
	    cURL CVEs: CVE-2023-28319 and CVE-2023-28322

	#2455354 (Job #115964) **
	    'p4 streams -F' would automatically escape the '&' query operator
	    in the special case where it immediately followed the string 'import';
	    this would cause a query parse error when combining two queries with '&'
	    if the first query ended with 'import'.  The automatic escaping behavior
	    has been removed and 'p4 help streams' has been clarified to explain
	    how to escape query operators that are part of a search expression.

	#2454956 (Job #115981) **
	    'p4 sync' of a symlink type file with P4ALTSYNC no longer causes
	    an infinite loop.

	#2453580 (Job #116086) **
	    'p4 fstat -m1 -S //...` once again performs a correct count of all
	    files.

	#2452968 (Job #114741, #115631, #115812) **
	    'p4 streams --viewmatch' has been significantly reworked in order
	    to more accurately return the exact set of streams whose views
	    match a given depot file and to eliminate unnecessary scans of
	    db.streamviewx.

	#2452668 (Job #116033) **
	    23.1 or later edge servers will now omit the altsync option if the
	    commit server has not been upgraded to at least 23.1.

	#2450824 (Job #114820) **
	    'p4 reload -p' will now correctly report errors to the users and if
	    a journalwait is required, the correct journal offset is now used.

	#2449796 (Job #116005) **
	    'p4 add' of a file in a client overlay path could unnecessarily scan
	    all mapped db.revhx records.  Fixed.

	#2448510 (Job #114845) **
	    Parallel checkpoint and dump operations now create an aggregate
	    MD5 file to indicate success.

	#2445284 (Job #114041) **
	    For 'p4 submit' of a graph depot repository if the repository
	    includes submodule the submit would corrupt the repository by
	    replacing the submodule with the directory of the submodule. This
	    change fixes the problem.

	#2442805 (Job #115714) **
	    'p4 fstat -Oz' did not display lazy copies of purged or
	    deleted revisions. This has been fixed.

	#2442681 (Job #115619) **
	    Fixed a 'p4 zip' bug where one half of a move/delete pair was
	    wrongly declared to be missing.

	#2440369 (Job #115687) **
	    This ensures that the respective intermediary server log is not
	    spammed with the topology server warning related to skipping the
	    capture of the server records in the db.topology table in case of
	    any upstream server that is not upgraded to the version >= 2021.2.

	#2437067 (Job #110437) * ** *** ****
	    The network autotune algorithm has been corrected to address the rare
	    cases where large numbers of files being submitted to a Linux server
	    from a Windows client could stall or hang if autotune was enabled
	    (net.autotune=1).

	#2434383 (Job #115391) **
	    Fixed stream view generation at a specific change causing an 
	    endless loop during upgrade.

	#2433630 (Job #115113) **
	    Missing archives no longer cause 'p4 renameuser' to crash.

	#2433577 (Job #115504) **
	    For the graph depot command 'p4 receive-pack' if the pack-file
	    includes merge commits, it is possible for the process to take
	    apparently infinite time and never finish. This can show up as a
	    git-connector mirroring update that never completes. This change
	    fixes the problem.

	#2427917 (Job #114334) **
	    If a stream has one or more components, and a stream client
	    is set to have a StreamAtChange for a change which did not
	    involve the stream spec, then the client view might not
	    include the component stream views, or they might be wrong.
	    This has been fixed.

	#2427515 (Job #114761) **
	    A 'p4 retype -l' request on a revision with a shelved
	    integration generates incorrect records in the db.storage
	    and db.storagesh tables. This has been fixed.

	#2426423 (Job #100988) **
	    'p4 undo' previously gave a empty error message when there were
	    conflicts between different open actions for the same file.  Now it
	    correctly reports the problematic file, the two conflicting actions,
	    and relevant changelist numbers that can be used to break the undo up
	    into non-conflicting ranges.

	#2424554 (Job #87367) *
	    P4IGNORE now defaults to '.p4ignore', 'p4ignore.txt',
	    '$HOME/.p4ignore' and '$HOME/p4ignore.txt'.

	#2423690 (Job #115128) **
	    This change fixes a bug in 'p4 changes' when it is used with options
	    '-m<maxchanges> <filepath>@<changeNumber>'.
	    If the '-m' value is bigger than 10% of the number of changes, and
	    the filepath does not match the first file in a change but matches
	    other files in the change, then the change would be skipped. This
	    change fixes the problem.

	#2423392 (Jobs #114708, #114712) **
	    The default fields to the display checkpoint history command,
	    'p4d -xj', now includes the 'end' date stamp of the operation.
	    The journal date field is now set to the current time for a
	    parallel checkpoint or dump request.

	#2422126 (Job #114848) ** ***
	    p4 pull -l' command could put shared lock on rdb.lbr for the whole
	    duration of the command running, resulting overall performance
	    degradation for edge or proxy servers. This improves the performance
	    by changing 'pull -l' to quickly read all the records it needs and
	    release the lock.


--------------------------------------------------------------------------

Major new functionality in 2023.1 (2023.1/2442900) (2023/05/15)

	#2413980 (Job #104786) * ** ***
	    Support for alternative sync agents
	    
	    The client spec has a new '[no]altsync' option which specifies if
	    the client application should use an alternative sync agent
	    (specified by the P4ALTSYNC environment variable) to perform file
	    operations. The alternative sync agent will be invoked once per
	    connection and will be provided with file metadata instead of the
	    client application writing file content directly; the primary
	    use-case for this functionality is to update the state of virtual
	    file service providers.
	    
	    See: P4ALTSYNC in Helix Core Command-Line (P4) Reference 

	#2350943, #2339529, #2328309 (Jobs #112184, #112183, #111439) **
	    Parallel checkpoint and dump operations accept an 'm'
	    sub-option, that allows each individual database table to
	    be split into multiple checkpoint or dump files. This should
	    allow the checkpoint/dump workload to be spread more evenly
	    between the available threads. The recovery operation
	    supports the 'p' sub-option to recover a parallel checkpoint
	    directory.

	    See: "Parallel checkpointing, dumping and recovery" in the
	    Helix Core Server Administrator Guide 

Technology Preview features in 2023.1 (2023.1/2442900) (2023/05/15)

	#2419976 (Job #5077, #67496, #72878, #108158, #108325, #110287) **
	    Helix Core Server System Resource Monitoring

	    The server can now meter the amount of incoming work it accepts,
	    pausing or rejecting client requests if the amount of free
	    operating system memory or CPU availability is past a configurable
	    threshold.  This feature is platform-specific.  CPU pressure
	    responsiveness is only available on Linux systems with cgroups
	    v2 configured.  Memory awareness is available on all Linux
	    versions as well as Windows, but not on MacOS.

	    Contact Technical Support for guidance when enabling this feature
	    in a production environment.

	    See 'p4 help server-resources' for further information.

Minor new functionality in 2023.1 (2023.1/2442900) (2023/05/15)

	#2413707 (Job #19809) * **
	    'p4 sizes' has a new '-C' flag which causes the filesizes reported
	    to be based on the size that the file would be if written with the
	    current client connection; this accounts for line-ending conversion,
	    charset conversion for unicode/utf8/utf16 filetypes (including the
	    value of 'filesys.utf8bom') and keyword expansion for +k type files.
	    These variables may be overridden with the following additional new
	    flags:
	        -B utf8bom     - Override 'filesys.utf8bom' for utf8 type files
	        -K             - Collapse keywords for +k type files
	        -L line-ending - Override the client's line ending setting
	        -Q charset     - Override P4CHARSET for unicode type files

	#2408924 (Job #114224) **
	    Logs now include the amount of time a command has spent in
	    the paused state (e.g. via 'p4 monitor pause').  Tracking output
	    in the P4LOG log file will show lines like '--- paused $seconds'.
	    Version 56 of the 'CommandEnd' event (1.56) in the structured logs
	    has a new field that represents the same data.

	    The 'serverlog.version.N' configurable can be used to pin a
	    structured log file to a specific server version's format.
	    To retain the prior structured log events format, set the
	    'serverlog.version.N' configurable to 55.

	#2399143 (Job #95529) **
	    The new 'p4 integrated -m <max>' option reports the latest
	    <max> integration records.

	#2397436 (Job #112553) **
	    The server on Linux can now protect itself from the OOM killer
	    during database writes.  This happens automatically when the
	    necessary capabilities have been granted to the server executable,
	    e.g. "sudo setcap 'CAP_SYS_RESOURCE=+ep' p4d".  A new server
	    startup log entry is now written with details about the detected
	    level of support for features like this.

	#2396097 (Job #112520) **
	    'p4 topology -m' now allows the user to mark the server record as
	    moved. Please see 'p4 help topology' for details.

	#2394721 (Job #112311) **
	    New server type 'distribution-server', can be used for content
	    distribution, requires new specific license.

	#2380883 (Job #113299) **
	    The 'p4 admin checkpoint' command now supports the parallel
	    checkpoint and multifile options (-p, -m, -N threads).

	#2373917 (Job #112371) **
	    Long-running server processes now release more memory back to
	    the OS, resulting in up to half as much memory usage in some
	    situations.

	#2368014 (Job #112446) * **
	    Compression-related tasks are now ~38% faster on 64-bit X86.
	    E.g. 'p4 submit' on 'binary' filetypes.

	#2367890 (Job #110101) *** ****
	    The default Perforce mimalloc memory manager configurables are now
	    used in the Proxy and Broker.

	#2359921 (Job #111565) **
	    New flag --preserve-change-numbers added to 'p4 push' and 'p4 fetch'
	    may be used to preserve the pushed/fetched change numbers on the
	    target server, command will fail if there are any conflicting
	    changelist numbers.
	    Configurable 'dm.fetch.preservechangenumbers' disabled by default,
	    can be enabled (set to 1) on the target server for the same effect,
	    server restart not required.

	#2358093 (Job #112666) **
	    'p4 topology -D' now accepts the destination server address and the
	    server id to delete the record. Please see 'p4 help topology' for
	    details.

Bugs fixed in 2023.1 Patch 9 (2023.1/2797325) (2025/07/11)

	#2790706 (Jobs #123929) **
	    Fixed istat crash due to inconsistencies in stream spec data
	    originating from pre-19.1 servers. Run 'p4d -xf 123929' to fix
	    inconsistent data.

	#2793722 (Job #127398) **
	    The stream spec permission checking is no longer applied to submits
	    to streams that do not include a change to the stream spec.
	
	#2788870 (Job #127308) **
	    The modtime of binary files with either the +m modifier or with the
	    modtime option enabled in the client are now correctly passed to
	    altsync agents.

	#2775894 (Job #125223) **
	    We were mistakenly checking the permissions to stream spec when doing
	    submit to a classic depot. We have now stopped checking stream permissions
	    when submitting for a classic depot.

	#2729468 (Jobs #107457, #117470, #118998, #117719) * ** *** ****
	    Improve SSL connection establishment under heavy load. In particular,
	    this eliminates the "wrong version number" error when the client
	    is slow to initiate the SSL handshake after establishing the TCP
	    connection.

	    Improve SSL error detection and handling to prevent reporting
	    non-existent SSL errors. Previously this was theoretically
	    possible but had not been observed.

	    Ignore spurious SSL errors detected during SSL client and server
	    initialization to prevent reporting non-existent SSL errors.
	    Previously this was theoretically possible but had not been
	    observed.

	    Make SSL error handling more robust and provide more detailed
	    and user-friendly SSL error messages.

Bugs fixed in 2023.1 Patch 8 (2023.1/2722319) (2025/02/18)

	#2720928 (Job #124712) **
	    In rare cases the setup to run p4diag automatically can fail on
	    Windows Server 2022 Enterprise without a desktop installed.  This
	    has been corrected.

	#2717516 (Job #124613) **
	    Setting 'auth.ldap.ssllevel=2' on a Windows server will no longer
	    allow connections to LDAP servers with self-signed certificates
	    unless that certificate is installed into the CA store or is
	    specified with 'auth.ldap.cafile'.

	#2713835 (Job #124534) **
	    Serverlocks on Windows servers are no longer deleted in such a way
	    that on rare occasions synchronous operations could occur in
	    parallel.

	#2709957 (Job #122963) **
	    On an edge server with configurables submit.allowbgtransfer=1 and
	    submit.autobgtransfer=1 set, when a file edit is submitted without
	    change, the option '-f submitunchanged' of submit would fail to
	    override 'revertunchanged' from client spec and it would result
	    submit failing with: "No files to submit". This change fixes the
	    problem.

	#2707697 (Jobs #124317, #124320) * **
	    P4ALTSYNC agents are now provided with a 'time' field containing
	    the modtime to set on add/added files of type +m or when the
	    modtime client option is enabled.

	#2698519 (Job #120059) **
	    There is a race condition between directory removal and archive
	    creation on an edge during a 'p4 submit -e' for binary file types.
	    This has been fixed.

Bugs fixed in 2023.1 Patch 7 (2023.1/2693640) (2024/12/10)

	#2692636 (Job #122076) *
	    The command-line client on Windows now prints an error when it
	    detects ambiguous argument encoding.

	#2689099 (Job #114420) **
	    'p4 renameuser' no longer takes long write locks on db.monitor.

	#2686336 (Job #122784) **
	    Corrected crash when authentication fails during istat operation.

	#2685392 (Job #122569) * **
	    cURL has been upgraded 8.10.1

	#2685151 (Job #119735) **
	    On Windows, network share access permissions for RCS depot archives
	    can cause a crash.  This has been resolved.

	#2682942 (Job #117647) **
	    A crash in 'p4 transmit -r' has been corrected.

	#2680582 (Job #121121) **
	    Corrected an unexpected 'Files are missing as a result of one or
	    more move operations' error in the fetch, push, and zip commands.

	#2679937 (Job #114613) **
	    If 'p4 unlock -f' is run for a bunch of individual files, it could
	    result unnecessary scanning of db.domain and holding lock on this
	    table for a long period of time, blocking out other commands. This
	    change fixes the problem.

	#2678662 (Job #123034) **
	    Setting a trigger command to an empty string will now result in an
	    error on execution rather than allow the undefined behavior.

	#2676561 (Job #123250) **
	    Security fix. Addressed CVE-2024-10314, CVE-2024-10344 and
	    CVE-2024-10345

	#2671237 (Job #120977) **
	    Fixed a problem where a user with openstreamspec permission could
	    open a stream spec but not edit the stream spec. Also fixed a
	    problem where a user with writestreamspec permission could not edit
	    and save a new stream spec.

	#2670367 (Job #123015) **
	    Fixed locking order bug when obliterating a stream and the
	    configurable index.domain.owner is 1.

	#2666580 (Job #123094) * ** *** ****
	    OpenSSL has been upgraded to 3.0.15

	#2660279 (Job #113058) **
	    Fixed stream spec obliterate problem where a super or admin user
	    could not obliterate the stream spec if configurable
	    dm.protects.streamspec was set to 1.

	#2648895 (Job #117955) * **
	    The zlib deflate operation uses x64 instructions not supported on
	    older CPUs raising an illegal instruction exception. This has been
	    fixed.

	#2640332 (Job #120764) **
	    Removed unnecessary error "Error object passsed to database already
	    with an error" when attempting to switch a stream workspace with
	    unresolved issues. 

Bugs fixed in 2023.1 Patch 6 (2023.1/2633133) (2024/08/01)

	#2632065 (Job #121790) **
	    If a virus scanner locks a portion of an RCS temp file during
	    a pull operation, a crash may occur.  This has been corrected.

	#2631131 (Job #119346) **
	    In case of a commitServer-Edge-ForwardingReplica chain, there was a
	    problem where on ForwardingReplica a 'p4 submit' after Integ/Resolve
	    could fail because archive files were missing on the Edge server.
	    This change fixes the problem by pulling the missing archive-files
	    for the Edge server when needed, allowing 'p4 submit' to succeed.

	#2631129 (Job #119795) **
	    For p4 fetch', if '-I' flag is used the command could fail
	    unexpectedly with a 'Cannot import' error. This change fixes the
	    problem.

	#2630390 (Job #121621) **
	    Setting a very low value of db.checkpoint.reqlevel can allow a
	    multifile parallel checkpoint or dump to skip small db.files.
	    This has been fixed.

	#2620239 (Job #121119) ** ***
	    Fix for client 'clobber' option being dropped when syncing
	    through a proxy.

	#2619518 (Job #119772) **
	    Fixed a journal inconsistency issue on non-Windows platforms caused
	    by killing a running p4 command.

	#2619515 (Job #121240) **
	    The 'p4 lock' and 'p4 unlock' commands can now be cancelled by
	    using 'p4 monitor terminate' or pressing Ctrl-C on the client.

	#2613734 (Job #115232) **
	    This change introduces a new flag, -E, for p4 copy. The -E flag
	    overrides the current setting for the 'dm.integ.tweaks'
	    configurable and its effect is the same as having
	    'dm.integ.tweaks' set to 32. This flag, similar to the
	    configurable 'dm.integ.tweaks', is kept undoc.

	#2613026 (Job #112564) **
	    Added 'dm.protects.exclusioncheck' check to 'p4 servers',
	    'p4 remotes', 'p4 switch', and 'p4 print'.

	#2612594 (Job #114829) **
	    For 'p4 fstat' locking db.revcx for long period could block other
	    commands like 'p4 submit' to run simultaneously. This change fixes
	    the problem by altering db.revcx lock mode to PEEK mode, if
	    db.peeking is set to greater than 2.

	#2611896 (Job #121091) **
	    Fixed reversion of an open stream spec when using the command
	   'p4 revert -a -Si filelist...'.

	#2610973 (Job #120791) **
	    Fixed stream obliterate endless loop problem.

	#2610961 (Job #87618) **
	    Ignored branch records resulting from a cherry-pick now only
	    grant credit for the cherry-picked revisions, rather than
	    implicitly including all prior revisions as is the case for a
	    normal branch record.  This fixes a problem in which an ignored
	    branch of a file that was copied from an old revision did not
	    grant any credit at all on subsequent integrations.

	#2609822 (Job #121079) **
	    Fixed reversion of an open stream spec when using the command
	   'p4 revert -n -Si filelist...'.

	#2609129 (Job #120840) **
	    If a Helix Core Server is configured with no logging, a crash may
	    occur. This has been corrected.

	#2606107 (Job #120474) **
	    Replication of a journal rotation event from an upstream server
	    using journalcopy can no longer enter a loop.

	#2606075 (Job #115864) **
	    The client filesize cache data is now replicated. If filesize data
	    needs to be generated on a replica, the required archives are pulled
	    on-demand if not already replicated.

	#2603176 (Job #110263) **
	    This change fixes a performance problem in 'p4 obliterate' where it
	    was causing excessive time on edge-server to purge related db.label
	    records.

	#2601166 (Job #118997) **
	    'dm.protects.exclusioncheck' no longer blocks the owner of
	     sub-protection table from modifying it.

	#2580610 (Job #113605) **
	    When 'p4 verify -S @=<change#>' is run with a change# that is not
	    shelved, or was shelved previously and then the shelf was deleted,
	    'p4 verify' for this case would incorrectly output files from other
	    shelved changes. This change fixes the problem.

	#2580259 (Job #119810) **
	    The error message "db.group locked after db.stream" no longer
	    appears when submitting a stream spec on an edge server and
	    then issuing a stream command. Previously, this error could
	    occur in P4V or any client that uses a shared connection.

	#2579717 (Job #119203) **
	    A non-parallel checkpoint request using more than one thread did
	    not ensure that the CHECKPOINT_HEADER note appeared as the first
	    line in the output file. Also the same checkpoint ona Windows platform
	    did not use the correct line ending. This has been fixed.


Bugs fixed in 2023.1 Patch 5 (2023.1/2576871) (2024/03/25)

	#2576352 (Job #112901) **
	    If a file was added with the same name as a file which had
	    previously been moved, then a 'p4 verify' might erroneously
	    report the readded file was missing.  This has been fixed.

	#2576348 (Job #119453) **
	    Fixed "db.streamview locked after db.domain" error when submitting
	    an opened stream spec.

	#2570973 (Job #119620) **
	    The initial 2023.1 release changed the order of precedence for
	    multiple 'p4 labelsync' arguments that reference the same depot
	    file.  This change reverts it to the 2022.2 behavior.  Note that
	    the behavior of conflicting labelsync arguments is not currently
	    documented or formally defined, so any workflows that depend on
	    it are unsupported, and may be negatively impacted by this patch.

	#2569182 (Job #114849) **
	    The fix for job #84375 inadvertently caused issues for the
	    'SearchBindPasswd' field of the 'p4 ldap' specification, resulting 
	    in authentication failures when using that LDAP connection; this
	    has been fixed

	#2567499 (Job #119441) **
	    The aggregate MD5 was not created for a parallel checkpoint on a 
	    replica. This has been fixed.

	#2566234 (Jobs #118375, #112333) **
	    On Windows the atomic rename api is limited in scope by the OS.
	    With this change the atomic rename is first attempted, if the
	    atomic rename fails the operation falls back to a copy truncate.

	#2564640 (Job #119493) **
	    Fixed stream view generation at a specific change causing an 
	    endless loop during upgrade, where the loop occurs for the stream's
	    ancestors and the stream itself is not in the loop.

	#2562156 (Job #119336) **
	    OpenLDAP has been upgraded 2.4.17

Bugs fixed in 2023.1 Patch 4 (2023.1/2560797) (2024/02/22)

	#2557622 (Job #119417) **
	    Fixed a crash when 'p4 unshelve -b/-S' encountered an error.

	#2557496 (Job #116539) **
	    It was possible for the table dump command 'p4d -jd' to create
	    the MD5 checksum file even when the command had failed. This
	    has been fixed.

	#2557184 (Job #116293) **
	    'p4 search' could get stuck when putting a read-lock on the ixtext
	    table. This change fixes the problem by switching to lockless access
	    for the table.

	#2557097 (Job #102151) **
	    This change improves 'p4 sync' performance with complex views by 
	    increasing the lookback limit from the previous value of 8 to a 
	    value set by the new configurable maxLookBack with a default value 
	    of 1000.

	#2553623 (Job #119254) **
	    A parallel recovery would leak memory on note entries in the
	    replay file(s). This has been fixed.

	#2552713 (Job #118004) **
	    On-demand fetching of archives from a replica will now cause the
	    commit server to perform a fetch on-demand if the archive has not
	    yet been transferred from an edge server as part of a background
	    submit. The client requesting the file content will no longer
	    receive a librarian error in this situation.

	#2552001 (118593) **
	    An Extension implementing a 'pressure-pause' hook no longer prevents
	    updates to the trigger table.

	#2547700 (Job #118566) **
	    Parallel recoveries did not detect a case handling mismatch between
	    the server and recovery files. This has been fixed.

	#2546175 (Job #118002) **
	    'p4 obliterate' can no longer write archive delete journal notes
	    when a journal rotation is in progress.

	#2538969 (Job #115632) **
	    Fixed auto-shelve of modified content on distribution server when
	    switching between streams.

Bugs fixed in 2023.1 Patch 3 (2023.1/2534247) (2023/12/15)

	#2531279 (Job #116191) **
	    Fixed DVCS fetch, push and zip commands incorrectly reporting a
	    split move across changelists.

	#2531018 (Job #118342) **
	    Fixed segmentation violation with real-time monitoring enabled.

	#2531015 (Job #118395) **
	    Set digest/filesize on text+k files for 'p4 change -t' command.

Bugs fixed in 2023.1 Patch 2 (2023.1/2513900) (2023/11/03)

	#2512341 (Job #117646) **
	    'p4 unshelve' with multiple files as parameters, if this file-list
	    is not sorted, could erroneously report 'can't unshelve (already
	    opened for edit using a different client view path)'. This change
	    fixes the problem.

	#2510947 (Job #117156) **
	    Security fix. Addressed CVE-2023-35767.

	#2510257 (Job #117185) **
	    The 'db.checkpoint.threads' configurable override was not supported
	    for non-parallel checkpoint and dump requests started directly with
	    'p4d' via the '-N threads' option and requests started by the
	    'p4 admin checkpoint' command via the '-n threads' option. This has
	    been fixed.

	#2510009 (Job #112432) **
	    'p4 fetch' and 'p4 push' commands now update LastFetch/LastPush
	    when user provided filespec argument does not limit remote view.

	#2510008 (Job #117155) **
	    Security fix. Addressed CVE-2023-45849.

	#2510007 (Job #90618, #117153) * ** *** ****
	    Security fix. Addressed CVE-2023-5759.

	#2509225 (Job #111780) **
	    For 'p4 shelve' with a lot of content that dedups to existing
	    content, it produces lots of shelf archives to be deleted. In these
	    cases database tables stay locked for extended periods of time,
	    resulting performance degradation for other commands. This change
	    improves on this kind of database lock time.

	#2508491 (Job #116102) * ** *** ****
	    OpenSSL has been upgraded to 3.0.12

	#2508379 (Job #117154) **
	    Security fix. Addressed CVE-2023-45319.

	#2507034 (Job #117098) **
	    For a parallel checkpoint operation, the start time and end time
	    in the checkpoint history record were the same and the
	    'checkpoint' and 'journal' fields in the 'rotate-journal'
	    trigger were not set. This has been fixed.

	#2505991 (Job #117741) * **
	    cURL (for extensions) has been upgraded 8.4.0 to address multiple
	    cURL CVEs: CVE-2023-38545 and CVE-2023-38546

	#2505638 (Job #117392) **
	    There was a data race between threads in the 'p4 storage -U' command.
	    This has been fixed.

	#2498961 (Job #117071) **
	    For 'changes -m -u' it may produce less than m lines, missing valid
	    records in the output. For 'p4 changes' with -i closure option,
	    it may produce result that does not include changes for the files
	    in the source of integration.

	#2498788 (Job #115204) **
	    For 'p4 changes -m<maxChanges> <filepath>@<change>', this change
	    improves performance by quickly skipping over changes that have a
	    non-matching path.

	#2497916 (Job #114933) **
	    When a lazy copy file is sent using 'p4 unzip', 'p4 push' or
	    'p4 fetch' and the source is not part of the package, it will be
	    imported as a non-lazy copy file.

	#2494346 (Job #117292) **
	    Parallel checkpoint and dump requests do not honor the
	    'db.checkpoint.bufsize' configurable. This has been fixed. Note,
	    with this fix, 'filesys.bufsize' in no longer used to determine
	    the checkpoint write size.

	#2494008 (Job #117270) **
	    Fixed a component stream validation error when reparenting a stream.

	#2489953 (Job #117222) **
	    Ensures that 'p4d -jr' command to replay the checkpoint in a
	    non empty directory does not update the existing database files.
	    
	#2489812 (Job #113319) **
	    Using 'p4 unzip' with -I option to exclude integration records
	    no longer causes a crash when the source of a lazy copy is not
	    included in the zip.

	#2489147 (Job #106491) **
	    'p4 zip' correctly includes archives for lazy copies when used with
	    a revision range.

	#2480069 (Job #117741, #117093) **
	    The orphan scanner, 'p4 storage -l', does not work with space in
	    the depotdirectory argument. This has been fixed.

	#2478674 (Job #114250) **
	    Concurrent 'p4 unlock' and 'p4 lock' commands can result a deadlock
	    and system hang. This change fixes the problem.

	#2473031 (Job #115529) **
	    Many 'p4 diff2' commands run simultaneously can hold lock on
	    db.revsh blocking other commands for long periods of time. This
	    change improves performance by making db.revsh access lockless.

	#2468926 (Job #115585) **
	    'p4 topology --explain' now displays the long-form syntax for all
	    the topology options.

	#2468905 (Job #115584) **
	    'p4 topology -m' command now results in topology usage error when
	    used with the options '-a' or '-d'.

	#2468481 (Job #110437) * ** *** ****
	    The network autotune algorithm has been corrected to address the rare
	    cases where large numbers of files being submitted to a Linux server
	    from a Windows client could stall or hang if autotune was enabled
	    (net.autotune=1).

Bugs fixed in 2023.1 Patch 1 (2023.1/2468153) (2023/07/24)

	#2462781 (Job #116121) **
	    P4ALTSYNC will now generate a digest on the fly for files that do
	    not have checksums stored in the database.

	#2462349 (Job #116376) **
	    The precedence of overlapping ChangeView entries, including those
	    generated for streams with multiple "import @change" Paths, was
	    not honored correctly.  This has been fixed.

	#2462206 (Job #116382) **
	    'p4 fstat -e CHANGE' would unnecessarily scan db.rev records for
	    files open in other changelists, making it very inefficient when
	    there were many such files.  This has been fixed.

	#2461940 (Job #116409) **
	    The stdout is now flushed after the starting checkpoint message is
	    generated. This is to help scripts determine the current checkpoint
	    number in use.

	#2461701 (Job #116373) **
	    The p4d help message now includes details on the -xj option to 
	    display db.ckphist records.

	#2460758 (Job #115558) **
	    'p4 unshelve' is no longer allowed for altsync enabled clients when
	    P4ALTSYNC is not configured correctly.

	#2459572 (Job #116348) **
	    Command group logging information is now correctly passed upstream
	    from forwarding-replicas.

	#2459572 (Job #116187) **
	    P4ALTSYNC now works as expected with forwarding replicas.

	#2459439 (Job #114905) **
	    'p4 sync' is now more tolerant of out-of-memory conditions.
	    Note that the extra error handling included in this fix
	    makes 'p4 sync' honor MaxResults for files synced to the
	    workspace or opened, where it previously did not.

	#2459434 (Job #114906) **
	    'p4 filelog' is now more tolerant of out-of-memory conditions.

	#2459094 (Job #114845) **
	    Parallel checkpoint and dump operations now create an aggregate
	    MD5 file to indicate success.

	#2459030 (Job #116306) **
	    Multifile checkpoints and dumps could contain duplicate records.
	    This has been fixed.

	#2458373 (Job #116101) * **
	    cURL (for extensions) has been upgraded 8.1.2 to address multiple
	    cURL CVEs: CVE-2023-28319 and CVE-2023-28322

	#2458299 (Job #116141, #116277) **
	    Fixed problems with upgrade when a stream's view could not be
	    generated.

	#2455092 (Job #114741) **
	    Fixed a stream viewmatch bug where an exclude path might obscure a
	    share path in the generated streamviews.

	#2454956 (Job #115981) **
	    'p4 sync' of a symlink type file with P4ALTSYNC no longer causes
	    an infinite loop.

	#2453231 (Job #114820) **
	    'p4 reload -p' will now correctly report errors to the users and if
	    a journalwait is required, the correct journal offset is now used.

	#2453069 (Job #116086) **
	    'p4 fstat -m1 -S //...` once again performs a correct count of all
	    files.

	#2452668 (Job #116033) **
	    23.1 or later edge servers will now omit the altsync option if the
	    commit server has not been upgraded to at least 23.1.

	#2449758 (Job #116005) **
	    'p4 add' of a file in a client overlay path could unnecessarily scan
	    all mapped db.revhx records.  Fixed.

	#2448511 (Jobs #114708, #114712) **
	    The default fields to the display checkpoint history command,
	    'p4d -xj', now includes the 'end' date stamp of the operation.
	    The journal date field is now set to the current time for a
	    parallel checkpoint or dump request.

	#2447644 (Job #115980) * ** *** ****
	    OpenSSL has been upgraded to 1.1.1u

	#2446515 (Job #114761) **
	    A 'p4 retype -l' request on a revision with a shelved
	    integration generates incorrect records in the db.storage
	    and db.storagesh tables. This has been fixed.

	#2445284 (Job #114041) **
	    For 'p4 submit' of a graph depot repository if the repository
	    includes submodule the submit would corrupt the repository by
	    replacing the submodule with the directory of the submodule. This
	    change fixes the problem.

	#2444620 (Job #115391) **
	    Fixed stream view generation at a specific change causing an 
	    endless loop during upgrade.

	#2444614 (Job #115619) **
	    Fixed a 'p4 zip' bug where one half of a move/delete pair was
	    wrongly declared to be missing.

	#2443869 (Job #115687) **
	    This ensures that the respective intermediary server log is not
	    spammed with the topology server warning related to skipping the
	    capture of the server records in the db.topology table in case of
	    any upstream server that is not upgraded to the version >= 2021.2.

	#2442805 (Job #115714) **
	    'p4 fstat -Oz' did not display lazy copies of purged or
	    deleted revisions. This has been fixed.

Bugs fixed in 2023.1 (2023.1/2442900) (2023/05/15)

	#2440503 (Job #115503) * **
	    cURL (for extensions) has been upgraded 8.0.1 to address multiple
	    cURL CVEs: CVE-2023-27537, CVE-2023-23916, CVE-2023-23915 and
	    CVE-2023-23914

	#2439308 (Job #112863, #115676 ) **
	    The 'p4 failover' command could be run from a server that
	    has been prepared for the 'p4 failback' command by running
	    'p4d -Fm'. Now 'p4 failover' will fail in this situation with
	    an error message instructing the user to run 'p4 failback' instead.

	#2434101 (Job #115504) **
	    For the graph depot command 'p4 receive-pack' if the pack-file
	    includes merge commits, it is possible for the process to take
	    apparently infinite time and never finish. This can show up as a
	    git-connector mirroring update that never completes. This change
	    fixes the problem.

	#2429038 (Job #114515) **
	    Running 'p4 reopen' with multiple file arguments that include
	    moved files could cause a member of a moved pair to fail to be
	    reopened. This has been fixed.

	#2423940 (Job #115128) **
	    This change fixes a bug in 'p4 changes' when it is used with options
	    '-m<maxchanges> <filepath>@<changeNumber>'.
	    If the '-m' value is bigger than 10% of the number of changes, and
	    the filepath does not match the first file in a change but matches
	    other files in the change, then the change would be skipped. This
	    change fixes the problem.

	#2419973 (Job #111678) **
	    Starting with release 2023.1, servers using central authentication
	    (P4AUTH) require the central server's release version to be at least
	    2023.1. The central server must have a valid license, and must
	    be running when its outer servers are starting up or being upgraded.

	#2419808 (Job #113805) **
	    Queries against a client path with an overlay view would previously
	    be applied to all matching depot paths, meaning that a command
	    executed against a single file could return two (or more) results.
	    This behavior has been changed so that as a general rule, commands
	    which are expected to return a single result per file will only
	    return one depot result per client file when a client path is used,
	    according to the precedence specified in the client view.  Queries
	    against depot paths, or queries which permit multiple revisions to
	    be returned per matching file, are not affected by this change.

	#2417619 (Job #113622) **
	    StreamQWorker is now launched at server startup to finish any
	    leftover processing.

	#2417343 (Job #112669)
	    The Helix Core Proxy installers (.exe and .msi) use the property 
	    P4LOG instead of PRXYLOG to specify the name or path and name of
	    the Helix Core Proxy log file. Note that when upgrading from an old
	    version you will need to use the new property name.

	#2415891 (Job #67312) **
	    The Remapped field in stream specifications did not allow a target
	    path of "...", i.e., remapping into the root.  This has been fixed.

	#2415279 (Job #94950) **
	    Improved locking mechanism for the 'p4 unload' operation.

	#2412791 (Job #113923) **
	    When using the 'filesys.atomic.rename' configuration, an incorrect
	    journal size might be reported.  This has been fixed.

	#2411873 (Job #114552) **
	    The performance of 'p4 populate' has been improved by optimising
	    the inserts of integration records.

	#2409959 (Job #112599) **
	    An integration from a stream client might fail with an error
	    message "The target stream of a stream spec integration must
	    be the stream associated with the current client ...".  This
	    error should only occur when using a '-S' parameter with the 
	    integration command, but did sometimes occur when not using
	    '-S' when the parent of the associated stream has a noinherit
	    ParentView setting.  This has been fixed.

	#2409758 (Job #113006) **
	    The 'p4 client -df' command run on an edge server could result
	    in pending changes that are deleted on the edge but not on the
	    commit server. This would cause the db.change table contents on
	    the commit server to differ from the contents on the edge server.
	    This has been fixed.

	#2409493 (Job #112877) **
	    Replication of large transactions is now more efficient. Previously
	    if the upstream server had yet to complete a transaction, replicas
	    could get to the end of the running journal and then restart the
	    replication from the last consistency point; the repeated records
	    would be retained in memory on the replica. Replicas now continue
	    replication of transactions across requests to the upstream server,
	    preventing both repeated network transfers and reducing memory use.

	#2407879 (Job #113804) **
	    Depot paths that are overlaid in the client view (i.e. lower in
	    precedence than a +-mapping for the same client path) are now
	    considered read-only, similarly to &-mapped paths, in order to
	    avoid confusion around adding or branching files within ambiguously
	    mapped client paths.

	#2407742 (Job #113467) **
	    When a file was opened for 'add' with the exclusive open filetype
	    in a distributed environment and was submitted with the 'reopen'
	    option, the exclusive open type would not be set. This has been
	    fixed.

	#2405801 (Job #113970) **
	    Changes to the configuration 'filesys.atomic.rename' now only take
	    effect upon Server startup.  After changing this configurable, a
	    'p4 admin restart' is required.

	#2405137 (Job #113841) **
	    When using the SDP to recover a rotated / numbered journal
	    from an active Server, a sharing violation will no longer occur.

	#2404949 (Job #114063 ) **
	    If 'p4 license -i' fails due to an IP address change in a license
	    file, the error message now shows both the previous and expected IP
	    addresses.

	#2403655 (Job #114243) **
	    Intermediary server (Replica, Proxy, Broker, etc) login no longer
	    leads to the server crash if the commit server starts with an
	    unspecified host address.

	#2403229 (Jobs #113829, #113840) **
	    Parallel checkpoint, dump and recovery operations now create
	    a db.ckphist record. p4d now supports the '-xj' option to
	    display db.ckphist records.

	#2399402 (Job #113830) **
	    The configurable, 'db.checkpoint.nofiles', that specifies the
	    default split parameter for parallel multifile checkpoint
	    and dump operations has been renamed to 'db.checkpoint.numfiles'.
	    The help page and usage message for 'p4 dbstat' have been
	    updated to reflect this name change.

	#2398674 (Job #112505) **
	    The 'p4 group' on a replica working with an older commit server
	    would fail with error: "Unkown field name 'Description'". This
	    change fixes the problem.

	#2394917 (Job #102021) **
	    Replication on edge servers after large obliterates suffered
	    from poor performance due to excessive scanning on the db.domain
	    table. The performance issue caused by excessive
	    scanning of the db.domain table has been fixed.

	#2393897 (Job #113904) **
	    'p4 shelve -f -c' no longer leads to the deletion of shared shelve
	    archive files on the replica server.

	#2393497 (Job #114030) ****
	    Broker now handles MaxMemory when provided by the Helix Core
	    Command Line client (P4).

	#2393485 (Job #113985) **
	    Using the '-p' option to 'p4 dbstat' with a worklevel of 1
	    could cause a server crash. This has been fixed.

	#2392837 (Job #113967) **
	    Under certain configuration limitations 'p4 fstat' could throw an
	    exception.  This has been fixed.

	#2392735 (Job #113267) **
	    For 'p4 sync -E <path>@<label>', when label includes an unknown
	    change number, sync would incorrectly succeed by syncing to the
	    latest committed change. This change corrects it to fail with a
	    proper error message.

	#2932312 (Job #112760) **
	    Parallel checkpoint and dump operations now create an MD5 file
	    in the checkpoint/dump directory for each checkpoint/dump output
	    file created.

	#2391631 (Job #113971) **
	    Upgrade steps no longer run prematurely when being rerun on
	    a replica.

	#2391143 (Job #113915) **
	    Enabling the buffering of server logs could cause a deadlock.
	    This has been fixed.

	#2390874 (Job #87716) **
	    Users of type 'operator' can now run 'p4 journals'.

	#2390593 (Job #112639) **
	    This change improves performance for 'p4 changes' when it is used
	    with options: '-m<maxchanges> <filepath>@<changeNumber>'.
	    This is specially effective if filepath is not too narrow and
	    changes with matching files are not rare. If this is not the case,
	    this change can detect it and will follow the old logic so that
	    performance never gets noticeably worse.

	#2390102 (Jobs #23789, #113496, #113768) **
	    'p4 dirs' and all commands that accept branch mappings as command
	    arguments (e.g. 'p4 diff2 dir1/... dir2/...') produced incorrect
	    or duplicate results when using client paths in a client with
	    overlay mappings.  This has been fixed by disregarding overlays
	    when deriving branch mappings between depot paths from client
	    mappings; only the higher precedence depot path will be considered
	    in the generated mapping and in the command result when a client
	    path is specified.

	#2389867 (Job #113831) **
	    Rerunning the last number of upgrade steps by setting the 'upgrade'
	    counter back using the 'p4 counter -f upgrade <n-known-good>'
	    command on the innermost server and then restarting the
	    innermost server now behaves correctly: the upgrade steps beyond
	    the value of the 'upgrade' counter run and then replicate outward.

	#2389146 (Job #113495) **
	    The 'p4 fstat -L' command now performs less database work and
	    consumes fewer resources when run from workspaces with large
	    numbers of files synced.

	#2388212 (Job #111114) **
	    Changes to Extension instance configurations that resulted in
	    changed depot paths on events taking a depot path no longer
	    produce duplicated events for the Extension instance.

	#2387362 (Job #113622) **
	    Fixed a problem where viewmatch streamviews did not update after
	    child stream was deleted.

	#2384150 (Job #101277) **
	    The 'journal-rotate-lock' and 'journal-rotate' triggers are now
	    invoked on replicas that use journalcopy (e.g. standby servers)
	    at the point that that the 'pull -L' completes the replay of a
	    rotated journal.

	#2380509 (Job #112645) **
	    If the configurable 'dm.stream.components' is set 0, the commands
	    'p4 files', 'p4 fstat', and 'p4 dirs' no longer show files or dirs
	    which originate from component views.

	#2380501 (Job #112771) **
	    'p4 fstat' now displays pathPermissions of a file as well as the
	    effectiveComponentType if the file comes from a component view.
	    The pathPermissions value will either be 'readonly' (not submitable)
	    or 'writable' (submitable).  The effectiveComponent type is the
	    most restrictive component type in the chain of components from
	    which the file originates; the values will be 'readonly',
	    'writeimport+', or 'writeall'.

	#2380057 (Job #109988) **
	    'p4 info' run from P4V no longer takes an excessive number of
	    database locks.

	#2377082 (Job #112616) **
	    Since we changed the storage default to 'lbr.autocompress=1', The +D
	    type modifier that is entered through a typemap is ignored. This
	    change fixes the problem.

	#2376914 (Job #113459) **
	    An edge server chained to another edge server now correctly records
	    the target serverid in 'p4 topology'.

	#2376517 (Job #113377) **
	    'p4 storage -c changenum' did not work when 'changenum' had
	    been renumbered. This has been fixed.

	#2375904 (Job #112472) **
	    Improve performance of end of line handling during checkpointing
	    for Windows.

	#2375617 (Job #111069) **
	    Ensures that the sensitive data such as address, root, etc are
	    hidden in the Broker and Proxy info output for the unauthorised/
	    unauthenticated user when dm.info.hide is set.

	#2373920 (Job #113366) **
	    LuaSQLite3 for Extensions has been updated to the latest
	    revision (ba0ad5e0f0).

	#2372354 (Job #112649)
	    Added a message that appears when opening a file in a writable
	    component for a stream client with the StreamAtChange field set.
	    The message indicates that due to the StreamAtChange field being
	    set, the file cannot be submitted.

	#2372146 (Job #113364) **
	    SQLite3 for Extensions has been updated to version 3.40.0.

	#2369295 (Job #111274, #108480) **
	    'p4 topology' now displays the IP address that the server listens
	    on instead of the end user client IP address for the intermediary
	    servers.

	#2368325 (Job #112654) **
	    Long lock wait timing is now recorded correctly at monitor level 5+.

	#2367095 (Job #110980) **
	    Under rare circumstances, 'p4 istat -ac //taskName' might give
	    incorrect integToParent results if the workspace was not associated
	    with the task stream.  This has been fixed.

	#2363670 (Job #113021) **
	    Ensured that when a client of an edge server submits changes to the
	    Paths, Remapped, or Ignored fields of a stream spec, the client view
	    is updated to reflect those changes.

	#2363352 (Job #91936) **
	    'p4 integrate' will now limit the total number of integration
	    actions and branched files that it will scan in search of an ideal
	    merge base.  These limits are set to 100k and 100 respectively, and
	    can be modified via the (undoc) 'dm.integ.maxact' and
	    'dm.integ.maxbranch' configurables.  If one of the limits is
	    exceeded, the integration will not fail; the base will be chosen
	    based on the data that was gathered before the limit.

	#2362994 (Job #106523, #106524) **
	    'p4 unzip -n' will now scan the entire archive for possible missing
	    archive errors.

	#2362883 (Job #112710) **
	    When 'p4 clean' updated a file on a workspace to match the depot,
	    the 'syncTime' field of the have record was not updated. This
	    would cause performance issues with 'p4 clean -m' since it
	    could not detect when MD5 calculations were not needed.
	    This has been fixed.

	#2362779 (Job #110998) **
	    This change improves performance for p4api when processing specs 
	    with large changelists. The performance improvement is also
	    noticeable in 'p4 -ztag describe <changenumber>' and 'p4 changes'
	    with option "--field Files+=<additional-filename>" when there is
	    already a large changelist.

	#2359840 (Job #111928) **
	    When 'p4 unlock' is run on an edge server, requests sent to the
	    commit server are now batched when unlocking globally locked files.

	#2358404 (Job #112807) **
	    When failover through failback is repeated using the same servers
	    on Windows, the second 'p4 failback' command may fail with the
	    error 'journal exists and unexpectedly not empty'. This has been
	    fixed.

	#2357792 (Job #112233) **
	    If a user tried to start a former master after failover or failback
	    before running 'p4d -Fm', 'p4d -Fs', or changing the server.id,
	    they were advised to change the server.id. The error now does
	    not tell the user to change server.id when failback has occurred,
	    or when failback may be run from that P4ROOT.

	#2357682 (Job #106649) **
	    The Extension API call GetAutoClientApi() no longer creates an
	    invalid ticket when there is a server hostname lookup mismatch.

	#2354911 (Job #112681) **
	    Not performing a journal rotation after a failover through failback
	    cycle before repeating failover through failback with the same
	    servers could cause the second failback to fail. This has been
	    fixed.

	#2352097 (Job #101073) **
	    Performance is improved for 'p4 change -o' of shelved restricted
	    changes when the user has no access to the paths in the
	    restricted change.

	#2352094 (Job #112370) **
	    'p4 sync' for LFS files in graph depot on a replica could fail by
	    just generating LFS file attributes as file contents. This change
	    fixes the problem.

	#2351916 (Job #110507) **
	    'p4 zip -c' without file arguments no longer causes a server
	    crash.

	#2351732 (Job #96964, #106560) **
	    Some integrations involving a target task stream resulted in a
	    baseless merge when the base did exist as a file that was indirectly
	    related. This has been fixed.

	#2350523 (Job #112234) **
	    When 'failbackconfigs' is missing when running 'p4d -Fs',
	    the error would report that 'failoverconfigs' is missing.
	    This has been fixed.

	#2344992 (Job #112360) **
	    Revoking list access will now revoke stream spec access.

	#2342205 (Job #093477) **
	    'p4 unshelve' no longer excessively scans db.workingx when used in
	    conjunction with a file argument.

	#2341866 (Job #112274) **
	    Client-supplied command identifiers are properly escaped in the log.

--------------------------------------------------------------------------

Major new functionality in 2022.2 (2022.2/2369846) (2022/11/16)

	#2323550 (Jobs #111683, #111684, #111685) **
	    Added Writable Components feature, with new stream component types
	    writeimport+ and writeall.  If a stream component is defined as
	    writeimport+ in a stream consumer, then the stream consumer clients
	    can open for edit and submit changes to any files in import+ paths
	    in the stream component.  If a stream component is defined as
	    writeall, then the stream consumer clients can open for edit and
	    submit changes to files in share, isolate, or import+ paths in the
	    stream component.

	#2302144 (Jobs #41853, #109932, #110537, #110737) **
	    Added parallel checkpointing, dumping and recovery.
	    The 'p' suboption to -jc, -jd and -jr allows the use of
	    concurrent threads writing/reading to multiple checkpoint
	    files, one per database table. For example:
	        $ p4d -r . -N 4 -jcp cp
	        Checkpointing files to cp.ckp.9154...
	        $ p4d -r . -N 4 -jrp cp.ckp.9154
	        Recovering from cp.ckp.9154...
	    The checkpoint files are placed into a newly created directory
	    based on the checkpoint/dump prefix. The number of threads to use
	    is controlled by the 'db.checkpoint.threads' configurable.
	    This can be overridden on the command line for checkpoint and
	    recovery with the '-N threads' option.

	    Changes to 'db.checkpoint.threads' will apply to the next checkpoint
	    or journal dump; no server restart is required.

Minor new functionality in 2022.2 (2022.2/2369846) (2022/11/16)

	#2382272 (Job #109101) **
	    BTree consolidation and repair merges pages where possible
	    and can recover lost internal node space.
	    Run 'p4d -xrc' on a single table or all tables.
	    Set 'db.internal.repair' configurable to 1 to have runtime
	    processes do space recovery, including internal node space
	    if it avoids pages splits.

	#2360521 (Jobs #100355, #113009) **
	    When you log in with a license that will soon expire, a warning now
	    appears about the need to update the license to avoid downtime. This
	    change introduces two new configurables:
	    1) 'auth.licenseexpiry.warn', which enables the license expiry
	       warning:
	       0: no license expiry warning
	       1: Warn only users with permission level 'admin' or higher, when
	          they log in (default)
	       2: Warn all users when they log in
	    2) 'auth.licenseexpiry.warnthreshold', is the number of days prior
	       to license expiry when the warnings start to appear. The default
	       is 7 days.

	    Changes to either 'auth.licenseexpiry.warn' or
	    'auth.licenseexpiry.warnthreshold' will apply to all new logins; no
	    server restart required.

	#2342301 (Job #109600) **
	    'p4 topology' now reports:
	    - the context of capturing the topology server records
	    - the address, destination address and the server-id of the
	      respective target server.
	    The prior '-d' flag has been replaced by the '-D' flag, which
	    permanently removes topology server records.
	    The '-d' flag's new behavior is to mark a server in the topology
	    as deleted whilst leaving the history intact. For more details,
	    please see 'p4 help topology'.

	#2331726 (Job #109101) **
	    BTree consolidation and repair merges pages where possible
	    and can recover lost internal node space.
	    Run 'p4d -xrc' on a single table or all tables.
	    Set 'db.internal.repair' configurable to 1 to have runtime
	    processes do space recovery, including internal node space
	    if it avoids pages splits.

	#2330294 (Job #111573) **
	    Server log files now include an estimate of the memory used
	    by the server to process a command.  Tracking output in the
	    P4LOG log file now includes output like
	    '--- memory cmd/proc 6mb/10mb' that represents megabytes of
	    committed, touched memory used by a command.  The 'cmd' portion
	    is what the particular command being logged used, and the 'proc'
	    portion is what the peak usage for the process/thread is - this
	    comes into play when multiple commands are run on the same
	    connection.

	    Version 55 of the 'CommandEnd' event (1.55) in the structured logs
	    have two new fields that represent the same data.

	    The 'serverlog.version.N' configurable can be used to pin a
	    structured log file to a specific server version's format.
	    To retain the prior structured log events format, set the
	    'serverlog.version.N' configurable to 54.

	#2328306 (Job #111568) **
	    The track output in server log files now include network stats for
	    upstream server-to-server communication as well as with the client
	    or downstream server. These stats are recorded as additional 'rpc'
	    lines with the target server's P4PORT in parentheses in the P4LOG
	    file and as additional 'NetworkPerformance' events in the structured
	    logs at version 55 (8.55), where the 'f_trackType' field has the
	    P4PORT appended to the 'rpc' string after a '-'.  Note that the
	    himark is not used on client connections (including connections
	    from servers to upstream servers), and so will remain at the default
	    value of 2000.

	    The 'serverlog.version.N' configurable can be used to pin a
	    structured log file to a specific server version's format.
	    To retain the prior structured log events format, set the
	    'serverlog.version.N' configurable to 54.

	#2330292 (Job #111584) **
	    Server triggers have a new 'serverprocesspid' variable provided to
	    them that is the PID of the entire server process on both Windows
	    and Unix platforms.  This compliments the existing 'serverpid'
	    variable which is the thread ID that's handling a command on
	    Windows, and the PID on Unixes.

	#2328638 (Job #110937) **
	    Two new options has been added for 'p4 changes':
	    --stream, is for filtering result to changes that contain a stream.
	    --nostream, is for filtering result to changes that do not contain
	    a stream.

	#2328154 (Job #59960) **
	    Group specifications can now specify a memory limit (MaxMemory) for
	    commands run by group members.  See 'p4 help maxmemory' for details.
	    The limit is applied each time a single command is run, and does
	    not affect groups of commands as a whole.  Note that the memory
	    limit is best-effort and that commands may exceed the limit for a
	    time between checks.  P4API programs that run multiple commands
	    on a single connection will be disconnected from the server when
	    the memory limit is hit.  Note that the memory limit is more
	    accurate at larger values than smaller ones (as in single or double
	    digit) due to differences in when/where memory is sampled.

	#2328077 (Job #83788) **
	    The new 'p4 renameclient' command renames a client to a new client
	    name by modifying database records pertaining to the old client.
	    This command creates the new client, changes database records for
	    existing work in progress to use the new client name, and then
	    deletes the old client from the domain table. The entities that are
	    modified include pending and shelved changes owned by the old
	    client, fixes to pending changes by the old client, files opened by
	    the client, and the client's have list. The 'run.renameclient.allow'
	    configurable can be used to restrict users that can run the
	    'p4 renameclient' command.

	#2325440 (Job #110831) **
	    Added new '--use-stream-change=N' option for 'p4 sync' for syncing
	    stream clients to use the stream spec view at or before change N.
	    If no change N is specified, then the maximum change specifier in
	    the file list is used.  For N=0 or N=head, the current stream spec
	    view is used.

	    Also added configurable 'dm.sync.streamchange', which takes values
	    0 (default) or 1.  When set to 1, 'p4 sync' will implicitly use 
	    '--use-stream-change=N', where N is the maximum change specifier
	    used in the file list;  if no change specifier is used then the
	    current stream spec view is used.

	    If the StreamAtChange field is set in the client specification,
	    then that value overrides any value given for '--use-stream-change'.

	    Changes to 'dm.sync.streamchange' will apply to all new commands;
	    no server restart required.

	#2323074 (Job #21537) **
	    On Windows Server 2016 and newer, journal rotation can be performed
	    using an atomic rename.  Previous journal rotation was performed
	    as a copy and truncate operation.  The atomic rename journal
	    rotation offers a significant performance gain only on NTFS
	    filesystems.  By default the 'filesys.atomic.rename' configurable
	    is set to 0 (disabled).

	    Changes to 'filesys.atomic.rename' will not apply until the server
	    has been restarted.

	#2315124 (Job #111351) **
	    Structured logging improvements.
	    This release adds a new command group identifier which clients
	    can use to tie multiple events to a single action for improved
	    traceability. The command group identifier has been added to all
	    structured log event types that contain command fields,
	    positioned at column 14 (after the command arguments field),
	    increasing the version number of those events to 55 (e.g. 2.55).

	    The 'serverlog.version.N' configurable can be used to pin a
	    structured log file to a specific server version's format.
	    To retain the prior structured log events format, set the
	    'serverlog.version.N' configurable to 54.

	#2306230 (Job #103797) **
	    The -jr recovery command to p4d now accepts the '-S' option.
	    Using this option ignores all storage records in the replay
	    file and instead recalculates the net storage reference count
	    change from the rev records. It applies the recalculated
	    reference count at the end of the replay or end of each
	    transaction. The '-S' option cannot be combined with the '-m'
	    option.
	    This option has a performance impact on journal replay and is
	    intended for use under the guidance of Perforce Support.

	#2306041 (Job #106424) **
	    The new '--streamviews' option has been added to the p4 fstat,
	    p4 files, and p4 dirs commands to report files and directories from
	    stream Paths and Components. Also known as stream materialization.

	#2300668 (Job #104865) **
	    The command identifier (see #1881458) is now exposed to triggers
	    via the new 'commandIdent' variable.

	#2280769 (Job #105490) **
	    For 'p4 sync' with a changelist argument, the new -E option causes
	    the command to fail with a message if the changelist is not a
	    committed change. If a command is run with multiple file arguments,
	    a message line indicates any invalid change in an argument.
	    When the command is run as 'p4 sync -E <filepath>@now' on a replica,
	    the replica waits for any changes that are in transit to be
	    replicated before the sync begins.

	#2261234 (Job #108124) **
	    New 'failed-back' trigger and extension types have been added.
	    Either or both may be fired when a standby server becomes the
	    new master and first starts up during a successful
	    'p4 failback' command.

	#2255753 (Job #109524) **
	    'p4 storage' now reports whether an archive is shelved or committed.

Bugs fixed in 2022.2 Patch 5 (2022.2/2693782) (2024/12/10)

	#2692632 (Job #122076) *
	    The command-line client on Windows now prints an error when it
	    detects ambiguous argument encoding.

	#2687911 (Job #114420) **
	    'p4 renameuser' no longer takes long write locks on db.monitor.

	#2686782 (Job #119735) **
	    On Windows, network share access permissions for RCS depot archives
	    can cause a crash.  This has been resolved.

	#2686774 (Job #122784) **
	    Corrected crash when authentication fails during istat operation.

	#2684592 (Job #122569) * **
	    cURL has been upgraded 8.10.1

	#2683554 (Job #117647) **
	    A crash in 'p4 transmit -r' has been corrected.

	#2680587 (Job #121121) **
	    Corrected an unexpected 'Files are missing as a result of one or
	    more move operations' error in the fetch, push, and zip commands.

	#2678663 (Job #123034) **
	    Setting a trigger command to an empty string will now result in an
	    error on execution rather than allow the undefined behavior.

	#2676562 (Job #123250) **
	    Security fix. Addressed CVE-2024-10314, CVE-2024-10344 and
	    CVE-2024-10345

	#2670658 (Job #123015) **
	    Fixed locking order bug when obliterating a stream and the
	    configurable index.domain.owner is 1.

	#2670355 (Job #120977) **
	    Fixed a problem where a user with openstreamspec permission could
	    open a stream spec but not edit the stream spec. Also fixed a
	    problem where a user with writestreamspec permission could not edit
	    and save a new stream spec.

	#2666580 (Job #123094) * ** *** ****
	    OpenSSL has been upgraded to 3.0.15

	#2659725 (Job #113058) **
	    Fixed stream spec obliterate problem where a super or admin user
	    could not obliterate the stream spec if configurable
	    dm.protects.streamspec was set to 1.

Bugs fixed in 2022.2 Patch 4 (2022.2/2637361) (2024/08/09)

	#2633516 (Job #121790) **
	    If a virus scanner locks a portion of an RCS temp file during
	    a pull operation, a crash may occur.  This has been corrected.

	#2630647 (Job #120764) **
	    Removed unnecessary error "Error object passsed to database already
	    with an error" when attempting to switch a stream workspace with
	    unresolved issues. 

	#2629260 (Job #119795)
	    For p4 fetch', if '-I' flag is used the command could fail
	    unexpectedly with a 'Cannot import' error. This change fixes
	    the problem.

	#2610983 (Job #121091) **
	    Fixed reversion of an open stream spec when using the command
	   'p4 revert -a -Si filelist...'.

	#2609848 (Job #120791) **
	    Fixed stream obliterate endless loop problem.

	#2609806 (Job #87618) **
	    Ignored branch records resulting from a cherry-pick now only
	    grant credit for the cherry-picked revisions, rather than
	    implicitly including all prior revisions as is the case for a
	    normal branch record.  This fixes a problem in which an ignored
	    branch of a file that was copied from an old revision did not
	    grant any credit at all on subsequent integrations.

	#2609372 (Job #121079) **
	    Fixed reversion of an open stream spec when using the command
	   'p4 revert -n -Si filelist...'.

	#2609129 (Job #120840) **
	    If a Helix Core Server is configured with no logging, a crash may
	    occur. This has been corrected.

	#2602112 (Job #102151) **
	    This change improves 'p4 sync' performance with complex views by
	    increasing the lookback limit from the previous value of 8 to a
	    value set by the new configurable maxLookBack with a default value
	    of 1000.

	#2585216 (Job #119810) **
	    The error message "db.group locked after db.stream" no longer
	    appears when submitting a stream spec on an edge server and
	    then issuing a stream command. Previously, this error could
	    occur in P4V or any client that uses a shared connection.

	#2573911 (Job #119453) **
	    Fixed "db.streamview locked after db.domain" error when submitting
	    an opened stream spec.

	#2573498 (Job #112901) **
	    If a file was added with the same name as a file which had
	    previously been moved, then a 'p4 verify' might erroneously
	    report the readded file was missing.  This has been fixed.

	#2568943 (Jobs #118375, #112333) **
	    On Windows the atomic rename api is limited in scope by the OS.
	    With this change the atomic rename is first attempted, if the
	    atomic rename fails the operation falls back to a copy truncate.

	#2563512 (Job #119336) **
	    OpenLDAP has been upgraded 2.4.17

	#2546174 (Job #118002) **
	    'p4 obliterate' can no longer write archive delete journal notes
	    when a journal rotation is in progress.

Bugs fixed in 2022.2 Patch 3 (2022.2/2531894) (2023/12/11)

	#2530935 (Job #118342) **
	    Fixed segmentation violation with real-time monitoring enabled.

	#2527034 (Job #112432) **
	    'p4 fetch' and 'p4 push' commands now update LastFetch/LastPush
	    when user provided filespec argument does not limit remote view.

        #2523176 (Job #110437) * ** *** ****
            The network autotune algorithm has been corrected to address the rare
            cases where large numbers of files being submitted to a Linux server
            from a Windows client could stall or hang if autotune was enabled
            (net.autotune=1).

	#2521554 (Job #114849) **
	    The fix for job #84375 inadvertently caused issues for the
	    'SearchBindPasswd' field of the 'p4 ldap' specification, resulting 
	    in authentication failures when using that LDAP connection; this
	    has been fixed

	#2519170 (Job #117156) **
	    Security fix. Addressed CVE-2023-35767.

	#2519169 (Job #117155) **
	    Security fix. Addressed CVE-2023-45849.

	#2518890 (Job #90618, #117153) * ** *** ****
	    Security fix. Addressed CVE-2023-5759.

	#2518730 (Job #117154) **
	    Security fix. Addressed CVE-2023-45319.

	#2510694 (Job #117392) **
	    There was a data race between threads in the 'p4 storage -U' command.
	    This has been fixed.

	#2508491 (Job #116102) * ** *** ****
	    OpenSSL has been upgraded to 3.0.12

	#2506626 (Job #117741) * **
	    cURL (for extensions) has been upgraded 8.4.0 to address multiple
	    cURL CVEs: CVE-2023-38545 and CVE-2023-38546

	#2506262 (Job #116191) **
	    Fixed DVCS fetch, push and zip commands incorrectly reporting a
	    split move across changelists.

	#2497917 (Job #114933) **
	    When a lazy copy file is sent using 'p4 unzip', 'p4 push' or
	    'p4 fetch' and the source is not part of the package, it will be
	    imported as a non-lazy copy file.

	#2497043 (Job #113319) **
	    Using 'p4 unzip' with -I option to exclude integration records
	    no longer causes a crash when the source of a lazy copy is not
	    included in the zip.

	#2496086 (Job #116306) **
	    Multifile checkpoints and dumps could contain duplicate records.
	    This has been fixed.

	#2496084 (Job #112713) **
	    The parallel dump operation, 'p4d -jdp', now supports the
	    '-N threads' option to override the 'db.checkpoint.threads'
	    configurable.

	#2494347 (Job #117292) **
	    Parallel checkpoint and dump requests do not honor the
	    'db.checkpoint.bufsize' configurable. This has been fixed. Note,
	    with this fix, 'filesys.bufsize' in no longer used to determine
	    the checkpoint write size.

	#2493794 (Job #117270) **
	    Fixed a component stream validation error when reparenting a stream.

	#2489963 (Job #117222) **
	    Ensures that 'p4d -jr' command to replay the checkpoint in a
	    non empty directory does not update the existing database files.

	#2489807 (Job #106491) **
	    'p4 zip' now correctly includes archives for lazy copies when used
	    with a revision range.

	#2480068 (Job #117093) **
	    The orphan scanner, 'p4 storage -l', does not work with space in
	    the depotdirectory argument. This has been fixed.

	#2476244 (Job #114250) **
	    Concurrent 'p4 unlock' and 'p4 lock' commands can result a deadlock
	    and system hang. This change fixes the problem.

Bugs fixed in 2022.2 Patch 2 (2022.2/2468771) (2023/07/25)

	#2466052 (Job #116141, #116277) **
	    Fixed problems with upgrade when a stream's view could not be
	    generated.

	#2462372 (Job #116376) **
	    The precedence of overlapping ChangeView entries, including those
	    generated for streams with multiple "import @change" Paths, was
	    not honored correctly.  This has been fixed.

	#2458374 (Job #116101) * **
	    cURL (for extensions) has been upgraded 8.1.2 to address multiple
	    cURL CVEs: CVE-2023-28319 and CVE-2023-28322

	#2455674 (Job #114761) **
	    A 'p4 retype -l' request on a revision with a shelved
	    integration generates incorrect records in the db.storage
	    and db.storagesh tables. This has been fixed.

	#2452669 (Job #114820) **
	    'p4 reload -p' will now correctly report errors to the users
	    and if a journalwait is required, the correct journal offset
	    is now used.

	#2447644 (Job #115980) * ** *** ****
	    OpenSSL has been upgraded to 1.1.1u

	#2441682 (Job #115619) **
	    Fixed a 'p4 zip' bug where one half of a move/delete pair was
	    wrongly declared to be missing.

	#2441537 (Job #115676) **
	    The 'p4 failover' command could be run from a server that
	    has been prepared for the 'p4 failback' command by running
	    'p4d -Fm'. Now 'p4 failover' will fail in this situation with
	    an error message instructing the user to run 'p4 failback' instead.

	#2441108 (Job #115503) * **
	    cURL (for extensions) has been upgraded 8.0.1 to address multiple
	    cURL CVEs: CVE-2023-27537, CVE-2023-23916, CVE-2023-23915 and
	    CVE-2023-23914

	#2441105 (Job #115687) **
	    This ensures that the respective intermediary server log is not
	    spammed with the topology server warning related to skipping the
	    capture of the server records in the db.topology table in case of
	    any upstream server that is not upgraded to the version >= 2021.2.

	#2433554 (Job #115391) **
	    Fixed stream view generation at a specific change causing an 
	    endless loop during upgrade.

	#2432065 (Job #114515) **
	    Running 'p4 reopen' with multiple file arguments that include
	    moved files could cause a member of a moved pair to fail to be
	    reopened. This has been fixed.

	#2425796 (Job #113467) **
	    When a file was opened for 'add' with the exclusive open filetype
	    in a distributed environment and was submitted with the 'reopen'
	    option, the exclusive open type would not be set. This has been
	    fixed.

	#2420407 (Job #112599) **
	    An integration from a stream client might fail with an error
	    message "The target stream of a stream spec integration must
	    be the stream associated with the current client ...".  This
	    error should only occur when using a '-S' parameter with the
	    integration command, but did sometimes occur when not using
